unit util;

interface

uses Windows, Classes, SysUtils, Controls, ShellApi, FileCtrl,
     Registry;
Var
  timestart, timeend : TDateTime;
  QFreq1, QStart1, QEnd1 : int64;
  QFreq2, QStart2, QEnd2 : int64;
  QFreq3, QStart3, QEnd3 : int64;
  QDiff1, QDiff2, QDiff3 : extended;

function GetUserFriendlyTime(t:extended;millisecondcount:int64=0):string;

procedure TimerStart1;
procedure TimerPause1;
procedure TimerResume1;
function  TimerStop1:extended; // userfriendly time string
function TimerAsString1:string;
function TimerAsSeconds1:extended;

procedure TimerStart2;
procedure TimerPause2;
procedure TimerResume2;
function  TimerStop2:extended; // userfriendly time string
function TimerAsString2:string;
function TimerAsSeconds2:extended;

procedure TimerStart3;
procedure TimerPause3;
procedure TimerResume3;
function  TimerStop3:extended; // userfriendly time string
function TimerAsString3:string;
function TimerAsSeconds3:extended;

function ShellExecute_AndWait(Operation, FileName, Parameter, Directory: string; Show: Word; bWait: Boolean): Longint;

Function CountStr(Number, pos: int64): String;
Function FillStrWithZeros(Number, pos: int64): String;

function FileSizeByName(sFilename: string): Int64;

function GetDirLevel(filename:string; fssystem: string=''):integer;
function GetDirLevel2(filename:string; delimiter: String):integer;

function ExtractFileNameCutStream(const FileName: string): string;
function ExtractDirNoLastDir(filename:string; fssystem: string=''):string;
function ExtractFileExtNoPoint(const FileName: string): string;
function ExtractFileNameNoExt(filename:string):string;
function ExtractDirNameMaxPath(filename:string; maxpath: integer):string;
function ExtractFilenameWithoutIP(filename: string):string;
function ExtractDirOnly(filename:string):string;  // no drive letter

function DTtoFT(dt: TDateTime): TFiletime;
function SetDirDateTime(FileName: string;
         dtCreation, dtLastAccessTime, dtLastWriteTime: TFileTime): Boolean;
function MyFileSetDate(filename: string; Age: Integer): boolean;
function MyFileAgeFromData(FindData: TWin32FindData): Integer;
function MyFileAge(const FileName: string): Integer;

function ExistsFragment(var SelectFragment:String;fragmente:array of String):boolean;
function CheckFragment(Fragment:String;var aMessage:String):Boolean;

procedure ConvertStringList2PChar(const Value: TStringlist; var buff: PChar);
function  ConvertString2HexArray(s:string):string;

procedure ConvertPAnsiChar2StringList(const Value: PAnsiChar; Len: longint; var Stringlist:TStringlist);

function  ConvertHexArray2String(hexstr: string):string;
procedure ConvertHexArray2PChar(hexstr: string; var buffer: PChar; var buffsize: longint);

function InsertLineFeedsREG(pre,str:string): string;
function InsertLineFeedsINF(pre,str:string): string;

function IsNumber(s: string): boolean;
function IsDouble(s: string): boolean;
function IsAlpha(c:char):boolean;
function VarIsNull(const V: Variant): Boolean;
function VariantToInteger(aValue:Variant):Integer;
function VariantToFloat(aValue:Variant):Extended;
function VariantToDateTime(aValue:Variant):TDateTime;
function VariantToBoolean(aValue:Variant):Boolean;
function VariantToString(aValue:Variant):String;

function GetRandomValue(TagParams:TStrings;str:string='count';default:Integer=0):integer;
function CSVStr(Const st:String;C:Char):String;
function DBSTR(Const st:String):String;
function WeekOfDate(aDate:TDate;FirstDay:integer=1):integer;

function TrimHtml(Text:String):String;
function TrimURL(aURL:String):String;
function StringsToText(Tags:TStrings;Seperator:String=' '):String;
function ConvertUDF8Format(s:string): string;

function FilterLineFeeds(s: String): string;
function FilterURLChars(s:string; replacechar: char): string;
function MakeHtmlBody(Const s:WideString):WideString;
function MakeHtmlText(Const st:String):String;
function RebuiltBracesFromHTML(s:string):string;
function CorrectQoutesToDelphi(AnalyseString:String):string;

function ReplaceAllStringsInString(AnalyseString,replWhat, replWith:String; ignorecase:boolean=true):string;overload;
function ReplaceAllStringsInString(AnalyseString,replWhat, replWith:WideString; ignorecase:boolean=true):Widestring;overload;
function ReplaceCharInString(s: String; search_c: char; replace_c: char): string;overload;
function ReplaceCharInString(s: String; search_c: char; replace_s: string): string;overload;
function ReplaceIDInUrl(AnalyseString,preString,newstring:String):string;


function DeleteFromString(AnalyseString:String;preCount:Integer;Poststring:String):string;overload;
function DeleteFromString(AnalyseString,preString,Poststring:String):string;overload;

procedure DeleteFromStringList(name: string; var tmpQFs: TStrings);
procedure InsertTagsBefore(Tags:TStrings; var s: string; PostString: string);
procedure InsertStringBefore(InsertString: string; var s: string; PostString: string);

function ExtractIDFromString(AnalyseString:String;preCount:Integer;Poststring:String;var ID:Integer):Boolean;overload;
function ExtractIDFromString(AnalyseString,preString,Poststring:String;var ID:Integer):Boolean;overload;
function ExtractIDFromURL(AnalyseString,preString,Poststring:String;var ID:Integer):Boolean;overload;
function ExtractIDFromURL(AnalyseString,preString:String;var ID:Integer):Boolean;overload;

procedure ExtractStrings(aString,Divider:String;List:TStrings);
procedure ExtractStringsExactOrder(aString:String;DividerList:TStrings;List:TStrings);
procedure ExtractStringsPuzzledDividers(aString:String;DividerList:TStrings;List:TStrings);

function ExtractValueFromStrPre(AnalyseString,preString:string):string;
function ExtractValueFromString(AnalyseString,ValueName:String):string;
//function ExtractValueFromStrings(TagParam: TStrings; ValueName:String):string;
function ExtractValueFromURL(AnalyseString,preString:String):string;overload;
function ExtractValueFromURL(AnalyseString,preString, poststring:string):string;overload;


implementation

uses StrUtils, Math;

// function for creating strings from numbers
Function CountStr(Number, pos: int64): String;
var zw : String;
begin
  zw := IntToStr(Number);
  If Length(zw) > pos Then pos := Length(zw);
  while Length(zw) <> pos do zw := '0' + zw;
  result := zw;
End;

Function FillStrWithZeros(Number, pos: int64): String;
var zw : String;
begin
  zw := IntToStr(Number);
  If Length(zw) > pos Then pos := Length(zw);
  while Length(zw) <> pos do zw := zw + '0';
  result := zw;
End;

function GetUserFriendlyTime(t:extended;millisecondcount:int64=0):string;
const ticksperday    = 1000 * 60 * 60 * 24;
      ticksperhour   = 1000 * 60 * 60;
      ticksperminute = 1000 * 60;
      tickspersecond = 1000;
var days, hours, mins, secs: int64;
    sdays,shours,smins,ssecs,smsecs:string;
    timet,timet2:int64;
    timestr:string;
    faktor:extended;
begin
   timet := Trunc(t);
   timet2:=timet;
   days  := Trunc(timet / ticksperday   ); timet := timet - days  * ticksperday;
   hours := Trunc(timet / ticksperhour  ); timet := timet - hours * ticksperhour;
   mins  := Trunc(timet / ticksperminute); timet := timet - mins  * ticksperminute;
   secs  := Trunc(timet / tickspersecond); timet := timet - secs  * tickspersecond;
   sdays  :=countStr(days ,2);
   shours :=countStr(hours,2);
   smins  :=countStr(mins ,2);
   ssecs  :=countStr(secs ,2);
   if       (days>0) then
       timestr:=sdays+'d, '+shours+':'+smins+':'+ssecs
   else if (hours>0) then
       timestr:=shours+':'+smins+':'+ssecs
   else
       timestr:=smins+':'+ssecs;
   if millisecondcount>0 then 
   begin
       faktor:=power(10,millisecondcount);
       //smsecs := inttostr(trunc((t-timet)*faktor));
       smsecs := CountStr(trunc((t-timet)*faktor),millisecondcount);
       smsecs := copy(smsecs,1,millisecondcount);
       timestr := timestr+'.'+smsecs; //inttostr(trunc( (t-timet)*faktor));
   end;
   Result := timestr;
end;

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

function TimerAsString1:string; begin result:=GetUserFriendlyTime(QDiff1,4); end;
function TimerAsSeconds1:extended; begin result:=QDiff1; end;
procedure TimerStart1; begin QDiff1:=0.0; QueryPerformanceFrequency(QFreq1); QueryPerformanceCounter(QStart1);end;
procedure TimerPause1; begin QueryPerformanceCounter(QEnd1); QDiff1 := QDiff1 + (QEnd1 - QStart1) / QFreq1; end;
procedure TimerResume1; begin QueryPerformanceCounter(QStart1); end;
function TimerStop1:extended;
begin
   QueryPerformanceCounter(QEnd1);
   QDiff1 := QDiff1 + (QEnd1 - QStart1) / QFreq1;
   //result:=FloatToStrF(QDiff1, ffNumber, 15, 4) + ' sec.';
   //timeend := Time;
   //result:=FloatToStrF((timeend - timestart) * 100000, ffNumber, 15, 2) + ' sec.';
   result:=TimerAsSeconds1;
end;

function TimerAsString2:string; begin result:=GetUserFriendlyTime(QDiff2,4); end;
function TimerAsSeconds2:extended; begin result:=QDiff2; end;
procedure TimerStart2; begin QDiff2:=0.0; QueryPerformanceFrequency(QFreq2); QueryPerformanceCounter(QStart2);end;
procedure TimerPause2; begin QueryPerformanceCounter(QEnd2); QDiff2 := QDiff2 + (QEnd2 - QStart2) / QFreq2; end;
procedure TimerResume2; begin QueryPerformanceCounter(QStart2); end;
function TimerStop2:extended;
begin
   QueryPerformanceCounter(QEnd2);
   QDiff2 := QDiff2 + (QEnd2 - QStart2) / QFreq2;
   //result:=FloatToStrF(QDiff2, ffNumber, 15, 4) + ' sec.';
   //timeend := Time;
   //result:=FloatToStrF((timeend - timestart) * 100000, ffNumber, 15, 2) + ' sec.';
   result:=TimerAsSeconds2;
end;

function TimerAsString3:string; begin result:=GetUserFriendlyTime(QDiff3,4); end;
function TimerAsSeconds3:extended; begin result:=QDiff3; end;
procedure TimerStart3; begin QDiff3:=0.0; QueryPerformanceFrequency(QFreq3); QueryPerformanceCounter(QStart3);end;
procedure TimerPause3; begin QueryPerformanceCounter(QEnd3); QDiff3 := QDiff3 + (QEnd3 - QStart3) / QFreq3; end;
procedure TimerResume3; begin QueryPerformanceCounter(QStart3); end;
function TimerStop3:extended;
begin
   QueryPerformanceCounter(QEnd3);
   QDiff3 := QDiff3 + (QEnd3 - QStart3) / QFreq3;
   //result:=FloatToStrF(QDiff3, ffNumber, 15, 4) + ' sec.';
   //timeend := Time;
   //result:=FloatToStrF((timeend - timestart) * 100000, ffNumber, 15, 2) + ' sec.';
   result:=TimerAsSeconds3;
end;

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

function ShellExecute_AndWait(Operation, FileName, Parameter, Directory: string; Show: Word; bWait: Boolean): Longint;
var bOK: Boolean;
    Info: TSHELLEXECUTEINFO;
begin
  FillChar(Info, SizeOf(Info), Chr(0));
  Info.cbSize := SizeOf(Info);
  Info.fMask := SEE_MASK_NOCLOSEPROCESS;
  Info.lpVerb := PChar(Operation);
  Info.lpFile := PChar(FileName);
  Info.lpParameters := PChar(Parameter);
  Info.lpDirectory := PChar(Directory);
  Info.nShow := Show;
  bOK := ShellExecuteEx(@Info);
  if bOK then
  begin
    if bWait then
    begin
      while WaitForSingleObject(Info.hProcess, 100) = WAIT_TIMEOUT
      do 
        Sleep(100); //Application.ProcessMessages;
      bOK := GetExitCodeProcess(Info.hProcess, DWORD(Result));
      //info.
    end
    else
      Result := 0;
  end;
  if not bOK then Result := -1;
end;

function FileSizeByName(sFilename: string): Int64;
var sr   : TSearchRec;
begin
  result := 0;
  if FindFirst(sFilename, faAnyFile, sr) { *Converted from FindFirst*  }=0 then
      result := Int64(sr.FindData.nFileSizeHigh) * (INT64(MAXDWORD)+1) + Int64(sr.FindData.nFileSizeLow);
  FindClose(sr); { *Converted from FindClose*  }
  (*
  if FindFirstUTF8(sFilename, faAnyFile, sr) { *Converted from FindFirst*  }=0 then
      result := Int64(sr.FindData.nFileSizeHigh) * (INT64(MAXDWORD)+1) + Int64(sr.FindData.nFileSizeLow);
  FindCloseUTF8(sr); { *Converted from FindClose*  }
  *)
end;

function GetDirLevel(filename:string; fssystem: string=''):integer;
// default 'windows','unix','linux','url'
var l,p:integer;
    delimiter: char;
begin
    result:=0;
    l:=length(filename);
    fssystem:=lowercase(fssystem);
    if (fssystem='unix') or (fssystem='linux') or (fssystem='url') then
         delimiter:='/'
    else delimiter:='\';
    for p:=0 to l do
    begin
        if filename[p]=delimiter then
            Inc(result);
    end;
end;

function GetDirLevel2(filename:string; delimiter: String):integer;
var p1:integer;
begin
   result:=0;
   p1:=Pos(delimiter,filename);

   if p1>0 then
     repeat
       inc(result);
       p1:=PosEx(delimiter,filename,p1+1)
     until (p1=0);
end;

function  ExtractFileNameCutStream(const filename: string):string;
var p: integer;
begin
    result:=filename;
    p:=Pos('::$',filename);
    if p>2 then
    begin
        result:=Copy(filename,1,p-1);
    end;
end;


function ExtractDirNoLastDir(filename:string; fssystem: string=''):string;
var l:integer;
    delimiter: char;
begin
    result:='';
    fssystem:=lowercase(fssystem);
    if (fssystem='unix') or (fssystem='linux') or (fssystem='url') then
         delimiter:='/'
    else delimiter:='\';
    l:=length(filename);
    while (l>0) and (filename[l]<>delimiter) do
      Dec(l);
    result:=Copy(filename,1,l-1);
end;

function ExtractFileExtNoPoint(const FileName: string): string;
var I: Integer;
begin
  I := LastDelimiter('.' + PathDelim + DriveDelim, FileName);
  if (I > 0) and (FileName[I] = '.') then
    Result := Copy(FileName, I+1, MaxInt)
  else
    Result := '';
end;

function  ExtractFileNameNoExt(filename:string):string;
var l,p:integer;
begin
    result:=ExtractFileName(filename);
    l:=length(result);
    p:=l;
    while (p>1) and (result[p]<>'.') do Dec(p);
    if p>1 then
    result:=Copy(result,1,p-1);
end;

function  ExtractDirNameMaxPath(filename:string; maxpath: integer):string;
var l,p,maxp:integer;
begin
    result:=filename;
    l:=length(ExtractFileDir(filename));
    if l>3 then begin
      maxp:=0;
      for p:=0 to l do
      begin
        if result[p]='\' then Inc(maxp);
        if maxp>=maxPath then break;
      end;
      if p>1 then
      result:=Copy(result,p+1,512);
    end;
end;

function  ExtractFilenameWithoutIP(filename: string):string;
var p: integer;
begin
    result:=filename;
    p:=Pos(':\',filename);
    if p>2 then
    begin
        result:=Copy(filename,p-1,512);
    end;
end;

function ExtractDirOnly(filename:string):string; // no drive letter
begin
  result:=ExtractFilePath(filename);
  result:=Copy(result,4,length(result)-3);
end;

////////////////////////////////////////////////////////////////////////

function DTtoFT(dt: TDateTime): TFiletime;
var dwft: DWORD;
    ft: TFiletime;
begin
  dwft := DateTimeToFileDate(dt);
  DosDateTimeToFileTime(LongRec(dwft).Hi, LongRec(dwft).Lo, ft);
  LocalFileTimeToFileTime(ft, Result);
end;

function SetDirDateTime(FileName: string;
         dtCreation, dtLastAccessTime, dtLastWriteTime: TFileTime): Boolean;
var hDir: THandle;
    ftCreation: TFiletime;
    ftLastAccessTime: TFiletime;
    ftLastWriteTime: TFiletime;

begin
  hDir:=FileCreate(PChar(FileName)); { *Converted from CreateFile*  }
  if hDir<>INVALID_HANDLE_VALUE then
  begin
    try
      ftCreation       := dtCreation;
      ftLastAccessTime := dtLastAccessTime;
      ftLastWriteTime  := dtLastWriteTime;
      Result := SetFileTime(hDir, @ftCreation, @ftLastAccessTime, @ftLastWriteTime);
    finally
      FileClose(hDir); { *Converted from CloseHandle*  }
    end;
  end
  else
    Result := False;
end;

function MyFileSetDate(filename: string; Age: Integer): boolean;
var LocalFileTime, FileTime: TFileTime;
    f: THandle;
begin
  Result := false;
  SetLastError(0);
  if DosDateTimeToFileTime(LongRec(Age).Hi, LongRec(Age).Lo, LocalFileTime) and
     LocalFileTimeToFileTime(LocalFileTime, FileTime) then
  begin
    if filename[length(filename)]='\' then
    begin
      SetDirDateTime(Copy(filename,1,length(filename)-1),
                     FileTime,FileTime,FileTime);
      //FileTimeToLocalFileTime(FileTime,)
    end else begin
      f := FileOpen(FileName, fmOpenWrite);
      if f = THandle(-1) then
      else
      begin
        Result := SetFileTime(f, nil, nil, @FileTime);
        FileClose(f);
      end;
    end;
  end else
    //SysErrMsg(GetLasterror,'SetDate('+filename+'): ')
    Result := GetLastError=0;
end;

function MyFileAgeFromData(FindData: TWin32FindData): Integer;
var LocalFileTime: TFileTime;
begin
  Result := -1;
  FileTimeToLocalFileTime(FindData.ftLastWriteTime, LocalFileTime);
  FileTimeToDosDateTime(LocalFileTime, LongRec(Result).Hi, LongRec(Result).Lo);
end;

function MyFileAge(const FileName: string): Integer;
var Handle: THandle;
    FindData: TWin32FindData;
begin
  Result := -1;
  Handle := FindFirstFile(PChar(FileName), FindData);
  if Handle <> INVALID_HANDLE_VALUE then
    result:=MyFileAgeFromData(FindData);
  //Windows.FindCloseUTF8(Handle); { *Converted from FindClose*  }
  Windows.FindClose(Handle); { *Converted from FindClose*  }
end;

function ExistsFragment(var SelectFragment:String;fragmente:array of String):boolean;
var i:integer;
begin
  for i:=0 to high(fragmente) do
    if FileExists(fragmente[i]) { *Converted from FileExists*  } then
    begin
      Result:=true;
      SelectFragment:=fragmente[i];
      exit;
    end;
  Result:=false;
  SelectFragment:='';
end;

function CheckFragment(Fragment:String;var aMessage:String):Boolean;
begin
  Result:=FileExists(Fragment); { *Converted from FileExists*  }
  if not result then
    aMessage:='Fragment "'+Fragment+'" nicht gefunden!';
end;

procedure ConvertStringList2PChar(const Value: TStringlist; var buff: PChar);
var
  P, PStart : PChar;
  iL, i,j   : Integer;
begin
    PStart:=buff;
    P:=PStart;

    // build PChar
    for i:=0 to Value.Count-1 do begin
        iL:=Length(Value.Strings[i]);
        for j:=1 to iL do begin
            P^:=Char( Value.Strings[i][j] );
            Inc(P);
        end;
        P^ := #0;
        Inc(P);
    end;
    P^ :=  #0;
    Inc(P);
    P := nil;
    buff:=PStart;
end;

function ConvertString2HexArray(s:string):string;
var x, i, o, l, last: longint;
begin
    result:='';
    l:=Length(s);
    i:=1;
    x:=0;
    last:=32;
    while i<=l do
    begin
      o:=Ord(s[i]);
      if (last=13) and (o=10) then
      begin
        delete(result,x*3-3,3);
        result:=result+'00,';
        //Inc(i,1);
      end else begin
        result:=result+IntToHex(o,2)+',';
        Inc(x);
      end;
      last:=o;
      Inc(i);
    end;
    result:=Lowercase(result)+'00';
end;

procedure ConvertPAnsiChar2StringList(const Value: PAnsiChar; Len: longint; var Stringlist:TStringlist);
var
  P, Start : PChar;
  S        : string;
  l,iLen     : longint;
begin
  Stringlist.Clear;
  iLen:=0;
  P := Pointer(Value);
  if P <> nil then
  while (P^ <> #0) and (iLen<Len) do
  begin
    Start := P;
    while not (P^ in [#0, #10, #13]) do
    begin
      Inc(P);
      Inc(iLen);
    end;

    //iLen:=iLen+1;
    SetString(S, Start, P - Start);
    Stringlist.Add(S);

    if (P^ = #13) or (P^ = #10) or (P^ =  #0) then
    begin
      Inc(P);
      Inc(iLen);
    end;
  end;
  l:=Length(Stringlist.Text);
//if Length(result.Text)<=Len then
//  result.Add('');
//result.Add('');
end;

function ConvertHexArray2String(hexstr: string):string;
var hexvals: TStringList;
    carr: array of Char;
    i: integer;
    o: integer;
    c: char;
begin
    hexvals:=Tstringlist.Create;
    hexvals.CommaText:=hexstr;

    SetLength(carr,hexvals.Count);
    for i:=0 to hexvals.Count-1 do begin
      o:=StrToInt('$'+hexvals[i]);
      c:=Chr(o);
      carr[i]:=c;
    end;
    result:=StrPas(PAnsiChar(carr));
    //result:=StrPas(@carr[0]);
    hexvals.free;
end;

procedure ConvertHexArray2PChar(hexstr: string; var buffer: PChar; var buffsize: longint);
var hexvals: TStringList;
    i: longint;
    //localbuff:string;
begin
    hexvals:=Tstringlist.Create;
    hexvals.CommaText:=hexstr;
    buffsize:=hexvals.Count;
    //setlength(buffer,buffsize);
    for i:=0 to hexvals.Count-1 do
      if hexvals[i]<>'' then
        buffer[i]:=Chr(StrToIntDef('$'+hexvals[i],0));
    buffer[buffsize]:=#0;
    //getmem(buffer,buffsize);
    //StrPCopy(buffer,localbuff);
    hexvals.free;
end;

// version for REG-files
function InsertLineFeedsREG(pre,str:string): string;
const linewidth = 77;
var c,i,l,lc:longint;
    last:char;
    quotes1:boolean;
begin
  result:='';
  lc:=length(pre);
  c:=0;
  l:=length(str);
  i:=1;
  quotes1:=false;
  last:=#32;
  while i<=l do
  begin
    if str[i]='"' then
      if quotes1 then begin
        quotes1:=false;
      end else begin
        quotes1:=true;
      end;
    if (last=#13) and (str[i]=#10) and (i+1<l) and (c>0) then
    begin
      result[c-1]:=' ';
      Inc(i);
    end;
    //if not (str[i] in [#0,#10,#13]) then
    begin
      result:=result+str[i];
      Inc(c);
      Inc(lc);
      if (not quotes1) and (lc>=linewidth) and
         ((str[i]=',') or (str[i]=' ')) then
      begin
        result := result + '\' + Chr(13) + Chr(10) + '  ';
        lc:=2;
      end;
    end;
    last:=str[i];
    Inc(i);
  end;
  result:=pre+Trim(result);
end;

// version for INF-files
function InsertLineFeedsINF(pre,str:string): string;
const maxlinewidth = 77;
      maxlonglinewidth = 128;
var c,i,l,lpre:longint;
    last:char;
    commacount:integer;
    quotes1:boolean;
begin
  lpre:=length(pre);
  l:=length(str);
  if (pos('0x3,',pre+str)<>1) or (lpre+l<maxlonglinewidth) then begin
    result:=str;
    exit;
  end else begin
    result:='';
  end;
  c:=0;
  i:=1;
  commacount:=0;
  quotes1:=false;
  last:=#32;
  while i<=l do
  begin
    if str[i]='"' then
      if quotes1 then quotes1:=false else quotes1:=true;

    if (last=#13) and (str[i]=#10) and (i+1<l) and (c>0) then
    begin
      result[c-1]:=' ';
      Inc(i);
    end;


    //if not (str[i] in [#0,#10,#13]) then
    begin
      result:=result+str[i];
      Inc(c);
      Inc(lpre);
      if not quotes1 and (str[i]=',') then inc(commacount);
      if (not quotes1) and                 // not inside quotes
         (commacount>5) and              // pre longer than maxlinewidth
         (
           ((lpre>=maxlinewidth)) and          // only wrap the value not its path/name
            (l-i>25)
         ) and
         ((str[i]=',') or (str[i]=' ')) then
      begin
        result := result + '\' + Chr(13) + Chr(10) + '  ';
        lpre:=2; // after new line begin counting after the first two spaces
      end;
    end;
    last:=str[i];
    Inc(i);
  end;
  result:=pre+Trim(result);
end;

//------------------------------------------------------------------------------

function IsNumber(s: string): boolean;
const NumericChars: set of char = ['0'..'9', '-'];
var i: integer;
begin
  result:=true;
  for i:=1 to Length(s) do
    if not (s[i] in NumericChars) or ((i=1) and (s[i]='0')) then
    begin
      result:=false;
      exit;
    end;
end;

function IsDouble(s: string): boolean;
const DoubleChars: set of char = ['0'..'9', '-', '.'];
var i: integer;
begin
  result:=true;
  for i:=1 to Length(s) do
    if not (s[i] in DoubleChars) then
    begin
      result:=false;
      exit;
    end;
end;

function IsAlpha(c:char):boolean;
var i:integer;
begin
  result:=false;
  i:=Ord(c);
  if ((i>64) and (i<92)) or
     ((i>95) and (i<124)) then
     result:=true
end;

function VarIsNull(const V: Variant): Boolean;
begin
  Result := TVarData(V).VType = varNull;
end;

function VariantToInteger(aValue:Variant):Integer;
begin
  try
    if VarIsNull(aValue) then result:=0
                         else result:=aValue;
  except
    Result:=0;
  end;
end;

function VariantToFloat(aValue:Variant):Extended;
begin
  try
    if VarIsNull(aValue) then result:=0
                         else result:=aValue;
  except
    Result:=0;
  end;
end;

function VariantToDateTime(aValue:Variant):TDateTime;
begin
  try
    if VarIsNull(aValue) then result:=0
                         else result:=aValue;
  except
    Result:=0;
  end;
end;


function VariantToBoolean(aValue:Variant):Boolean;
begin
  try
    if VarIsNull(aValue) then result:=false
                         else result:=aValue;
  except
    Result:=false;
  end;
end;

function VariantToString(aValue:Variant):String;
begin
  try
    if VarIsNull(aValue) then result:=''
                         else result:=aValue;
  except
    Result:='';
  end;
end;


function GetRandomValue(TagParams:TStrings;str:string='count';default:Integer=0):integer;
begin
  try
    result:=random(strtoint(Tagparams.Values[str]))+1;
  except
    result:=default;
  end;
end;

function CSVStr(Const st:String;C:Char):String;
var i:integer;
begin
  result:=st;
  i:=1;
  while i<=length(result) do
  begin
    if result[i]=C then
    begin
      insert(C,result,i);
      inc(i);
    end;
    inc(i);
  end;
end;

function DBSTR(Const st:String):String;
begin
  result:=CSVStr(st,'''');
end;

(*FirstDay: 0 Woche beginnt mit Sonntag
            1 Woche beginnt mit Montag*)
function WeekOfDate(aDate:TDate;FirstDay:integer=1):integer;
var WeekDay,move:integer;
    y,m,d:word;
    FirstDateOfYear:TDate;
begin
  DecodeDate(aDate,y,m,d);
  m:=1;d:=1;
  FirstDateOfYear:=EncodeDate(y,1,1);

  WeekDay:=DayofWeek(FirstDateOfYear);

  move:=Weekday-FirstDay-1;
  if Move<0 then Move:=Move+7;

  result:=1+(round(aDate-FirstDateOfYear)+move) div 7;
end;

function TrimHtml(Text:String):String;
var Strings:TStringlist;
    i:integer;
begin
  Result:='';
  Strings:=TStringlist.Create;
  try
    Strings.Text:=Text;
    for i:=0 to Strings.count-1 do
    begin
      Result:=Result+trimleft(Strings[i]);
    end;
  finally
    Strings.free;
  end;
end;

function TrimURL(aURL:String):String;
var List:TStrings;
    i:Integer;
begin
  Result:='';
  List:=TStringList.Create;
  try
    ExtractStrings(lowercase(aUrl),'/',List);

    //Letzten Eintrag ignorieren, da kein Pfad
    if (List.Count>0) and (List[List.Count-1]='') then
      List.Delete(List.Count-1);

    i:=1;
    while i<List.Count do
    begin
      if (List[i]='..') and (List[i-1]<>'..') then
      begin
        List.Delete(i);
        List.Delete(i-1);
      end
      else inc(i);
    end;

    for i:=0 to List.Count-1 do
      Result:=Result+List[i]+'/';
  finally
    List.free;
  end;
end;

function MakeHtmlText(Const st:String):String;
var i:integer;
begin
  result:=st;
  exit;
  i:=0;
  while i<length(result) do
  begin
    if (result[i] in [#10,#13]) then
    begin
      if i+1<length(Result) then
      begin
        if (result[i+1] in [#10,#13]) and (result[i]<>result[i+1]) then
          Delete(result,i+1,1);
      end;
      Delete(result,i,1);
      insert('<br>',result,i);
      inc(i,4);

      //Jetzt mssen noch fhrende leerzeichen und Tabulatoren umgewandelt werden
      while i<length(result) do
      begin
        case result[i] of
          ' ':begin
                delete(result,i,1);
                insert('&nbsp;',result,i);
                inc(i,6);
              end;
          '&':begin
                delete(result,i,1);
                insert('&amp;',result,i);
                inc(i,5);
              end;
          '<':begin
                delete(result,i,1);
                insert('&lt;',result,i);
                inc(i,4);
              end;
          '>':begin
                delete(result,i,1);
                insert('&gt;',result,i);
                inc(i,4);
              end;
          '"':begin
                delete(result,i,1);
                insert('&quot;',result,i);
                inc(i,6);
              end;
         '''':begin
                delete(result,i,1);
                insert('&apos;',result,i);
                inc(i,6);
              end;
        end;
      end;
    end
    else
      inc(i);
  end;
end;

function FilterURLChars(s:string; replacechar: char): string;
const urlchars: set of char =
[   'a'..'z','0'..'9'
    ,'+','-','_','/','.'//,'?',' ','&'
    //,'=',':'
    //,'?','&','%'
    //,'*','!',',',';','~','@','$','(',')','[',']'
    //,#13,#10,#9,#8
];
var i, l: integer;
    r: string;
begin
    r:='';
    result:=r;
    if s='' then exit;
    i:=1;
    s:=Trim(Lowercase(s));
    l:=Length(s);
    while i<=l do
    begin
        case s[i] of
        '','': begin r:=r+'ae'; end;
        '','': begin r:=r+'oe'; end;
        '','': begin r:=r+'ue'; end;
        ''    : begin r:=r+'ss'; end;
        else // case
          if s[i] in urlchars then
             r:=r+s[i]
          else begin
             if (r='') OR (r[length(r)]<>replacechar) then
               r:=r+replacechar;
          end;
        end; // case
        Inc(i);
    end;
    while (r[length(r)]=replacechar) do
      Delete(r, length(r), 1);
    result:=r;
end;

function ConvertUDF8Format(s:string): string;
var i, l, c1, c2: integer;
begin
    i:=1;
    s:=Trim(s);
    l:=Length(s);
    while i<=l do
    begin
        if Ord(s[i])>127 then
        begin
          c1:=Ord(s[i]);
          case c1 of
          194: if (i+1<=l) then begin
               if (Ord(s[i+1])=178) then  //blabla (hoch 2)
                 Delete(s,i,1);
               end;
          226: if (i+1<=l) and (i+2<=l) then begin
                 if (Ord(s[i+1])=130) and
                    (Ord(s[i+2])=172) then
                 begin
                   Delete(s,i,3);
                   Insert('', s, i);
                 end;
          end;
          195: if (i+1<=l) then begin
                 c2:=Ord(s[i+1]);
                 Delete(s,i,2);
                 case c2 of
                 132: Insert('',s, i);
                 164: Insert('',s, i);
                 156: Insert('',s, i);
                 188: Insert('',s, i);
                 150: Insert('',s, i);
                 182: Insert('',s, i);
                 159: Insert('',s, i);
                 end; //case
               end;
          end; // case
        end;
        Inc(i);
    end;
    result:=s;
end;

procedure ExtractStrings(aString,Divider:String;List:TStrings);
var p:integer;
begin
  List.Clear;
  while length(aString)>0 do
  begin
    p:=pos(Divider,aString);
    if p>0 then
    begin
      List.add(copy(aString,1,p-1));
      delete(aString,1,p+length(Divider)-1);
      if aString='' then
        List.add('');
    end else begin
      List.add(aString);
      aString:='';
    end;
  end;
end;

procedure ExtractStringsExactOrder(aString:String;DividerList:TStrings;List:TStrings);
var p:integer;
    i:integer;
begin
  List.Clear;
  i:=0;
  while length(aString)>0 do
  begin
    p:=pos(DividerList[i],aString);
    if p>0 then
    begin
      List.add(copy(aString,1,p-1));
      delete(aString,1,p+length(DividerList[i])-1);
    end else begin
      List.add(aString);
      aString:='';
    end;
    Inc(i);
  end;
end;

procedure ExtractStringsPuzzledDividers(aString:String;DividerList:TStrings;List:TStrings);
var p,pmin,plast:integer;
    i,imin:integer;
begin
  List.Clear;
  while Length(aString)>0 do
  begin
    imin:=-1;
    pmin:=Length(aString);
    for i:=0 to DividerList.Count-1 do 
    begin
      p:=Pos(DividerList[i],aString);
      if (pmin>p) and (p>0) then begin 
        pmin:=p;
        imin:=i;
      end;
    end;
    if (pmin>0) and (imin>=0) then
    begin
      List.add(copy(aString,1,pmin-1));
      Delete(aString,1,pmin+length(DividerList[imin])-1);
    end else begin
      List.Add(aString);
      aString:='';
    end;
  end;
end;

function ExtractValueFromStrPre(AnalyseString,preString:string):string;
const endchar: set of char = ['_','.','?','#','$','+','-','/','<','>'];
var p1,p2,p3:integer;
    l,l2:integer;
    s: string;
begin
    result:='';
    s:=AnalyseString;
    preString:=preString;
    l:=Length(AnalyseString);
    l2:=Length(prestring);

    if preString='' then
      p1:=0
    else
      p1:=pos(LowerCase(PreString),LowerCase(s));

    if p1=0 then exit;

    p2:=p1+l2;
    p3:=p2;
    while not (s[p3] in endchar) and (p3<=l) do begin
      Inc(p3);
    end;

    result:=copy(AnalyseString,p2,p3-p2);
end;

function ExtractValueFromString(AnalyseString,ValueName:String):string;
const ValueChars: set of char = ['A'..'Z','a'..'z','0'..'9','#','$','+','-','_','/'];
const Delimiter : set of char = ['"', '''','(','[','{',')',']','}','=',' '];
var p,x,y:integer;
    l, lValueName:integer;
begin
  result:='';
  l:=Length(AnalyseString);
  lValueName:=Length(ValueName);

  if l<lValueName then begin
    result:='';
    exit;
  end;

  p:=Pos(Lowercase(ValueName), Lowercase(AnalyseString));

  x:=p+lValueName;
  // finde anfang des value-wertes
  while AnalyseString[x] in Delimiter do Inc(x);

  y:=x;
  // finde ende des value wertes
  while AnalyseString[y] in ValueChars do Inc(y);

  result:=Copy(AnalyseString,x, y-x);
end;

function  DeleteFromString(AnalyseString:String;preCount:Integer;Poststring:String):string;overload;
var p2:integer;
begin
  result:='';
  try
    p2:=pos(Poststring,AnalyseString);
    if (p2>0) then
    begin
      Result:='';
      //ID:=strtoint(copy(AnalyseString,PreCount+1,p2-(PreCount+1)));
    end;
  except
  end;
end;

function  DeleteFromString(AnalyseString,preString,Poststring:String):string;overload;
var p1,p2:integer;
    lenPre:integer;
begin
  result:=AnalyseString;
  lenpre:=length(PreString);

  // get start-position of ID (start of PreString + lenPre)
  if preString='' then
    p1:=0
  else begin
    p1:=Pos(lowercase(PreString),lowercase(result));
  end;

  // get end-position of ID (start of PostString)
  if Poststring='' then
    p2:=lenpre+1
  else begin
    p2:=Pos(lowercase(PostString),lowercase(result));
  end;

  if ((p1<>0) or (PreString='')) and (p2>0) then
  begin
    Delete(result,p1,p2-p1);
  end;
  //result:=result;
end;

function ExtractIDFromString(AnalyseString:String;preCount:Integer;Poststring:String;var ID:Integer):Boolean;
var p2:integer;
begin
  result:=false;
  ID:=-1;
  try
    p2:=pos(Poststring,AnalyseString);
    if (p2>0) then
    begin
      Result:=true;
      ID:=strtoint(copy(AnalyseString,PreCount+1,p2-(PreCount+1)));
    end;
  except
  end;
end;

function ExtractIDFromString(AnalyseString,PreString,PostString:String;var ID:Integer):Boolean;
var p1,p2:integer;
    len,lenPre:integer;
    tmp: string;
begin
  result:=false;
  ID:=-1;
  len:=length(AnalyseString);
  lenpre:=length(PreString);

  // get start-position of ID (start of PreString + lenPre)
  if preString='' then
    p1:=0
  else begin
    p1:=Pos(lowercase(PreString),lowercase(AnalyseString));
    if p1>0 then
      p1:=p1+lenpre;
  end;

  // get end-position of ID (start of PostString)
  if Poststring='' then
    p2:=len+1
  else begin
    p2:=Pos(lowercase(PostString),lowercase(AnalyseString));
  end;

  if ((p1<>0) or (PreString='')) and (p2>0) then
  begin
    //p3:=length(preString)+1;
    tmp:=copy(AnalyseString,p1,p2-p1);
    ID:=strtointdef(tmp,-1);
    if ID>-1 then
        result:=TRUE;
  end;
end;

function ExtractIDFromURL(AnalyseString,preString,Poststring:String;var ID:Integer):Boolean;
var p1,p2:integer;
    l:integer;
begin
  result:=false;
  ID:=-1;
  try
    if preString='' then
      p1:=0
    else
      p1:=pos(lowercase(PreString) ,lowercase(AnalyseString));

    if Poststring='' then
      p2:=length(AnalyseString)+1
    else
      p2:=pos(Poststring,AnalyseString);

    l:=length(preString);
    ID:=strtointDef(copy(AnalyseString,p1+l,p2-(p1+l)), -1);
    if (ID>0) then
      Result:=true;
  except
  end;
end;

function ExtractIDFromURL(AnalyseString,preString:String;var ID:Integer):Boolean;
const numbers : set of char =['0'..'9'];
const endchars: set of char = ['_','.','?','#','$','+','-','/','<','>'];
var p1,p2:integer;
    l:integer;
    s: string;
begin
  result:=false;
  ID:=-1;
  if preString='' then
    p1:=0
  else
    p1:=pos(lowercase(PreString),lowercase(AnalyseString));

  if p1>0 then begin
    l:=length(preString);
    p2:=p1+l;
    while AnalyseString[p2] in numbers do Inc(p2);

    s:=copy(AnalyseString,p1+l,p2-(p1+l));
    ID:=strtointDef(s, -1);
  end;

  if (ID>=0) then
    Result:=true;
end;

function ExtractValueFromURL(AnalyseString,preString:string):string;
const endchar: set of char = ['_','.','?','#','$','+','-','/'];
var p1,p2,p3:integer;
    l,l2:integer;
    s: string;
begin
    result:='';
    s:=AnalyseString;
    l:=Length(AnalyseString);
    l2:=Length(prestring);

    if preString='' then
      p1:=0
    else
      p1:=pos(LowerCase(PreString),LowerCase(s));

    if p1=0 then exit;

    p2:=p1+l2;
    p3:=p2;
    while not (s[p3] in endchar) and (p3<=l) do begin
      Inc(p3);
    end;

    result:=copy(AnalyseString,p2,p3-p2);
end;

function  ExtractValueFromURL(AnalyseString,preString, poststring:string):string;
const endchar: set of char = ['_','.','?','#','$','+','-','/'];
var p1,p2:integer;
    l2:integer;
    s: string;
begin
    result:='';
    s:=AnalyseString;
    l2:=Length(prestring);

    // vorkommen von prestring testen
    if preString='' then
      p1:=0
    else
      p1:=pos(LowerCase(PreString),LowerCase(s));
    if p1=0 then exit;
    p1:=p1+l2;

    // vorkommen von poststring testen
    p2:=Pos(poststring,s);
    if p2=0 then exit;

    result:=copy(s,p1,p2-p1);
end;

procedure InsertStringBefore(InsertString: string; var s: string; PostString: string);
var p: integer;
begin
  p:=Pos(poststring, s);
  if p=0 then exit;
  Insert(InsertString, s, P);
end;

procedure InsertTagsBefore(Tags:TStrings; var s: string; PostString: string);
var i:integer;
begin
  for i:=0 to Tags.Count-1 do
  begin
    if trim(Tags[i])<>'' then
       InsertStringBefore(Tags.Names[i]+Tags.Values[Tags.Names[i]], s, PostString);
  end;
end;



function StringsToText(Tags:TStrings;Seperator:String=' '):String;
var i:integer;
begin
  Result:='';
  for i:=0 to Tags.Count-1 do
  begin
    if trim(Tags[i])<>'' then
    begin
      if Result<>'' then
        Result:=Result+Seperator;
      // neu binder Added Trim() like in the IF-statment
      Result:=Result+trim(Tags[i]);
    end;
  end;
end;

procedure DeleteFromStringList(name: string; var tmpQFs: TStrings);
var i: integer;
begin
    i:=tmpQFs.IndexOfName(name);
    if i>-1 then
        tmpQFs.Delete(i);
end;

function RebuiltBracesFromHTML(s:string):string;
begin
  result:=s;
  result:=ReplaceAllStringsInString(result, '&lt;', '<');
  result:=ReplaceAllStringsInString(result, '&gt;', '>');
end;

function CorrectQoutesToDelphi(AnalyseString:String):string;
var r: string;
    i:integer;
begin
    r:=AnalyseString;
    i:=2;
    while (i<Length(r)) do
    begin
        case r[i] of
        '''': begin Insert(#39, r, i); Inc(i); end;
        end; // case
        Inc(i);
    end;

    while (r[length(r)]='_') do
      Delete(r, length(r), 1);
    result:=r;
end;

function ReplaceAllStringsInString(AnalyseString,replWhat,replWith:String; ignorecase:boolean=true):string;
var p1:integer;
begin
   result:=AnalyseString;
   if replWhat=replWith then 
     exit;
   if ignorecase then
     p1:=Pos(Lowercase(replWhat),Lowercase(result))
   else
     p1:=Pos(replWhat,result);

   if p1>0 then
   begin
     repeat
       Delete(result, p1, Length(replWhat));
       Insert(replWith, result, p1);
       if ignorecase then
         p1:=PosEx(Lowercase(replWhat),Lowercase(result),p1+length(replWith))
       else
         p1:=PosEx(replWhat,result,p1+length(replWith));
     until (p1=0);
   end;
end;

function ReplaceAllStringsInString(AnalyseString,replWhat,replWith:wideString; ignorecase:boolean=true):widestring;
var p1:integer;
begin
   result:=AnalyseString;
   if replWhat=replWith then 
     exit;
   if ignorecase then
     p1:=Pos(Lowercase(replWhat),Lowercase(result))
   else
     p1:=Pos(replWhat,result);

   if p1>0 then
   begin
     repeat
       Delete(result, p1, Length(replWhat));
       Insert(replWith, result, p1);
       if ignorecase then
         p1:=PosEx(Lowercase(replWhat),Lowercase(result),p1+length(replWith))
       else
         p1:=PosEx(replWhat,result,p1+length(replWith));
     until (p1=0);
   end;
end;

function ReplaceCharInString(s: String; search_c: char; replace_c: char): string;
var i, l: integer;
    r: string;
begin
    i:=1;
    r:='';
    l:=Length(s);

    while i<=l do
    begin
        if s[i]=search_c then
            r:=r+replace_c
        else
            r:=r+s[i];
        Inc(i);
    end;
    result:=r;
end;

function ReplaceCharInString(s: String; search_c: char; replace_s: string): string;
var i, l: integer;
    r: string;
begin
    i:=1;
    r:='';
    l:=Length(s);

    while i<=l do
    begin
        if s[i]=search_c then
            r:=r+replace_s
        else
            r:=r+s[i];
        Inc(i);
    end;
    result:=r;
end;

function  ReplaceIDInUrl(AnalyseString,preString,newstring:String):string;
const numbers : set of char =['0'..'9'];
var p1,p2:integer;
    l:integer;
begin
  result:=AnalyseString;
  if AnalyseString='' then exit;
  if preString='' then
      p1:=0
  else
      p1:=pos(lowercase(PreString),lowercase(AnalyseString));

  l:=length(preString);
  p2:=p1+l;
  while AnalyseString[p2] in numbers do Inc(p2);

  Delete(result, p1, p2-(p1));
  Insert(newstring, result, p1);
end;

// entfernt tabulator, zeilenumbruch, wagenrcklauf, und '
function MakeHtmlBody(Const s:WideString):WideString;
var i,l:integer;
    r:widestring;
begin
    i:=1;
    r:='';
    l:=Length(s);

    while i<=l do
    begin
        if not (s[i]=#13) and not (s[i]=#10) and not (s[i]=#9) and not (s[i]='''') then
            r:=r+s[i];
        Inc(i);
    end;
    result:=Trim(r);
end;

function FilterLineFeeds(s: String): string;
var i, l: integer;
    r: string;
begin
    i:=1;
    r:='';
    l:=Length(s);
    while i<=l do
    begin
        if not (s[i]=#13) and not (s[i]=#10) then
            r:=r+s[i];
        Inc(i);
    end;
    result:=r;
end;

end.
