//  
//[600 pixels/decades]*log(freq_range)/(freq_range) pixels/Hz
//http://groups.google.de/group/comp.dsp/browse_thread/thread/a0d0fbb3883056e2/7b0010facddac166?hl=de&q=logarithmic+scale+group:comp.dsp.*+fred+marshall
//http://groups.google.de/group/comp.dsp/browse_thread/thread/69541e425cf88cbd/97864b207920d15a?hl=de&q=logarithmic+scale+group:comp.dsp.*+fred+marshall
//http://groups.google.de/group/comp.dsp/browse_thread/thread/3ed06e8e3ecc1892/bbfa60b06bf8af29?hl=de&q=logarithmic+scale+group:comp.dsp.*+fred+marshall
//http://www.dattalo.com/technical/theory/logs.html
//http://www.sengpielaudio.com/Rechner-notennamen.htm

unit main;

interface

uses Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
     Dialogs, ComCtrls, ExtCtrls, Spin, ExtDlgs, ShellAPI, StdCtrls, FileCtrl,
     Menus, Math,
     //
     MMSystem,
     //WaveMixer,
     BassEnc,
     Bass,
     OpenGl,
     cg,
     cgGL,
     //dglOpenGL,
     Util,
     GR32, GR32_Image, GR32_VectorMaps, GR32_ExtImage, GR32_Rasterizers,
     WaveMixer, Led;

function LogValue(x, minx, maxx: double):double;
function LogValue2(x, minx, maxx: double):double;
function LogPos2Freq(x, minx, maxx: double):double;
function LogPos2Ampl(x, minx, maxx: double):double;
function Freq2LogPos(x, minx, maxx: double):double;
Function  nteWurzel(x: Double; n: Double): double;

procedure SysErrMsg(ErrCode: Integer; S: string);
function  FileSizeByName(sFilename: string): Int64;
(**)
procedure glBindTexture(target: GLenum; texture: GLuint); stdcall; external opengl32;
procedure glGenTextures(n: GLsizei; var textures: GLuint); stdcall; external opengl32;
procedure glCopyTexImage2D(target: GLEnum; level: GLint; internalFormat: GLEnum; x, y: GLint; width, height: GLsizei; border: GLint); stdcall; external opengl32;
(**)

procedure glDisableClientState (cap: word); stdcall; external opengl32;
procedure glEnableClientState (cap: word); stdcall; external opengl32;

procedure glDrawArrays   (mode: GLenum; first: GLint; count:GLsizei); stdcall; external opengl32;
procedure glDrawBuffer   (mode: GLenum); stdcall; external opengl32;
procedure glDrawElements (mode: GLenum; count: GLsizei; etype: GLenum; indices: Pointer); stdcall; external opengl32;

procedure glVertexPointer(size: GLint; _type: GLenum; stride: GLsizei; const _pointer: Pointer); stdcall; external opengl32;
procedure glColorPointer(size: GLint; _type: GLenum; stride: GLsizei; const _pointer: Pointer); stdcall; external opengl32;

const
    MAXFFTSIZE     = 8192;
    MAXLINES       = 64; //256; //128; //256; //512;

    MOD_ALT = 1;
    MOD_CONTROL = 2;
    MOD_SHIFT = 4;
    MOD_WIN = 8;
    VK_A = $41;
    VK_R = $52;
    VK_F4 = $73;
    maxFileSize = 10000000; // 10 MB

    BASSENCVERSION = $2040300;
    TWO_PI = 6.2831853071;     // PI * 2
    //SIZE = 64;               // Velikost meshe

type
    TVert          = array of GLfloat;
    TCols          = array of GLfloat;

    TIntData       = array[0..MAXFFTSIZE-1] of GLint;
    PIntData       = ^TIntData;

    TFloatData     = array[0..MAXFFTSIZE-1] of GLfloat;
    PFloatData     = ^TFloatData;

    TFField3d      = array[0..MAXLINES-1] of TFloatData; // [ spalten(zeit) , zeilen(frequenzen) ]
    PFField3d      = ^TFField3d;

    TIField3d      = array[0..MAXLINES-1] of TIntData; // [ spalten(zeit) , zeilen(frequenzen) ]
    PIField3d      = ^TIField3d;

    TNotesArray = record
        Name: array[0..MAXFFTSIZE-1] of string;
        Frequency: array [0..9]of array  [0..10] of double; // [Octave][]
    end;

    PFullPalette = ^TFullPalette;
    TFullPalette = array[0..255] of TRGBQuad;

    PbmiColors = ^TbmiColors;
    TbmiColors = array[0..0] of TRGBQuad;
    PRGBTriple = ^TRGBTriple;

    TMyThread = class(TTHread)
    private
    protected
      procedure shellrun;
      procedure Execute; override;
    public
      constructor create;
    end;

    TFormPlayer = class(TForm)
        TimerRender: TTimer;
        T2: TTimer;
        SnapshotTimer: TTimer;
        ColorTimer: TTimer;

        AudioMixer: TAudioMixer;

        LinesList: TComboBox;
        
        OpenDialog: TOpenDialog;
        ColorDialog: TColorDialog;
        pOptions: TPanel;
        PanelBkg: TPanel;
        PanelPen: TPanel;
        DrawMode: TRadioGroup;
        Label6: TLabel;
        Label7: TLabel;
        cbLink: TCheckBox;
        Button1: TButton;
        Button2: TButton;
        PollIntervall: TSpinEdit;
        cb_volumescale: TCheckBox;
        ShowLevel: TCheckBox;
        dblpxl: TCheckBox;
        fFFTSize: TComboBox;
        Label2: TLabel;
        Button3: TButton;
        GroupBox1: TGroupBox;
        Label4: TLabel;
        Hiddenpanel: TPanel;
        Label3: TLabel;
        RadioGroup1: TRadioGroup;
        Label5: TLabel;
        FreqScaleLog: TTrackBar;
        Label9: TLabel;
        Button23: TButton;
        HzInfo: TCheckBox;
        Splitline: TCheckBox;
        reset: TButton;
        Button26: TButton;
        btnsave: TButton;
        blur: TSpinEdit;
        Label8: TLabel;
        Button28: TButton;
        Button29: TButton;
        SwapChannels: TCheckBox;
        GroupBox2: TGroupBox;
        Label10: TLabel;
        AmplScale1: TRadioButton;
        AmplScale2: TRadioButton;
        AmplScale3: TRadioButton;
        FMax: TTrackBar;
        FMin: TTrackBar;
        Label11: TLabel;
        Label12: TLabel;
        Label14: TLabel;
        Label17: TLabel;
        Button24: TButton;
        Label18: TLabel;
        Label19: TLabel;
        Mono: TCheckBox;
        cbSampleRate: TComboBox;
        Label20: TLabel;
        lbScaling: TLabel;
        Label24: TLabel;
        tbVolume: TTrackBar;
        Label25: TLabel;
        lbfps: TLabel;
        autolevel: TCheckBox;
        VolLevel: TCheckBox;
        vumeterwidth: TSpinEdit;
        Label23: TLabel;
        Button32: TButton;
        Button33: TButton;
        Label1: TLabel;
        AmplScale4: TRadioButton;
        Label26: TLabel;
        Label27: TLabel;
        Button34: TButton;
        Scrolling: TCheckBox;
        effect1: TTrackBar;
        effect2: TTrackBar;
        cbdebug: TCheckBox;
        opt2: TCheckBox;
        TrackBar1: TTrackBar;
        rms: TCheckBox;
        Button35: TButton;
        Button36: TButton;
        Button37: TButton;
        Button38: TButton;
        ScaleC: TTrackBar;
        ScaleB: TTrackBar;
        Label29: TLabel;
        GroupBox3: TGroupBox;
        Button15: TButton;
        Button14: TButton;
        Button21: TButton;
        Button20: TButton;
        Button19: TButton;
        Button18: TButton;
        Button17: TButton;
        Button16: TButton;
        Button13: TButton;
        Button9: TButton;
        Button6: TButton;
        Button5: TButton;
        Color1: TPanel;
        Color2: TPanel;
        Color3: TPanel;
        ColorPosition1: TTrackBar;
        Color4: TPanel;
        ColorPosition2: TTrackBar;
        Color5: TPanel;
        ColorPosition3: TTrackBar;
        Color6: TPanel;
        ColorPosition4: TTrackBar;
        Button7: TButton;
        Button8: TButton;
        Button10: TButton;
        Button11: TButton;
        Button12: TButton;
        tbContrast: TTrackBar;
        tbBrightness: TTrackBar;
        ColorPosition5: TTrackBar;
        Color7: TPanel;
        Button25: TButton;
        Button27: TButton;
        Button22: TButton;
        Button30: TButton;
        Button31: TButton;
        Panel1: TPanel;
        Image1: TImage;
        Button39: TButton;
        Button40: TButton;
        lbMissing: TLabel;
        lbTB1: TLabel;
        lbTB2: TLabel;
        lbTB3: TLabel;
    RecPanel: TPanel;
    btRec: TButton;
    Button41: TButton;
    silenceDuration: TSpinEdit;
    Label30: TLabel;
    GroupBox4: TGroupBox;
    Label16: TLabel;
    lb15: TLabel;
    lb16: TLabel;
    Label13: TLabel;
    Label15: TLabel;
    lb17: TLabel;
    lb18: TLabel;
    Label22: TLabel;
    Label21: TLabel;
    Button4: TButton;
    SpinSens: TSpinEdit;
    SpinSono: TSpinEdit;
    Edit1: TEdit;
    cbRec: TCheckBox;
    tbSavePath: TEdit;
    btnSelectDir: TButton;
    tbLamePath: TEdit;
    btnSelectLame: TButton;
    Image2: TImage;
    cbMute: TCheckBox;
    Led1: TLed;

        procedure Button32Click(Sender: TObject);
        procedure Button33Click(Sender: TObject);
        procedure vumeterwidthChange(Sender: TObject);
        procedure Button34Click(Sender: TObject);
        procedure btRecClick(Sender: TObject);

        procedure ColorTimerTimer(Sender: TObject);
        procedure T2Timer(Sender: TObject);
        procedure TimerRenderTimer(Sender: TObject);
        procedure SnapshotTimerTimer(Sender: TObject);

        procedure Button6Click(Sender: TObject);
        procedure Button5Click(Sender: TObject);
        procedure Button7Click(Sender: TObject);
        procedure Button8Click(Sender: TObject);
        procedure Button9Click(Sender: TObject);
        procedure Button10Click(Sender: TObject);
        procedure Button11Click(Sender: TObject);
        procedure Button1Click(Sender: TObject);
        procedure Button2Click(Sender: TObject);
        procedure Button4Click(Sender: TObject);
        procedure Button3Click(Sender: TObject);
        procedure Button12Click(Sender: TObject);
        procedure Button13Click(Sender: TObject);
        procedure Button14Click(Sender: TObject);
        procedure Button15Click(Sender: TObject);
        procedure Button16Click(Sender: TObject);
        procedure Button17Click(Sender: TObject);
        procedure Button18Click(Sender: TObject);
        procedure Button19Click(Sender: TObject);
        procedure Button20Click(Sender: TObject);
        procedure Button21Click(Sender: TObject);

        procedure DrawModeClick(Sender: TObject);
        procedure PanelBkgClick(Sender: TObject);
        procedure PanelPenClick(Sender: TObject);
        procedure SpecTrackWidthChange(Sender: TObject);
        procedure SpinLineFallChange(Sender: TObject);
        procedure SpinPeakFallChange(Sender: TObject);
        procedure pOptionsMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
        procedure pOptionsMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
        procedure TrackOffChange(Sender: TObject);
        procedure TrackResChange(Sender: TObject);
        procedure TrackRadChange(Sender: TObject);
        procedure tbContrastChange(Sender: TObject);
        procedure tbBrightnessChange(Sender: TObject);

        procedure PollIntervallChange(Sender: TObject);
        procedure SpinEditChange(Sender: TObject);

        procedure Edit1Change(Sender: TObject);
        procedure Edit1KeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
        procedure RadioDrawClick(Sender: TObject);
        procedure ColorChooser(Sender: TObject);

        procedure ColorPosition1Change(Sender: TObject);
        procedure ColorPosition2Change(Sender: TObject);
        procedure ColorPosition3Change(Sender: TObject);
        procedure ColorPosition4Change(Sender: TObject);
        procedure ColorPosition5Change(Sender: TObject);

        procedure Button35Click(Sender: TObject);
        procedure Button36Click(Sender: TObject);
        procedure Button37Click(Sender: TObject);
        procedure Button38Click(Sender: TObject);

        procedure cbdebugClick(Sender: TObject);
        procedure fFFTSizeChange(Sender: TObject);
        procedure Button26Click(Sender: TObject);
        procedure Button27Click(Sender: TObject);
        procedure ScalingClick(Sender: TObject);
        procedure Button29Click(Sender: TObject);
        procedure Button28Click(Sender: TObject);
        procedure dblpxlClick(Sender: TObject);
        procedure opt2Click(Sender: TObject);

        procedure Label19Click(Sender: TObject);
        procedure Label19MouseEnter(Sender: TObject);
        procedure Label19MouseLeave(Sender: TObject);
        procedure pOptionsMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);

        procedure Button39Click(Sender: TObject);
        procedure Button40Click(Sender: TObject);
        procedure FMinChange(Sender: TObject);
        procedure FMaxChange(Sender: TObject);
        procedure ScaleBChange(Sender: TObject);
        procedure Button23Click(Sender: TObject);
        procedure Button24Click(Sender: TObject);
        procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;Shift: TShiftState; X, Y: Integer);
        procedure resetClick(Sender: TObject);
        procedure Button25Click(Sender: TObject);
        procedure FreqScaleLogChange(Sender: TObject);
        procedure MonoClick(Sender: TObject);
        procedure cbSampleRateChange(Sender: TObject);
        procedure Button22Click(Sender: TObject);
        procedure Button30Click(Sender: TObject);
        procedure Button31Click(Sender: TObject);
        procedure Color1MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
        procedure VolLevelClick(Sender: TObject);
        procedure AmplitueScaleLogChange(Sender: TObject);
        procedure btnSelectDirClick(Sender: TObject);
        procedure btnSelectLameClick(Sender: TObject);
        procedure Button41Click(Sender: TObject);
        procedure SplitlineClick(Sender: TObject);
        procedure btnsaveClick(Sender: TObject);
        procedure SaveToFile(Sender: TObject; filename: string='');

        procedure ProcessError;
        procedure showinfo(s: string);

        procedure OpenAndPlayFile(sender:TObject; filename:string);
        procedure openStream(sender:TObject);
        procedure closeStream(sender:TObject);

        procedure VUBox(X, Y, Z, Value: glFloat; lX, lY, lZ: glFloat; yval: byte);
        procedure VUBox2(X, Y, Z: glFloat; lX, lY, lZ: glFloat; Value: byte);

        procedure ChangePalette(ABmp:TBitmap);
        procedure MakePaletteGDI;
        procedure MakePaletteGDI8Bit;
        procedure DrawPalette(b:TBitmap);
        procedure DrawPalette2(b:TBitmap);

        procedure tbVolumeChange(Sender: TObject);
        procedure tbMasterVolumeChange(Sender: TObject);

        procedure LinesListChange(Sender: TObject);
        procedure AudioMixerControlChange(Sender: TObject;MixerLine: TAudioMixerLine; ControlType: TMixerControlType);
        procedure AudioMixerLineChange(Sender: TObject;MixerLine: TAudioMixerLine);
        //procedure MixerLineChange(Sender: TObject; MixerLine: TAudioMixerLine);
        //procedure MixerListChange(Sender: TObject);
        //procedure MixerControlChange(Sender: TObject; MixerLine: TAudioMixerLine; ControlType: TMixerControlType);

        procedure SetS(nW, nH: integer; doresize:boolean=true);
        procedure SetFormStyle;
        procedure setSettings; // includes setvars
        procedure setVars;
        procedure config_read;
        procedure config_write;

        procedure FormCreate(Sender: TObject);
        procedure FormClose(Sender: TObject; var Action: TCloseAction);
        procedure FormPaint(Sender: TObject);
        procedure FormResize(Sender: TObject);
        procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
        procedure FormMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
        procedure FormMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
        procedure FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
        procedure FormKeyPress(Sender: TObject; var Key: Char);
        procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
        procedure FormDblClick(Sender: TObject);
        procedure FormActivate(Sender: TObject);
        procedure cbMuteClick(Sender: TObject);

    private
        doingsettings:boolean;
        MYhotkey: integer;
        openglRC: HGLRC; // Rendering Context
        openglDC: HDC; // Device Context
        rS, gS, bS: integer;
        ElapsedTime, AppStart, AppLast: DWord; // Timing variables

        procedure varinfo(y:integer; info:string);
        procedure WMHotKey(var Msg: TWMHotKey); message WM_HOTKEY;
        procedure GetMixerValues(bOnlyVolume:boolean);
        procedure SetMixerValues(bOnlyVolume:boolean);

        procedure glInit;
        procedure glDraw;
        procedure glDraw2;
        procedure glDraw3;
        procedure RenderScene;
        procedure glDraw4;
        procedure glDraw5;

        procedure Draw;
    public
    end;

type TSingleArray	= array of Single;

var FormPlayer         : TFormPlayer;

    bUpdating          : boolean;
    winkel,winkelmass  : double;
    wHalf,hHalf        : integer;
    xfact,yfact        : integer;
    wQuart,hQuart      : integer;
    lamePath     : string;
    lameOpts     : string;
    inifile      : string;
    progdir      : string;
    savePath     : string;
    fname, fname2: string;

    PaletteStream   : TMemoryStream;     { Stream }
    APalette        : TFullPalette;
    AmplitudeArray  : array [0..255] of GLfloat;
    SonoPal         : array [0..255] of TColor;
    glSonoPal       : array [0..255] of array [0..2] of glFloat;

    // Textures
    BlurTexture     : glUint;              // An Unsigned Int To Store The Texture Number
    sp              : boolean;
    wave_movement   : GLfloat = 0.0;       // Pro vytvoen sinusov vlny
    cg_enable       : boolean = true;      // Flag sputn CG
    cgKontext       : CGcontext;           // CG kontext
    cgPrg           : CGprogram;           // CG vertex program
    cgVertexProfile : CGprofile;           // CG profil
    positionCG, colorCG, waveCG, modelViewMatrix: CGparameter;    // Parametry pro shader
    mesh: array [0..MAXLINES-1,0..MAXFFTSIZE-1,0..2] of GLfloat;  // Data meshe

    //Vertices        : array of GLfloat; //TVert;
    //Colors          : array of GLfloat; //TCols
    //Float[] = [0.0, 1.0, -10.0, -1.0, -1.0, -10.0, 1.0, -1.0, -10.0]
    // floatFloat[] = [1.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 1.0]

    RECORDCHAN      : HRECORD; // recording channel
    FILEChannel     : HSTREAM; // file playback channel
    WaveStream      : TFileStream;
    lasttime        : extended;

    dataflag        : Cardinal;
    DL              : Cardinal;
    colorflag       : boolean;
    imgcount        : integer;
    missingcount    : integer;

    ColorData       : array [0..MAXFFTSIZE] of GLfloat;

  ci		: BASS_CHANNELINFO;
  Buf		: TSingleArray;
  SpecBuf	: Pointer;

    FloatData       : array [0..MAXFFTSIZE] of GLfloat; // TGLArrayf3;
    FloatDataLast   : array [0..MAXFFTSIZE] of GLfloat;

    FreqArray,
    lastaL,lastaR   : array [0..MAXFFTSIZE] of GLfloat;
    lastiL,lastiR   : array [0..MAXFFTSIZE] of Integer;

    NoteStrings     : array [0..MAXFFTSIZE-1] of string;
    NoteStrings2    : array [0..MAXFFTSIZE-1] of string;

    VisBuff         : TBitmap;
    VisBlack        : TBitmap;
    CanvasToDraw    : TCanvas;
    CurrentPanel    : TPanel;

    lx1,ly1,
    lx2,ly2,
    SplitLineColorIdx,
    VolColIdx1, VolColIdx2   : integer;
    szoverall, szline        : integer;

    FFTStart,FFTSize,
    FFTbins,                            // sampleRate div 4
    FFTpromille              : integer; // sampleRate div 2
    offset                   : integer;
    offsetstart, offsetend   : integer;

    Lsh,Rsh            : integer;
    mL,mR              : integer; // the middle from where to draw from
    scrollL, scrollR   : integer; // scrollcounters
    W, H               : integer; // width and height of picture
    PixelMax           : integer; // calculated
    PixelMaxX          : integer; // after drawing
    SampleRate         : integer;
    FreqRate           : integer; // sampleRate div 2

    FreqMin,FreqMax    : double;
    FreqRes            : double;  // SampleRate / FFTSize o. FreqRange /
    FreqLogFakt        : double;
    FreqLogFaktDiv     : double;
    AmplLogFakt   : double;
    AmplLogFaktDiv: double;
    avgL,avgR          : double;
    avgLl,avgRl        : double;

    //FillTime        : double;  // FFTSize / SampleRate o. 1/FreqRes = TimeScroll
    //FreqSpan        : double;  // FreqRes * h
    //bandPerOctave   : double;  // how many bands per octave
    //MaxBands        : integer; // FFTSize div 2

    pX, pY: integer; // for moving panel
    wx, wy, ww, wh: integer;
    seconds: longint;

    test,testmin,testmax      : integer;
    pl1,pl2,pl3,pixelwidth,ph : integer;
    bright, contrast, fExponent: double;
    doRec, yet2sec, flag      : boolean;

    recC2   : integer;
    recC    : Int64; // count recorded bytes

    bMouseDown: Boolean;
    fps:integer;
    drive: integer;

    Sensitivity: Integer;
    SensitivityF: Integer;

    peakCounter,
    peakL,peakR:integer;
    peakLf,peakRf:integer;
    peakLClip, peakRClip:boolean;
    peakLClipf, peakRClipf:boolean;

    maxxL, maxxR, minxL, minxR: Integer;
    maxLf, minLf:double;

    silence: cardinal;
    silDuration: cardinal;

    level,
    LevelL, LevelR         : DWORD;   // VolumeLevel
    LevelLf,LevelRf        : integer; // FFTenergy

    oldLevelLf, oldLevelRf : integer;
    oldLevelL , oldLevelR  : Word;
    oldzwL, oldzwR: integer;

    // opengl
    Frames: Integer; // number of frames in blur "buffer"
    angle: double;
    anglerotate: double;
    xDist: double;
    yDist: double;
    zDist: double;
    down: Boolean;

    (**)
    FField3d: TFField3d;
    gllastValue: GLfloat;
    maxboxwidth:GLfloat;
    (**)

(*
    PenColor   : TColor;
    DrawType   : Integer;
    UseBkg     : Boolean;
    fakt       : integer;
    fakt2      : integer;
    sqrtscl    : TCheckBoxState;
    fkontrastvalue:integer;
    xOld       : Integer;
*)

implementation

uses StrUtils;

{$R *.dfm}

function freq_to_note(freq:double):string;
  function lognote(freq:double):double;
  begin
    result:=Log2(freq) - log2(261.626) / log2(2) + 4.0;
  end;
  const note_table : string='C C#D D#E F F#G G#A A#B';//array [0..6] of string = ('C','C#D','D#E','F','F#G','G#A','A#B');
var lnote,cents,noteoffset:double;
    oct,j,x:integer;
    note,notenote:string;
begin
    lnote      := lognote(freq);
    oct        := floor(lnote);
    cents      := 1200 * (lnote - oct);

    noteoffset := 50.0;
    x := 2;
    if (cents < 50) then begin
      note := 'C ';
    end else if (cents >= 1150) then
    begin
      notenote := 'C ';
      cents := cents - 1200;
      inc(oct);
    end else begin
      for j:=1 to 11 do
      begin
        if (cents >= noteoffset) and (cents < (noteoffset + 100)) then
        begin
          note := note_table[x] + note_table[x + 1];
          cents := cents - (j * 100);
          break;
        end else begin
          noteoffset := noteoffset + 100;
          x := x+2;
        end;
      end;
    end;
    note:=trim(note);
    if      cents=0 then result:=' - '+note+inttostr(oct)
    //else if cents>0 then result:=' - '+note+inttostr(oct) + ' (+'+floattostrf(cents, ffNumber,12,1)+')'
    //                else result:=' - '+note+inttostr(oct) + ' (' +floattostrf(cents, ffNumber,12,1)+')'
    else if cents>0 then result:=' - '+note+inttostr(oct) + ' +'+floattostrf(cents, ffNumber,12,1)
                    else result:=' - '+note+inttostr(oct) + ' ' +floattostrf(cents, ffNumber,12,1)
end;

function freq_to_note2(freq:double):string;
  function lognote(freq:double):double;
  begin
    result:=Log2(freq) - log2(261.626) / log2(2) + 4.0;
  end;
  const note_table : string='C C#D D#E F F#G G#A A#B';//array [0..6] of string = ('C','C#D','D#E','F','F#G','G#A','A#B');
var lnote,cents,noteoffset:double;
    oct,j,x:integer;
    note,notenote:string;
begin
    lnote      := lognote(freq);
    oct        := floor(lnote);
    cents      := 1200 * (lnote - oct);

    noteoffset := 50.0;
    x := 2;
    if (cents < 50) then begin
      note := 'C ';
    end else if (cents >= 1150) then
    begin
      notenote := 'C ';
      cents := cents - 1200;
      inc(oct);
    end else begin
      for j:=1 to 11 do
      begin
        if (cents >= noteoffset) and (cents < (noteoffset + 100)) then
        begin
          note := note_table[x] + note_table[x + 1];
          cents := cents - (j * 100);
          break;
        end else begin
          noteoffset := noteoffset + 100;
          x := x+2;
        end;
      end;
    end;
    note:=trim(note);
    if      cents=0 then result:=' - '+note+inttostr(oct)
    //else if cents>0 then result:=' - '+note+inttostr(oct) + ' (+'+floattostrf(cents, ffNumber,12,1)+')'
    //                else result:=' - '+note+inttostr(oct) + ' (' +floattostrf(cents, ffNumber,12,1)+')'
    else if cents>0 then result:=' - '+note+inttostr(oct)
                    else result:=' - '+note+inttostr(oct)
end;

//////////////////////////////////////////////////////////////////////////////////////////

constructor TMyThread.create;
begin
  inherited create(false);
  FreeOnTerminate:=true;
end;

procedure TMyThread.shellrun;
begin
  ShellExecute(Handle,'open','http://free.pages.at/blumetools/','','',1);
end;

procedure TMyThread.Execute;
var loc_sleep, dummy : integer;
begin
  synchronize(shellrun);
end;

procedure TFormPlayer.Label19Click(Sender: TObject);
var t:TMyThread;
begin
  t:=TMyThread.Create;
end;

procedure TFormPlayer.Label19MouseEnter(Sender: TObject);
begin
  label19.Font.Style:=[];
end;

procedure TFormPlayer.Label19MouseLeave(Sender: TObject);
begin
  label19.Font.Style:=[fsUnderline];
end;

///////////////////////////////////////////////////////////////

function EmptyTexture : glUint;
var txtnumber : glUint;
    //data : Array of glUint;
    pData : Pointer;
begin
  // Create Storage Space For Texture Data (128x128x4)
  GetMem(pData, 128*128*4);

  glGenTextures(1, txtnumber);		      		// Create 1 Texture
  glBindTexture(GL_TEXTURE_2D, txtnumber);    		// Bind The Texture
  glTexImage2D(GL_TEXTURE_2D, 0, 4, 128, 128, 0, GL_RGBA, GL_UNSIGNED_BYTE, pData);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);

  result :=txtNumber;
end;

// function for creating strings from numbers
function countStr(Number, pos: Integer): string;
var zw: string;
begin
    zw := IntToStr(Number);
    if Length(zw) > pos then pos := Length(zw);
    while Length(zw) <> pos do zw := '0' + zw;
    result := zw;
end;

function FileSizeByName(sFilename: string): Int64;
var sFile: TFileStream;
begin
    if not FileExists(sFilename) then begin result := 0; exit end;
    sFile := TFileStream.Create(sFilename, fmOpenRead or fmShareDenyNone);
    try
        result := sFile.Size;
    finally
        sFile.free;
    end;
end;

procedure ShadowTextOut(C: TCanvas; X, Y: Integer; s: String; ShadowMode:integer=2);
var c1,c2: TColor;
begin
  c1:=sonopal[SplitLineColorIdx div 4]; //0];
  c2:=sonopal[SplitLineColorIdx];

  if ShadowMode>0 then begin
    C.Font.Color:=c1;
    C.TextOut(x+1 , y  , s);
    C.TextOut(x-1 , y  , s);
    C.TextOut(x   , y+1, s);
    C.TextOut(x   , y-1, s);

    (*
    C.TextOut(x+1 , y-1, s);
    C.TextOut(x-1 , y+1, s);
    C.TextOut(x-1 , y-1, s);
    C.TextOut(x+1 , y+1, s);
    *)

    if ShadowMode=1 then begin
    C.TextOut(x+1 , y+2, s);
    C.TextOut(x+1 , y-2, s);
    C.TextOut(x-1 , y+2, s);
    C.TextOut(x-1 , y-2, s);

    C.TextOut(x+2 , y+1, s);
    C.TextOut(x+2 , y-1, s);
    C.TextOut(x-2 , y+1, s);
    C.TextOut(x-2 , y-1, s);

    C.TextOut(x-2 , y  , s);
    C.TextOut(x+2 , y  , s);
    C.TextOut(x   , y+2, s);
    C.TextOut(x   , y-2, s);
    end;
  end;
  C.Font.Color:=C2;
  C.TextOut(x, y, s);
end;

procedure SetWinStyle(var style:ULONG; WS_X: ULONG; bOn: boolean);
begin
    if bOn then begin
        if (style and WS_X) <> WS_X then
            style := style OR WS_X;
    end else begin
        if (style and WS_X) = WS_X then
            style := style AND (NOT (WS_X))
    end;
end;

procedure SysErrMsg(ErrCode: Integer; S: string);
var Len: Integer;
   Buffer: array[0..255] of Char;
begin
  if ErrCode=0 then exit;
  Len := FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM or
      FORMAT_MESSAGE_ARGUMENT_ARRAY, nil, ErrCode, 0, Buffer,
      SizeOf(Buffer), nil);
  while (Len > 0) and (Buffer[Len - 1] in [#0..#32, '.']) do Dec(Len);
  Application.MessageBox(PChar(S + IntToStr(ErrCode) + Chr(13) + Buffer), 'error');
end;

procedure TFormPlayer.Button41Click(Sender: TObject);
begin
  t2.Enabled:=false;
  if btRec.caption='stop &record' then begin
    closeStream(sender);
  end else begin
    btRec.caption:='stop &record';
  end;
  Led1.LedOn:=true;
  Led1.OnColor:=$3333ff;
  openStream(sender);
end;

procedure TFormPlayer.btRecClick(Sender: TObject);
begin
  t2.Enabled:=false;
  if btRec.caption='stop &record' then begin
    btRec.caption:='&record now';
    Led1.LedOn:=false;
    Led1.OnColor:=$0088ff;
    closeStream(sender);
  end else begin
    btRec.caption:='stop &record';
    Led1.OnColor:=$3333ff;
    Led1.LedOn:=true;
    openStream(sender);
  end;
end;

function IntToDottetInt(I:Int64): String;
var fmtset: TFormatSettings;
    d: Extended	;
begin
    fmtset.ThousandSeparator:='.';
    d:=I;
    result:=Format('%.0n', [d], fmtset);
end;

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

procedure TFormPlayer.cbdebugClick(Sender: TObject);
begin
  if cbdebug.checked then
    CanvasToDraw:=FormPlayer.Canvas // for debug
  else
    CanvasToDraw:=VisBuff.Canvas;   // with buffer
end;

procedure TFormPlayer.ProcessError;
var i: integer;
begin
    Label16.Caption := '';
    i := BASS_ErrorGetCode;
    case i of
        BASS_ERROR_HANDLE: Label16.Caption := 'handle is not a valid channel.';
        BASS_ERROR_NOPLAY: Label16.Caption := 'The channel is not playing, or is stalled. When handle is a "decoding channel", this indicates that it has reached the end.';
        BASS_ERROR_ILLPARAM: Label16.Caption := 'An illegal parameter was specified.';
        BASS_ERROR_NOTAVAIL: Label16.Caption := 'Stereo FFT data is being requested, but the channel is mono. Or the BASS_DATA_AVAILABLE flag was used with a decoding channel.';
        BASS_ERROR_MEM: Label16.Caption := 'There is insufficent memory.';
        BASS_ERROR_BUFLOST: Label16.Caption := 'Should not happen, but...';
        BASS_ERROR_ALREADY: Label16.Caption := 'already initialized';
        BASS_ERROR_FILEFORM: Label16.Caption := 'unsupported file format';
    end;
    Label16.refresh;
end;

function RecordCallback(Handle: HRECORD; buffer: Pointer; length, user: DWord): boolean; stdcall;
var bytes: int64;
begin
    if doRec and (
       (silence * FormPlayer.TimerRender.Interval < silDuration)
       or (not FormPlayer.cbrec.checked) ) then
    begin
        TimerPause1;
        if lasttime>=0.0 then
        if TimerAsSeconds1 > lasttime+0.2499 then
        begin
          lasttime := TimerAsSeconds1;
          bytes    := FileSizeByName(fname);

          if not bUpdating then begin
            FormPlayer.Label16.Caption :=
              GetUserFriendlyTime(lasttime*1000,1)+#13#10+
              //inttostr(trunc(lasttime))+#13#10+
              IntToDottetInt(bytes)+' bytes ';
              //format('%.0f sec',[TimerAsSeconds1])+#13#10+
              //inttostr(bytes)+' bytes ';
          end;

          if (bytes > maxFileSize) then 
          begin
            FormPlayer.closeStream(nil);
            if DiskFree(drive) <= maxFileSize then
            begin
                doRec := false;
                FormPlayer.cbrec.checked:=false;
                FormPlayer.btRecClick(nil);
                FormPlayer.btRec.Enabled := false;
                FormPlayer.Label16.caption := 'disk full';
            end else begin
                FormPlayer.openStream(nil);
                FormPlayer.btRec.Enabled := true;
            end;
          end;
        end;
        TimerResume1;
        BASS_Encode_SetPaused(RECORDCHAN, FALSE);
    end else begin
        BASS_Encode_SetPaused(RECORDCHAN, TRUE);
    end;
    Result := True;
end;

procedure TFormPlayer.cbSampleRateChange(Sender: TObject);
begin
    TimerRender.Interval := PollIntervall.Value;
    samplerate := StrToIntDef(cbSampleRate.Items[cbSampleRate.itemIndex],44100);

    if RECORDCHAN<>0 then BASS_ChannelStop(RECORDCHAN);
    BASS_SetConfig(BASS_CONFIG_UPDATEPERIOD,TimerRender.Interval);
    RECORDCHAN := BASS_RecordStart(
        SampleRate,2, // always 2 channels, mono -> BASS_ChannelGetData no INDIVIDUAL-flag
        MAKELONG(0, TimerRender.Interval),
        @RecordCallback,
        nil);
    setVars;
end;

procedure TFormPlayer.PollIntervallChange(Sender: TObject);
begin
  if StrToIntDef(PollIntervall.text,-1)=-1 then exit;
  if PollIntervall.Value <> TimerRender.Interval then 
  begin
    TimerRender.Interval := PollIntervall.Value;
    samplerate := StrToIntDef(cbSampleRate.Items[cbSampleRate.itemIndex],44100);

    if RECORDCHAN<>0 then BASS_ChannelStop(RECORDCHAN);
    BASS_SetConfig(BASS_CONFIG_UPDATEPERIOD,TimerRender.Interval);
    RECORDCHAN := BASS_RecordStart(
        SampleRate,2, // always 2 channels, mono -> BASS_ChannelGetData no INDIVIDUAL-flag
        MAKELONG(0, TimerRender.Interval),
        @RecordCallback,
        nil);
  end;
end;

procedure TFormPlayer.GetMixerValues(bOnlyVolume:boolean);
var LVol, RVol: word;
    CtrlType: byte;
    pname:PansiChar;
    i,desiredSampleRate: DWORD;
    r: Boolean;
    level: single;
    bassinfo: BASS_CHANNELINFO;
    NumChan:Integer;
    flags:Cardinal;
    dName: PAnsiChar;
    ADeviceInfo: BASS_DEVICEINFO;
begin
  if not FormPlayer.Visible then exit;
  if bUpdating then exit;
  bUpdating:=true;

  if not bOnlyVolume then 
  begin
    i := 0;
    dName := BASS_RecordGetInputName(i);
    while dName <> nil do
    begin
      // is this one currently "on"?
      if (BASS_RecordGetInput(i, level) and BASS_INPUT_OFF) = 0 then
      begin
        LinesList.ItemIndex := i;
      end;
      Inc(i);
      dName := BASS_RecordGetInputName(i);
    end;
  end;

  if (BASS_RecordGetInput(-1, level) and BASS_INPUT_OFF) = 0 then
    cbMute.Checked:=False
  else
    cbMute.Checked:=true;
  
  desiredSampleRate := StrToIntDef(cbSampleRate.Items[cbSampleRate.itemIndex],44100);
  if BASS_ChannelGetInfo(RECORDCHAN,bassinfo) and (desiredSampleRate<>bassinfo.freq) then
      SampleRate:=bassinfo.freq;
  BASS_RecordGetInput(LinesList.ItemIndex, level);

  tbVolume.Position := trunc(ceil(level*100));
  Label25.Caption:=inttostr(tbVolume.Position)+'%';

  bUpdating:=false;
  //setvars;
end;

procedure TFormPlayer.SetMixerValues(bOnlyVolume:boolean);
var LVol, RVol: word;
    Mute: boolean;
    CtrlType: byte;
    pname:PansiChar;
    i,desiredSampleRate: DWORD;
    r: Boolean;
    level: single;
    bassinfo: BASS_CHANNELINFO;
    NumChan:Integer;
    flags:Cardinal;
begin
  if not FormPlayer.Visible then exit;
  if bUpdating then exit;
  bUpdating:=true;

  TimerRender.Interval := PollIntervall.Value;
  samplerate := StrToIntDef(cbSampleRate.Items[cbSampleRate.itemIndex],44100);

  if not bOnlyVolume then 
  begin
    r := True;
    i := 0;
    // first disable all inputs, then...
    if RECORDCHAN<>0 then BASS_ChannelStop(RECORDCHAN);
    while r do begin
      r := BASS_RecordSetInput(i, BASS_INPUT_OFF, -1);
      Inc(i);
    end;
    // enable the right one
    BASS_RecordSetInput(LinesList.ItemIndex, BASS_INPUT_ON, -1);
    //BASS_RecordSetInput(-1,BASS_INPUT_ON, -1);
    BASS_SetConfig(BASS_CONFIG_REC_BUFFER,1000);
    BASS_SetConfig(BASS_CONFIG_UPDATEPERIOD,TimerRender.Interval);
    //BASS_SetConfig(BASS_CONFIG_UPDATEPERIOD,0); // null and BASS_UPDATE();
    RECORDCHAN := BASS_RecordStart(
        SampleRate,2, // always 2 channels, mono -> BASS_ChannelGetData no INDIVIDUAL-flag
        MAKELONG(0, TimerRender.Interval),
        @RecordCallback,
        nil);
    //RECORDCHAN := BASS_RecordStart(44100, 2, MAKELONG(0, 20), @RecordCallback, nil);
    //ProcessError;
  end;

  if bOnlyVolume then
    BASS_RecordSetInput(LinesList.ItemIndex, BASS_INPUT_ON, tbVolume.Position/100);

  desiredSampleRate:=SampleRate;
  if BASS_ChannelGetInfo(RECORDCHAN,bassinfo) and (desiredSampleRate<>bassinfo.freq) then
    SampleRate:=bassinfo.freq;

  BASS_RecordGetInput(LinesList.ItemIndex, level);
  tbVolume.Position := trunc(ceil(level*100));
  Label25.Caption:=inttostr(tbVolume.Position)+'%';

  bUpdating:=false;
  //setvars;
end;

////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////

procedure TFormPlayer.WMHotKey(var Msg: TWMHotKey);
begin
    if Msg.HotKey = MYhotkey then
    begin
        FormPlayer.Visible := not FormPlayer.Visible;
        if FormPlayer.Visible then
            FormPlayer.SetFocus;
    end;
end;

procedure TFormPlayer.openStream(sender:TObject);
var num, dum : Integer;
    i, j     : Integer;
    cmdline  : PAnsiChar;
    lpSysTime: _SYSTEMTIME;
    lameErr  : cardinal;
begin
    // build filename from systemtime
    savepath:=tbSavePath.Text;
    if not (DirectoryExists(savepath)) then 
    begin
      Label16.Caption:='no savepath!';
      btRecClick(sender);
      exit;
    end;
    if RightStr(savepath,1)<>'\' then
      savepath:=savepath+'\';
    GetLocalTime(lpSysTime);
    fname := savePath + 'rec_'+
        IntToStr(lpSysTime.wYear) + '-' +
        countStr(lpSysTime.wMonth, 2) + '-' +
        countStr(lpSysTime.wDay, 2) + '_' +
        countStr(lpSysTime.wHour, 2) + '-' +
        countStr(lpSysTime.wMinute, 2) + '-' +
        countStr(lpSysTime.wSecond, 2);

    // make sure filname does not exist
    (*
    while FileExists(fname) do begin
        i := Length(fname) - 1;
        while not Isnumeric(fname[i]) do Dec(i);
        j := i;
        while Isnumeric(fname[j]) do Dec(j);
        Val(Copy(fname, j + 1, i - j), num, dum);
        fname := Copy(fname, 1, j) + IntToStr(num + 1) + Copy(fname, j + i - j + 1, Length(fname) - 1);
    end;
    *)

    // drive used by diskfree in RecordCallBack
    drive := Ord(fname[1]) - 64;
    if DiskFree(drive) < maxFileSize then 
    begin
      Label16.Caption:='no space in target dir!';
      btRecClick(sender);
      exit;
    end;
    //fname := UpperCase(fname);
    fname := ChangeFileExt(fname, '.mp3');
    //fname := ChangeFileExt(fname, '.wav');

    doRec := true;
    recC2 := 0; // reset rec size
    TimerStart1; // record timer!!
    TimerPause1;
    lasttime:=TimerAsSeconds1;

    (**)
    GetMem(cmdline, 512);
    //lamePath:='lame.exe';
{$IFDEF VER150}
    lstrcpy(cmdline, PChar(lamePath + lameOpts));
    lstrcat(cmdline, ' - ');
    lstrcat(cmdline, PChar(fname));
    lameErr := BASS_Encode_Start(RECORDCHAN,           cmdline , BASS_ENCODE_AUTOFREE, nil, nil);
{$ELSE}
    lstrcpy(pwidechar(cmdline), PChar(lamePath + lameOpts));
    lstrcat(pwidechar(cmdline), ' - ');
    lstrcat(pwidechar(cmdline), PChar(fname));
    lameErr := BASS_Encode_Start(RECORDCHAN, pwidechar(cmdline), BASS_ENCODE_AUTOFREE, nil, nil);
{$ENDIF}

    if (LameErr = 0) then
    begin
        SysErrMsg(GetLastError, 'Couldn''t start encoding...' + #10
          + 'Make sure LAME.EXE (if encoding to mp3) is in the same' + #10
          + 'direcory as this program.');
        BASS_ChannelStop(RECORDCHAN);
        btRecClick(sender);
    end else begin
        TimerResume1;
    end;
    FreeMem(cmdline);
(**)
end;

procedure TFormPlayer.closeStream(sender:TObject);
var bytes: int64;
begin
    BASS_Encode_Stop(RECORDCHAN);
    doRec:= false;
    recC := 0;
    TimerStop1;
    lasttime := TimerAsSeconds1;
    bytes    := FileSizeByName(fname);
    Label16.Caption := 'recorded ' + IntToDottetInt(bytes)+' bytes '+
              GetUserFriendlyTime(lasttime*1000,1)+' sec';
end;

procedure TFormPlayer.OpenAndPlayFile(sender:TObject; filename:string);
var bassinfo: BASS_CHANNELINFO;
begin
  if button1.Caption='&open file' then
  begin
    if filename='' then begin
      OpenDialog.Title := 'Open File';
      OpenDialog.Filter := 'soundfiles (*.wav;*.mp3;*.ogg;*.aif)|*.wav;*.mp3;*.ogg;*.aif|'+
                           'all (*.*)|*.*|';
      if not OpenDialog.Execute then exit;
      FileName:=OpenDialog.filename;
    end;

    BASS_SetDevice(1);
    BASS_RecordInit(-1);

    // BASS_SAMPLE_FLOAT Use 32-bit floating-point sample data. See Floating-point channels for info.
    // BASS_SAMPLE_MONO Decode/play the stream (MP3/MP2/MP1 only) in mono, reducing the CPU usage (if it was originally stereo). This flag is automatically applied if BASS_DEVICE_MONO was specified when calling BASS_Init.
    // BASS_SAMPLE_SOFTWARE
    FILEChannel := BASS_StreamCreateFile(FALSE, PChar(FileName), 0, 0,
                   //BASS_SAMPLE_FLOAT or
                   //BASS_SAMPLE_SOFTWARE or
                   BASS_SAMPLE_LOOP
{$IFDEF VER150}
{$ELSE}
                   or BASS_UNICODE
{$ENDIF}
                   );
    ProcessError;
    if FILEChannel>0 then
    begin
      bUpdating:=TRUE;
      BASS_ChannelPlay(FILEChannel, False);
      //BASS_ChannelSetAttribute(FILEChannel,BASS_ATTRIB_VOL,tbVolume.Position/100);
      //BASS_ChannelSetAttribute(FILEChannel,BASS_ATTRIB_VOL,0);

      //BASS_SetVolume(0);
      //BASS_StreamCreate()
      if BASS_ChannelGetInfo(FILEChannel,bassinfo) then
        SampleRate:=bassinfo.freq;
      //if cbSampleRate.
      //cbSampleRate.Text:=inttostr(SampleRate);
      cbSampleRate.ItemIndex:=cbSampleRate.Items.IndexOf(inttostr(SampleRate));
      cbSampleRate.Text:=cbSampleRate.Items[cbSampleRate.Itemindex];
      bUpdating:=false;
      SetVars;

      BASS_RecordInit(0);
      button1.Caption:='st&op';
      LinesList.Enabled:=false;
      LinesList.Color:=cl3DLight;
      cbSampleRate.Enabled:=false;
      cbSampleRate.Color:=cl3DLight;
    end else
      GetMixerValues(false);
  end else begin
    button1.Caption:='&open file';
    //BASS_Start();
    //BASS_RecordInit(0);
    BASS_StreamFree(FILEChannel);
    GetMixerValues(false);
    LinesList.Enabled:=true;
    LinesList.Color:=clWindow;
    cbSampleRate.Enabled:=true;
    cbSampleRate.Color:=clWindow;
  end;
end;

procedure TFormPlayer.LinesListChange(Sender: TObject);
begin
  SetMixerValues(false);
end;

procedure TFormPlayer.AudioMixerLineChange(Sender: TObject;MixerLine: TAudioMixerLine);
begin
  GetMixerValues(false);
end;

procedure TFormPlayer.AudioMixerControlChange(Sender: TObject; MixerLine: TAudioMixerLine; ControlType: TMixerControlType);
begin
  if (MixerLine.ID=-1) then
  begin
    bUpdating:=true;
    Application.ProcessMessages;
    cbMute.Checked:=MixerLine.Mute;
    bUpdating:=false;
  end;
  GetMixerValues(true);
end;

procedure TFormPlayer.tbMasterVolumeChange(Sender: TObject);
begin
  SetMixerValues(true);
end;

procedure TFormPlayer.tbVolumeChange(Sender: TObject);
begin
  SetMixerValues(true);
end;

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

procedure TFormPlayer.FormPaint(Sender: TObject);
begin
  BitBlt(Canvas.Handle, 0, 0, W, H, CanvasToDraw.Handle, 0, 0, SRCCOPY);
  //BltTBitmapAsDib(Canvas.Handle,0,0,VisBuff.Width,VisBuff.Height,VisBuff);
end;

procedure TFormPlayer.FormActivate(Sender: TObject);
begin
//  pX:=-1; pY:=-1;
end;

procedure TFormPlayer.FormDblClick(Sender: TObject);
begin
  Button2Click(sender);
end;

procedure TFormPlayer.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  // yet2sec
  //UnRegisterHotKey(Handle, MYHotkey);
  //GlobalDeleteAtom(MYhotkey);

  if doRec then
  begin
    //doRec:=false;
    //closeStream(sender);
    btRecClick(sender);
  end;

  // set from opengl to gdi debug
  RadioGroup1.ItemIndex:=0;

  config_write;
  wglMakeCurrent(0, 0);
  wglDeleteContext(openglRC);

  BASS_RecordFree;
  BASS_Free;
  if PaletteStream<>nil then
  begin
    PaletteStream.Free;
    PaletteStream:=nil;
  end;
  Action:=caFree;
  //setlength(Vertices,0);
  //setlength(Colors,0);
end;

procedure TFormPlayer.FormCreate(Sender: TObject);
var flags: DWORD;
    msgstr: string;
    dName: PAnsiChar;
    level: single;
    I, J, ll: Integer;
    MixerID, DestID: Integer;
    style,hiw,low:DWORD;
    inistr: array[0..259] of char;
    outstr:string;
begin
    if (HiWord(BASS_GetVersion) <> BASSVERSION) then begin
        MessageDlg('BASS.DLL v'+
            IntToHex(BASSVERSION,4) +' needed, but found '+
            IntToHex(BASS_GetVersion,4), mtError, [mbOk], 0);
        Halt;
    end;
    (*
    if (BASS_Encode_GetVersion <> BASSENCVERSION) then begin
        MessageDlg('BASSENC.DLL v'+
            IntToHex(BASSENCVERSION,4) + ' needed, but found '+
            IntToHex(BASS_Encode_GetVersion,4), mtError, [mbOk], 0);
        Halt;
    end;
    *)
    inifile:=ParamStr(0);
    inifile:=ExpandFileName(inifile);
    //ll := Length(inifile);
    //while (inifile[ll] <> '\') do Dec(ll);
    //inifile := Copy(inifile, 1, ll) + ChangeFileExt(ExtractFileName(ParamStr(0)), '.ini');
    progdir:=ExtractFilePath(inifile);
    inifile:=progdir + ChangeFileExt(ExtractFileName(ParamStr(0)), '.ini');

    SetRoundMode(rmUp);
    Randomize;
    //SetLength(Vertices,9);
    //SetLength(Colors,9);
    {
    Vertices[0]:=0.0;
    Vertices[2]:=1.0;
    Vertices[3]:=1.0;
    Vertices[4]:=-1.0;
    Vertices[5]:=-1.0;
    Vertices[6]:=-1.0;
    Vertices[7]:=-10.0;
    Vertices[8]:=-10.0;
    Vertices[9]:=-10.0;
    colors[0]:=0.0;
    colors[1]:=0.0;
    colors[2]:=0.0;
    colors[3]:=0.0;
    colors[4]:=0.0;
    colors[5]:=0.0;
    colors[6]:=1.0;
    colors[7]:=1.0;
    colors[8]:=1.0;
    }

    PaletteStream:=TMemoryStream.Create;
    VisBuff:=TBitmap.Create;
    VisBlack:=TBitmap.Create;
    //cbdebug.Checked:=true;
    CanvasToDraw:=VisBuff.Canvas;    // with buffer
    //CanvasToDraw:=FormPlayer.Canvas; // for debug

    //Panel2.Visible        := False;

    FillChar(lastaL,MAXFFTSIZE,0);
    FillChar(lastaR,MAXFFTSIZE,0);
    FillChar(lastiL,MAXFFTSIZE,0);
    FillChar(lastiR,MAXFFTSIZE,0);

    AppStart := GetTickCount();
    AppLast  := GetTickCount();
    fps:=0;
    winkel:=175;
    winkelmass:=0.1;
    DoubleBuffered:=false;

    bUpdating:=true;
    Sensitivity  := SpinSens.Value;
    SensitivityF := SpinSono.Value;

    doingsettings:=false;
    flag:=true;
    doRec := false;
    yet2sec := false;

    bMouseDown := false;
    silence := 0;
    maxxL := 0;
    maxxR := 0;
    DrawMode.ItemIndex := 1;
    oldLevelL := 0;
    oldLevelR := 0;
    oldLevelLf := 0;
    oldLevelRf := 0;
    oldzwL := 0;
    oldzwR := 0;
    lx2:=0;
    ly2:=0;
    lx1:=0;
    ly1:=0;
    imgcount:=0;
    missingcount:=0;
    
    peakCounter:=0;
    peakL:=0;peakR:=0;
    peakLf:=0;peakRf:=0;
    peakLClip:=false;peakRClip:=false;
    peakLClipf:=false;peakRClipf:=false;

    (*
    UseBkg   := False;
    DrawType := 1;
    dX       :=-1;
    scrollC  := 0;
    xOld     := 0;
    *)

    (**)
    ControlStyle := ControlStyle + [csOpaque];
    style        := GetWindowLong(FormPlayer.Handle, GWL_STYLE);
    SetWinStyle(style,WS_MINIMIZEBOX     ,FALSE);
    SetWinStyle(style,WS_MAXIMIZEBOX     ,FALSE);
    SetWinStyle(style,WS_SYSMENU         ,FALSE);
    SetWinStyle(style,WS_CAPTION         ,FALSE);
    //SetWinStyle(style,WS_OVERLAPPED      ,TRUE); // exstyle ???????????
    SetWinStyle(style,WS_THICKFRAME      ,true);
    SetWindowLong(FormPlayer.Handle, GWL_STYLE  ,   style);
    SetWindowPos(FormPlayer.Handle,HWND_NOTOPMOST, 0,0,0,0,
                    SWP_NOMOVE OR SWP_NOSIZE OR SWP_FRAMECHANGED);
    (**)

    config_read;

    // OpenGL initialisieren
    // gl start (after formstyle!!!)
    // Initialist GL environment variables
    glInit;

    glViewport(0, 0, FormPlayer.ClientWidth, FormPlayer.ClientHeight); // Set the viewport for the OpenGL window
    glMatrixMode(GL_PROJECTION); // Change Matrix Mode to Projection
    glLoadIdentity(); // Reset View
    gluPerspective(45.0, FormPlayer.ClientWidth / FormPlayer.ClientHeight, 1.0, 500.0); // Do the perspective calculations. Last value = max clipping depth
    glMatrixMode(GL_MODELVIEW); // Return to the modelview matrix
    // gl end
    (**)

    bUpdating:=false;
    setSettings; // includes setvars

    samplerate := StrToIntDef(cbSampleRate.Items[cbSampleRate.itemIndex],44100);
    BASS_Init(-1, SampleRate, 0, Application.Handle, nil);
    BASS_Start();
    BASS_RecordInit(0);

    //Channel := BASS_StreamCreateFile(FALSE, PChar('m:\Musik\pic\lena_face.wav'), 0, 0, BASS_SAMPLE_LOOP);
    //ProcessError;
    //Channel := BASS_StreamCreateFile(FALSE, PChar('m:\Musik\pic\lena_face.wav'), 0, 0, BASS_SAMPLE_LOOP);
    //ProcessError;

    //BASS_ChannelPlay(Channel, False);
    //BASS_ChannelSetAttribute(Channel,BASS_ATTRIB_VOL,0);
    //BASS_SetVolume(0);

    (**)
    i := 0;
    dName := BASS_RecordGetInputName(i);
    while dName <> nil do
    begin
      lineslist.Items.Add(StrPas(dName));
      // is this one currently "on"?
      if (BASS_RecordGetInput(i, level) and BASS_INPUT_OFF) = 0 then
      begin
        LinesList.ItemIndex := i;

        // enable it for bass right now
        BASS_RecordSetInput(LinesList.ItemIndex, BASS_INPUT_ON, -1);
        //BASS_RecordSetInput(-1,BASS_INPUT_ON, -1);
        BASS_SetConfig(BASS_CONFIG_REC_BUFFER,1000);
        BASS_SetConfig(BASS_CONFIG_UPDATEPERIOD,TimerRender.Interval);
        //BASS_SetConfig(BASS_CONFIG_UPDATEPERIOD,0); // null and BASS_UPDATE();
        RECORDCHAN := BASS_RecordStart(
            SampleRate,2, // always 2 channels, mono -> BASS_ChannelGetData no INDIVIDUAL-flag
            MAKELONG(0, TimerRender.Interval),
            @RecordCallback,
            nil);

      end;
      Inc(i);
      dName := BASS_RecordGetInputName(i);
    end;
    (**)

    show;
    GetMixerValues(false);
    TimerRender.Enabled := True;

    if FileExists(ParamStr(1)) then
      OpenAndPlayFile(sender,ParamStr(1));

    Application.Title := 'SonoGram 3.5';
    if GetPrivateProfileInt('SonoGram', 'Fullscreen', 0, PChar(inifile))=1 then
      Button2Click(sender); // restore fullscreen

    if GetPrivateProfileInt('SonoGram', 'FreqScaleLog', 6, PChar(inifile))=6 then
      Button24Click(nil); // autoscale on first run

    //Application.BringToFront;
    //FormPlayer.Repaint;
    //FormPlayer.SetFocus;
    //if pOptions.Visible then ffftsize.SetFocus;
    (**)
    //savepath:=tbSavePath;
    //if (LamePath = '') or (savePath = '') then
    tbSavePath.Text:=savepath;
    LamePath:=ExpandFileName(LamePath);
    tbLamePath.Text:=LamePath;
    if (not DirectoryExists(savepath)) or (not FileExists(LamePath)) then 
    begin
        Label16.Caption:='no savepath or lame.exe not found';
        (*
        msgstr := ('In order to be able to record, you must specify the position of the LAME.EXE' +
            Chr(10) + Chr(13) +
            'and the Path, where to save the Files.' +
            Chr(10) + Chr(13) + Chr(10) + Chr(13) +
            'You can change these Settings in the INI-file in the same Directory as the ' +
            ExtractFileName(ParamStr(0)) + '.' +
            Chr(10) + Chr(13) + Chr(10) + Chr(13) +
            'ehmm - Recording: First to a wave-file - this will be encoded if the' +
            Chr(10) + Chr(13) +
            'size-limit is reached. Then the wave-file will be deleted.' +
            Chr(10) + Chr(13) + Chr(10) + Chr(13) +
            'If you cancel, recording will be disabled.');
        if (MessageDlg(msgstr, mtConfirmation, mbOKCancel, 0) = mrOk) then 
        begin
            OpenDialog.Title := 'Search Path for LAME.EXE or Cancel';
            OpenDialog.Filter := '*.exe';
            OpenDialog.FileName := 'lame.exe';
            if OpenDialog.Execute then begin
                LamePath := OpenDialog.FileName;
            end;
            SelectDirectory('Output Directory', '', savePath);
        end;
        *)
    end;
    if (LamePath = '') or (savePath = '') then begin
        cbRec.Enabled := False;
        Edit1.Enabled := False;
        Label22.Enabled := False;
    end;
    (**)
    if pOptions.Visible and LinesList.Enabled then LinesList.SetFocus;

    j:=GetPrivateProfileString('SonoGram','Color1','-1',inistr,sizeof(inistr),PChar(inifile));
    if (inistr='-1') then
    begin
      resetClick(nil);
      Button27Click(nil);
    end;

    // Register Hotkey Ctrl + Alt + Shift + R
    //MYhotkey := GlobalAddAtom('SonoGramHotkey');
    //RegisterHotKey(Handle, MYhotkey, MOD_CONTROL + MOD_Alt + MOD_SHIFT, VK_R);
end;

procedure TFormPlayer.FormMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if (ssRight in shift) then begin
    Button26Click(sender);
  end else
  if (ssLeft in shift) then
  if BorderStyle<>bsNone then
  begin
    bMouseDown := True;
    pX:=X;
    pY:=Y;
    //Cursor:=crSize;
    SetCursor(LoadCursor(0, IDC_SIZEALL));
  end;
end;

procedure TFormPlayer.FormMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
begin
  //if formplayer.BorderStyle<>bsNone then
  //begin
  if (bMouseDown) and (ssleft in shift) and (pX<>-1) and (pY<>-1) then
  begin
    Left:=Left+X-pX;
    Top:=Top+Y-pY;
    Application.ProcessMessages;
    //Cursor:=crSize;
    SetCursor(LoadCursor(0, IDC_SIZEALL));
  end else begin
  (**-)
    if (pX<>X) and (pY<>Y) then
    begin
      pOptions.Visible:=pOptions.tag=1;
      //Hiddenpanel.Visible:=pOptions.Visible;
      //Cursor:=crCross; //crNone
      SetCursor(LoadCursor(0, IDC_CROSS));
      pX:=X;
      pY:=Y;
    end;
  (**)
  end;
end;

procedure TFormPlayer.FormMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if bMouseDown then begin
    pX := -1;
    pY := -1;
    bMouseDown := False;
    //Cursor:=crCross; //crNone
    SetCursor(LoadCursor(0, IDC_CROSS));
  end;
end;

procedure TFormPlayer.showinfo(s: string);
begin
  Canvas.Font.Color := clSilver;
  Canvas.TextOut(FormPlayer.ClientWidth - 150, FormPlayer.ClientHeight - 50, s);
end;

procedure TFormPlayer.pOptionsMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
    pX := -1;
    pY := -1;
end;

procedure TFormPlayer.pOptionsMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if (ssRight in shift) then begin
    Button26Click(sender);
  end else if (ssLeft in shift) then begin
    pX := x;
    pY := y;
  end;
end;

procedure TFormPlayer.pOptionsMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
begin
  if (ssleft in shift) and (pX<>-1) and (pY<>-1) then
  begin
    TPanel(sender).left := TPanel(sender).left + x - pX;
    TPanel(sender).top  := TPanel(sender).top  + y - pY;
    Application.ProcessMessages;
  end;
end;

procedure TFormPlayer.Button2Click(Sender: TObject);
var style:DWORD; // fullscreen toggle
begin
  formplayer.hide;
  if formplayer.BorderStyle=bsNone then
  begin
    formplayer.BorderStyle:=bsSizeable;
    formplayer.SetBounds(wx,wy,ww,wh);
    SetFormStyle;
    pOptions.Visible:=true;
    //Hiddenpanel.Visible:=pOptions.Visible;
    formplayer.show;
  end else begin
    wx:=Left; wy:=Top; ww:=Width; wh:=Height;
    formplayer.SetBounds(0,0,Screen.Width,Screen.Height);
    formplayer.BorderStyle:=bsNone;
    formplayer.show;
    setSettings;
  end;
end;

procedure TFormPlayer.Button26Click(Sender: TObject);
begin
  pOptions.Visible:=not pOptions.Visible;
  if (not pOptions.Visible) and (ColorPosition1.Visible) then
  begin
    Button31Click(sender);
  end;
  if Hiddenpanel.Enabled then
    Hiddenpanel.Visible:=pOptions.Visible;
  if RecPanel.Enabled then
    RecPanel.Visible:=pOptions.Visible;
  pOptions.tag:=integer(pOptions.Visible);
  Application.ProcessMessages;
end;

procedure TFormPlayer.FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if ((Key = VK_RETURN) and (ssAlt in Shift)) then
    Button2Click(Sender); // alt+enter
  if (Key=70) or (key=102) then // f F
    Button2Click(Sender);
  if (Key=77) or (key=109) then // alt+m
    if (ssAlt in shift) then
      mono.Checked:=not mono.Checked;
  if (Key=68) or (key=100) then // alt+d
    if (ssAlt in shift) then
      dblpxl.Checked:=not dblpxl.Checked;
  if (Key=76) or (key=108) then
    if (ssAlt in shift) then // alt+l
      Splitline.Checked:=not Splitline.Checked;
  if (Key=90) or (key=122) then
    if (ssAlt in shift) then // alt+z
      HzInfo.Checked:=not HzInfo.Checked;
  if (Key=71) or (key=103) then
    if (ssAlt in shift) then // alt+g
      RadioGroup1.ItemIndex:=0;
  if (Key=80) or (key=112) then
    if (ssAlt in shift) then // alt+p
      RadioGroup1.ItemIndex:=1;
end;

procedure TFormPlayer.FormKeyPress(Sender: TObject; var Key: Char);
begin
    if (Key = #27) then
      Button26Click(sender);
end;

procedure TFormPlayer.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
    if not (ssShift in Shift) and
        not (ssAlt in Shift) and
        not (ssCtrl in Shift) and
        not (ssLeft in Shift) and
        not (ssRight in Shift) and
        not (ssMiddle in Shift) and
        not (ssDouble in Shift)
        then begin
        if Key = VK_UP then angle := angle - 1;
        if Key = VK_DOWN then angle := angle + 1;
        if Key = VK_LEFT then anglerotate := anglerotate - 1;
        if Key = VK_RIGHT then anglerotate := anglerotate + 1;
    end;
    if (Key = VK_RIGHT) and (ssShift in Shift) then xdist := xdist + 0.1;
    if (Key = VK_LEFT ) and (ssShift in Shift) then xdist := xdist - 0.1;
    if (Key = VK_UP   ) and (ssShift in Shift) then ydist := ydist + 0.1;
    if (Key = VK_DOWN ) and (ssShift in Shift) then ydist := ydist - 0.1;
    if (Key = VK_UP   ) and (ssCtrl  in Shift) then zdist := zdist - 0.1;
    if (Key = VK_DOWN ) and (ssCtrl  in Shift) then zdist := zdist + 0.1;

    if (Key=83) or (key=115) then
      if (ssAlt in Shift) then
        SaveToFile(sender,'');
    if (Key=65) or (key=97) then
      if (ssAlt in Shift) then
        Button24Click(sender);
    if (Key=88) or (key=120) then
      if ((ssAlt in shift) OR (ssCtrl in shift)) then // strg/alt+x
        Close;
    if (Key=83) or (key=115) then
      if (ssAlt in shift) then // strg/alt+x
        SaveToFile(Sender);

    if Key = VK_ADD then //'+' then
        if ScaleB.Position < ScaleB.Max then
            ScaleB.Position := ScaleB.Position + ScaleB.PageSize;

    if Key = VK_SUBTRACT then // '-' then
        if ScaleB.Position > ScaleB.Min then
            ScaleB.Position := ScaleB.Position - ScaleB.PageSize;

    if Key = VK_PRIOR then // '+' then
        if ScaleC.Position > ScaleC.Min then
            ScaleC.Position := ScaleC.Position - ScaleC.PageSize;

    if Key = VK_NEXT then //'-' then
        if ScaleC.Position < ScaleC.Max then
            ScaleC.Position := ScaleC.Position + ScaleC.PageSize;
end;

procedure TFormPlayer.SetFormStyle;
var style   : ULONG;
    exstyle : ULONG;
begin
    style   := GetWindowLong(FormPlayer.Handle, GWL_STYLE);
    SetWinStyle(style,WS_CAPTION,FALSE);
    SetWinStyle(style,WS_THICKFRAME,formplayer.BorderStyle<>bsNone);
    SetWindowLong(formplayer.Handle, GWL_STYLE  ,   style);
    (**-)
    exstyle   := GetWindowLong(foptions.Handle, GWL_EXSTYLE);
    SetWinStyle(style,WS_EX_TRANSPARENT,FALSE);
    SetWindowLong(foptions.Handle, GWL_EXSTYLE  ,   style);
    (**)
    SetWindowPos(formplayer.Handle,HWND_TOP, 0,0,0,0,
                 SWP_NOMOVE OR SWP_NOSIZE OR SWP_FRAMECHANGED);
end;

procedure TFormPlayer.Button3Click(Sender: TObject);
begin Close; end;

procedure TFormPlayer.Button34Click(Sender: TObject);
begin Application.Minimize; end;

procedure TFormPlayer.resetClick(Sender: TObject);
begin
  bUpdating:=true;
  mono.Checked:=true; 
  Scrolling.Checked:=true;
  dblpxl.Checked:=false; 
  Splitline.Checked:=true; 
  HzInfo.Checked:=false; 
  VolLevel.checked:=true;

  PollIntervall.Value:=20; 
  cbSampleRate.ItemIndex:=3;
  fFFTSize.ItemIndex:=4; 
  blur.Value:=0; 
  vumeterwidth.Value:=8;

  FMin.Position:=FMin.Min;
  FMax.Position:=FMin.Max;
  ScaleC.Position:=128;
  ScaleB.Position:=ScaleB.Max; 
  FreqScaleLog.Position:=64; 

  AmplScale1.checked:=true; 
  AmplScale2.checked:=false;
  AmplScale3.checked:=false;
  AmplScale4.checked:=false;
  //Button8Click(sender);
  ColorPosition1.Position:=8;
  ColorPosition2.Position:=16;
  ColorPosition3.Position:=48;
  ColorPosition4.Position:=92;
  ColorPosition5.Position:=224;
  bUpdating:=false;
  setvars;
  MakePaletteGDI;
  //setSettings;
end;

procedure TFormPlayer.config_read;
var W, H, L, T: integer;
    i, j: integer;
    inistr: array[0..259] of char;
    s: string;
    int:double;
begin
    L := -((Height-ClientHeight) div 2);
    T := -((Height-ClientHeight) div 2);
    W := Screen.Width div 3; H := Screen.Height - 100;
    L := GetPrivateProfileInt('SonoGram', 'Screen_x', L, PChar(inifile));
    T := GetPrivateProfileInt('SonoGram', 'Screen_y', T, PChar(inifile));
    W := GetPrivateProfileInt('SonoGram', 'Screen_w', W, PChar(inifile));
    H := GetPrivateProfileInt('SonoGram', 'Screen_h', H, PChar(inifile));
    SetBounds(L, T, W, H);

    pOptions.Top           :=GetPrivateProfileInt('SonoGram', 'OptionsY', 20, PChar(inifile));
    pOptions.Left          :=GetPrivateProfileInt('SonoGram', 'OptionsX', 20, PChar(inifile));
    Hiddenpanel.Top        :=GetPrivateProfileInt('SonoGram', 'RecOptionsY', 40, PChar(inifile));
    Hiddenpanel.Left       :=GetPrivateProfileInt('SonoGram', 'RecOptionsX', 260, PChar(inifile));
    RecPanel.Left          :=GetPrivateProfileInt('SonoGram', 'RecPanelX', 260, PChar(inifile));
    RecPanel.Top           :=GetPrivateProfileInt('SonoGram', 'RecPanelY', 40, PChar(inifile));
    pOptions.Visible       :=GetPrivateProfileInt('SonoGram','OptionsVisible', 1, PChar(inifile))=1;
    Hiddenpanel.Visible    :=pOptions.Visible and Hiddenpanel.Enabled;
    RecPanel.Visible       :=pOptions.Visible and Recpanel.Enabled;

    j := GetPrivateProfileString('SonoGram','XDist', '0',inistr,sizeof(inistr),PChar(inifile));
    xDist:=StrToFloatDef(inistr,0);
    j := GetPrivateProfileString('SonoGram','YDist', '0',inistr,sizeof(inistr),PChar(inifile));
    yDist:=StrToFloatDef(inistr,0);
    j := GetPrivateProfileString('SonoGram','ZDist', '0',inistr,sizeof(inistr),PChar(inifile));
    zDist:=StrToFloatDef(inistr,0);

    ScaleB.Position:=0; // force refresh (set to 128 in delphi-ide)
    ScaleB.Position:=1; // force refresh (set to 128 in delphi-ide)
    FreqScaleLog.position:=1; // force refresh (set to 2 in delphi-ide)
    tbVolume.Position:=50; // force refresh (set to 1 in delphi-ide)
    FMin.Position:=0; // force refresh (set to 0 in delphi-ide)
    FMax.Position:=1; // force refresh (set to 0 in delphi-ide)

    FMin.Position          :=GetPrivateProfileInt('SonoGram','FreqMin', 0, PChar(inifile));
    FMax.Position          :=GetPrivateProfileInt('SonoGram','FreqMax', 100, PChar(inifile));
    cbSampleRate.ItemIndex :=GetPrivateProfileInt('SonoGram','SampleRate', 3, PChar(inifile));;
    ScaleC.Position:=GetPrivateProfileInt('SonoGram','AmplScale2', 128, PChar(inifile));
    ScaleB.Position:=GetPrivateProfileInt('SonoGram','AmplScale', 128, PChar(inifile));
    Scrolling.Checked      :=GetPrivateProfileInt('SonoGram','Scrolling', 1, PChar(inifile))=1;
    FreqScaleLog.Position  :=GetPrivateProfileInt('SonoGram','FreqScaleLog', 64, PChar(inifile));
    ffftsize.ItemIndex     :=GetPrivateProfileInt('Sonogram','FFTSize',4,pchar(inifile));
    offset:=GetPrivateProfileInt('Sonogram','Offset',0,pchar(inifile));
    DrawMode.ItemIndex     :=GetPrivateProfileInt('SonoGram','DrawMode', 1, PChar(inifile));
    SplitLineColorIdx      :=GetPrivateProfileInt('SonoGram','SplitLineColorIdx', 128, PChar(inifile));
    AmplScale1.Checked     :=GetPrivateProfileInt('SonoGram','AmplMode', 0, PChar(inifile))=0;
    AmplScale2.Checked     :=GetPrivateProfileInt('SonoGram','AmplMode', 0, PChar(inifile))=1;
    AmplScale3.Checked     :=GetPrivateProfileInt('SonoGram','AmplMode', 2, PChar(inifile))=2;
    AmplScale4.Checked     :=GetPrivateProfileInt('SonoGram','AmplMode', 0, PChar(inifile))=3;
    blur.Value             :=GetPrivateProfileInt('SonoGram','Blur', 0, PChar(inifile));
    vumeterwidth.Value     :=GetPrivateProfileInt('SonoGram','VUMeterWidth', 8, PChar(inifile));
    Mono.Checked           :=GetPrivateProfileInt('SonoGram','Mono', 1, PChar(inifile))=1;
    SwapChannels.Checked   :=GetPrivateProfileInt('SonoGram','SwapLR', 0, PChar(inifile))=1;
    SplitLine.Checked      :=GetPrivateProfileInt('SonoGram','SplitLine', 1, PChar(inifile))=1;
    HzInfo.Checked         :=GetPrivateProfileInt('SonoGram','HzInfo', 0, PChar(inifile))=1;
    VolLevel.checked       :=GetPrivateProfileInt('SonoGram','VolumeLevel', 1, PChar(inifile))=1;
    dblpxl.Checked         :=GetPrivateProfileInt('SonoGram','DoublePixels', 0, PChar(inifile))=1;
    PollIntervall.Value    :=GetPrivateProfileInt('SonoGram','PollIntv', 20, PChar(inifile));
    TimerRender.Interval   :=PollIntervall.Value;

    // recording
    SpinSono.Value         :=GetPrivateProfileInt('SonoGram','LevelMinimum', 25, PChar(inifile));
    SpinSens.Value         :=GetPrivateProfileInt('SonoGram','LevelCount', 4, PChar(inifile));
    inistr[0] := #0;
    j := GetPrivateProfileString('SonoGram', 'LameOpts', '', inistr, sizeof(inistr), PChar(inifile));
    if inistr[0] <> #0 then begin
        LameOpts := trim(Copy(inistr, 1, j));
        LameOpts := ' ' + LameOpts + ' ';
    end;
    if lameOpts = '' then LameOpts := ' --preset insane ';

    inistr[0] := #0;
    j := GetPrivateProfileString('SonoGram', 'LamePath', '', inistr, sizeof(inistr), PChar(inifile));
    if inistr[0] <> #0 then LamePath := Copy(inistr, 1, j);

    inistr[0] := #0;
    j := GetPrivateProfileString('SonoGram', 'SavePath', '', inistr, sizeof(inistr), PChar(inifile));
    if inistr[0] <> #0 then SavePath := Copy(inistr, 1, j);

    // colors //
    ColorPosition1.Position := GetPrivateProfileInt('SonoGram', 'ColorPosition1', 32, PChar(inifile));
    ColorPosition2.Position := GetPrivateProfileInt('SonoGram', 'ColorPosition2', 64, PChar(inifile));
    ColorPosition3.Position := GetPrivateProfileInt('SonoGram', 'ColorPosition3', 92, PChar(inifile));
    ColorPosition4.Position := GetPrivateProfileInt('SonoGram', 'ColorPosition4', 128, PChar(inifile));
    ColorPosition5.Position := GetPrivateProfileInt('SonoGram', 'ColorPosition5', 160, PChar(inifile));
    tbBrightness.Position:=ColorPosition1.Position;
    tbContrast.Position:=ColorPosition5.Position;

    j := GetPrivateProfileString('SonoGram','ColorPen','$FFFF00',inistr,sizeof(inistr),PChar(inifile));
    if inistr[0]<>#0 then s := Copy(inistr, 1, j);
    if s='' then PanelPen.Color:=$FFFF00 else PanelPen.Color:=StringToColor(s);
    j := GetPrivateProfileString('SonoGram','ColorBG' ,'$000000',inistr,sizeof(inistr),PChar(inifile));
    if inistr[0]<>#0 then s := Copy(inistr, 1, j);
    if s='' then PanelBkg.Color:=$000000 else PanelBkg.Color:=StringToColor(s);
    j := GetPrivateProfileString('SonoGram','Color1', '$000000',inistr,sizeof(inistr),PChar(inifile));
    if inistr[0]<>#0 then s := Copy(inistr, 1, j);
    if s='' then Color1.Color:=$000000 else Color1.Color:=StringToColor(s);
    j := GetPrivateProfileString('SonoGram','Color2', '$2a2a2a',inistr,sizeof(inistr),PChar(inifile));
    if inistr[0]<>#0 then s := Copy(inistr, 1, j);
    if s='' then Color2.Color:=$0080FF else Color2.Color:=StringToColor(s);
    j := GetPrivateProfileString('SonoGram','Color3', '$555555',inistr,sizeof(inistr),PChar(inifile));
    if inistr[0]<>#0 then s := Copy(inistr, 1, j);
    if s='' then Color3.Color:=$FFFFFF else Color3.Color:=StringToColor(s);
    j := GetPrivateProfileString('SonoGram','Color4', '$7f7f7f',inistr,sizeof(inistr),PChar(inifile));
    if inistr[0]<>#0 then s := Copy(inistr, 1, j);
    if s='' then Color4.Color:=$FFFFFF else Color4.Color:=StringToColor(s);
    j := GetPrivateProfileString('SonoGram','Color5', '$aaaaaa',inistr,sizeof(inistr),PChar(inifile));
    if inistr[0]<>#0 then s := Copy(inistr, 1, j);
    if s='' then Color5.Color:=$FFFFFF else Color5.Color:=StringToColor(s);
    j := GetPrivateProfileString('SonoGram','Color6', '$d4d4d4',inistr,sizeof(inistr),PChar(inifile));
    if inistr[0]<>#0 then s := Copy(inistr, 1, j);
    if s='' then Color6.Color:=$FFFFFF else Color6.Color:=StringToColor(s);
    j := GetPrivateProfileString('SonoGram','Color7', '$FFFFFF',inistr,sizeof(inistr),PChar(inifile));
    if inistr[0]<>#0 then s := Copy(inistr, 1, j);
    if s='' then Color7.Color:=$FFFFFF else Color7.Color:=StringToColor(s);
end;

procedure TFormPlayer.config_write;
begin
    if formplayer.BorderStyle=bsnone then begin
    WritePrivateProfileString('SonoGram','Screen_x', PChar(IntToStr(wx)), PChar(inifile));
    WritePrivateProfileString('SonoGram','Screen_y', PChar(IntToStr(wy)), PChar(inifile));
    WritePrivateProfileString('SonoGram','Screen_w', PChar(IntToStr(ww)), PChar(inifile));
    WritePrivateProfileString('SonoGram','Screen_h', PChar(IntToStr(wh)), PChar(inifile));
    end else begin
    WritePrivateProfileString('SonoGram','Screen_x', PChar(IntToStr(FormPlayer.Left)), PChar(inifile));
    WritePrivateProfileString('SonoGram','Screen_y', PChar(IntToStr(FormPlayer.Top)), PChar(inifile));
    WritePrivateProfileString('SonoGram','Screen_w', PChar(IntToStr(FormPlayer.Width)), PChar(inifile));
    WritePrivateProfileString('SonoGram','Screen_h', PChar(IntToStr(FormPlayer.Height)), PChar(inifile));
    end;

    WritePrivateProfileString('SonoGram','XDist', PChar(FloatToStr(xDist)), PChar(inifile));
    WritePrivateProfileString('SonoGram','YDist', PChar(FloatToStr(yDist)), PChar(inifile));
    WritePrivateProfileString('SonoGram','ZDist', PChar(FloatToStr(zDist)), PChar(inifile));
    WritePrivateProfileString('SonoGram','OptionsVisible', PChar(IntToStr(integer(pOptions.Visible))), PChar(inifile));

    
    WritePrivateProfileString('SonoGram','RecPanelX', PChar(IntToStr(RecPanel.Left)), PChar(inifile));
    WritePrivateProfileString('SonoGram','RecPanelY', PChar(IntToStr(RecPanel.Top)), PChar(inifile));
    
    WritePrivateProfileString('SonoGram','OptionsX', PChar(IntToStr(POptions.Left)), PChar(inifile));
    WritePrivateProfileString('SonoGram','OptionsY', PChar(IntToStr(POptions.Top)), PChar(inifile));
    WritePrivateProfileString('SonoGram','RecOptionsX', PChar(IntToStr(Hiddenpanel.Left)), PChar(inifile));
    WritePrivateProfileString('SonoGram','RecOptionsY', PChar(IntToStr(Hiddenpanel.Top)), PChar(inifile));
    WritePrivateProfileString('SonoGram','FullScreen',PChar(IntToStr(integer((w=screen.Width)and(h=screen.height)))), PChar(inifile));
    WritePrivateProfileString('SonoGram','DrawMode', PChar(IntToStr(DrawMode.ItemIndex)),PChar(inifile));
    WritePrivateProfileString('Sonogram','SampleRate',pchar(inttostr(cbSampleRate.ItemIndex)),pchar(inifile));
    WritePrivateProfileString('Sonogram','FFTSize',pchar(inttostr(ffftsize.ItemIndex)),pchar(inifile));
    WritePrivateProfileString('Sonogram','Offset',pchar(inttostr(offset)),pchar(inifile));
    WritePrivateProfileString('Sonogram','Blur',pchar(inttostr(blur.value)),pchar(inifile));
    WritePrivateProfileString('Sonogram','VUMeterWidth',pchar(inttostr(vumeterwidth.value)),pchar(inifile));
    WritePrivateProfileString('SonoGram','FreqMin', PChar(IntToStr(FMin.Position)), PChar(inifile));
    WritePrivateProfileString('SonoGram','FreqMax', PChar(IntToStr(FMax.Position)), PChar(inifile));
    WritePrivateProfileString('SonoGram','PollIntv', PChar(IntToStr(PollIntervall.Value)), PChar(inifile));
    WritePrivateProfileString('SonoGram','AmplScale2', PChar(IntToStr(ScaleC.Position)), PChar(inifile));
    WritePrivateProfileString('SonoGram','AmplScale', PChar(IntToStr(ScaleB.Position)), PChar(inifile));
    WritePrivateProfileString('SonoGram','FreqScaleLog', PChar(IntToStr(FreqscaleLog.Position)), PChar(inifile));
    WritePrivateProfileString('SonoGram','SplitLineColorIdx', PChar(IntToStr(SplitLineColorIdx)),PChar(inifile));

    if      AmplScale1.Checked then WritePrivateProfileString('SonoGram','AmplMode','0', PChar(inifile))
    else if AmplScale2.Checked then WritePrivateProfileString('SonoGram','AmplMode','1', PChar(inifile))
    else if AmplScale3.Checked then WritePrivateProfileString('SonoGram','AmplMode','2', PChar(inifile))
    else if AmplScale4.Checked then WritePrivateProfileString('SonoGram','AmplMode','3', PChar(inifile))
    else                            WritePrivateProfileString('SonoGram','AmplMode','4', PChar(inifile));

    WritePrivateProfileString('SonoGram','Mono'          , PChar(IntToStr(integer(Mono.Checked))), PChar(inifile));
    WritePrivateProfileString('SonoGram','SwapLR'        , PChar(IntToStr(integer(SwapChannels.Checked))), PChar(inifile));
    WritePrivateProfileString('SonoGram','Splitline'     , PChar(IntToStr(integer(Splitline.Checked))), PChar(inifile));
    WritePrivateProfileString('SonoGram','HzInfo'        , PChar(IntToStr(integer(HzInfo.Checked))), PChar(inifile));
    WritePrivateProfileString('SonoGram','DoublePixels'  , PChar(IntToStr(integer(dblpxl.Checked))), PChar(inifile));
    WritePrivateProfileString('SonoGram','VolumeLevel'   , PChar(IntToStr(integer(VolLevel.Checked))), PChar(inifile));
    WritePrivateProfileString('SonoGram','Scrolling'     , PChar(IntToStr(integer(Scrolling.Checked))), PChar(inifile));
    // recording
    WritePrivateProfileString('SonoGram','LamePath', PChar(LamePath), PChar(inifile));
    WritePrivateProfileString('SonoGram','LameOpts', PChar(Trim(LameOpts)), PChar(inifile));
    WritePrivateProfileString('SonoGram','SavePath', PChar(Trim(SavePath)), PChar(inifile));
    WritePrivateProfileString('SonoGram','LevelMinimum', PChar(IntToStr(SpinSono.Value)), PChar(inifile));
    WritePrivateProfileString('SonoGram','LevelCount', PChar(IntToStr(SpinSens.Value)), PChar(inifile));
    // colors
    WritePrivateProfileString('SonoGram', 'ColorPen',PChar(ColorToString(PanelPen.Color )), PChar(inifile));
    WritePrivateProfileString('SonoGram', 'ColorBG' ,PChar(ColorToString(PanelBkg.Color )), PChar(inifile));
    WritePrivateProfileString('SonoGram', 'ColorPosition1', PChar(IntToStr(ColorPosition1.Position)), PChar(inifile));
    WritePrivateProfileString('SonoGram', 'ColorPosition2', PChar(IntToStr(ColorPosition2.Position)), PChar(inifile));
    WritePrivateProfileString('SonoGram', 'ColorPosition3', PChar(IntToStr(ColorPosition3.Position)), PChar(inifile));
    WritePrivateProfileString('SonoGram', 'ColorPosition4', PChar(IntToStr(ColorPosition4.Position)), PChar(inifile));
    WritePrivateProfileString('SonoGram', 'ColorPosition5', PChar(IntToStr(ColorPosition5.Position)), PChar(inifile));
    WritePrivateProfileString('SonoGram', 'Color1'  ,PChar(ColorToString(Color1.Color   )), PChar(inifile));
    WritePrivateProfileString('SonoGram', 'Color2'  ,PChar(ColorToString(Color2.Color   )), PChar(inifile));
    WritePrivateProfileString('SonoGram', 'Color3'  ,PChar(ColorToString(Color3.Color   )), PChar(inifile));
    WritePrivateProfileString('SonoGram', 'Color4'  ,PChar(ColorToString(Color4.Color   )), PChar(inifile));
    WritePrivateProfileString('SonoGram', 'Color5'  ,PChar(ColorToString(Color5.Color   )), PChar(inifile));
    WritePrivateProfileString('SonoGram', 'Color6'  ,PChar(ColorToString(Color6.Color   )), PChar(inifile));
    WritePrivateProfileString('SonoGram', 'Color7'  ,PChar(ColorToString(Color7.Color   )), PChar(inifile));
end;

////////////////////////////////////////////////////////////////////////////////

procedure FarbVerlauf(x:integer; fbegin, fend: TColor; fPos, fAnz: Integer);
var r1,g1,b1,r2,g2,b2,r3,g3,b3: Byte; _fPos: Integer;
begin
  r1:=Byte(fbegin);
  g1:=Byte(fbegin shr 8);
  b1:=Byte(fbegin shr 16);
  r2:=Byte(fend);
  g2:=Byte(fend shr 8);
  b2:=Byte(fend shr 16);
  _fPos:=fAnz-fPos;
  r3:=Round((r1*_fPos+r2*fPos)/fAnz);
  g3:=Round((g1*_fPos+g2*fPos)/fAnz);
  b3:=Round((b1*_fPos+b2*fPos)/fAnz);
  with APalette[x] do begin     {   0 ..  41 }
  rgbBlue :=b3;
  rgbGreen:=g3;
  rgbRed  :=r3;
  end;
  SonoPal [x]    := (b3 shl 16) or (g3 shl 8) or r3;
  glSonoPal[x][0] := r3; glSonoPal[x][1] := g3; glSonoPal[x][2] := b3;
end;

function FarbVerlauf2(x:integer; fbegin, fend: TColor; fPos, fAnz: Integer):TColor;
var r1,g1,b1,r2,g2,b2,r3,g3,b3: Byte; _fPos: Integer;
begin
  r1:=Byte(fbegin);
  g1:=Byte(fbegin shr 8);
  b1:=Byte(fbegin shr 16);
  r2:=Byte(fend);
  g2:=Byte(fend shr 8);
  b2:=Byte(fend shr 16);
  _fPos:=fAnz-fPos;
  r3:=Round((r1*_fPos+r2*fPos)/fAnz);
  g3:=Round((g1*_fPos+g2*fPos)/fAnz);
  b3:=Round((b1*_fPos+b2*fPos)/fAnz);
  result := (b3 shl 16) or (g3 shl 8) or r3;
  glSonoPal[x][0] := r3; glSonoPal[x][1] := g3; glSonoPal[x][2] := b3;
end;

function Darker(color: TColor; val, max: Integer): TColor;
var r,g,b   : integer;
    x:integer;
begin
  b := (Color shr 16) and $FF;
  g := (Color shr 8) and $FF;
  r := (Color and $FF);
  b:=b-Trunc(val/max*255) div 2;
  g:=g-Trunc(val/max*255) div 2;
  r:=r-Trunc(val/max*255) div 2;
  if (r<0) then r:=0;
  if (g<0) then g:=0;
  if (b<0) then b:=0;
  result := (b shl 16) or (g shl 8) or r;
end;

function Lighter(color: TColor; val, max: Integer): TColor;
var r,g,b: word;
begin
  //Color := ColorToRGB(color);
  b := (Color shr 16) and $FF;
  g := (Color shr 8) and $FF;
  r := (Color and $FF);
  b:=b+Trunc(val/max*255) div 2;
  g:=g+Trunc(val/max*255) div 2;
  r:=r+Trunc(val/max*255) div 2;
  if (r>255) then r:=255;
  if (g>255) then g:=255;
  if (b>255) then b:=255;
  result := (b shl 16) or (g shl 8) or r;
end;

(*
function TForm1.Lighter(col1,col2: TColor; val, max: Integer): TColor;
  function farbverlauf(fbegin, fend: TColor; fval, fmax: Integer): TColor;
  var r1,g1,b1,r2,g2,b2,r,g,b: Byte; fval2: Integer;
  begin
    r1:=Byte(fbegin);
    g1:=Byte(fbegin shr 8);
    b1:=Byte(fbegin shr 16);
    r2:=Byte(fend);
    g2:=Byte(fend shr 8);
    b2:=Byte(fend shr 16);
    fval2:=fmax-fval;
    r:=Round((r1*fval2+r2*fval)/fmax);
    g:=Round((g1*fval2+g2*fval)/fmax);
    b:=Round((b1*fval2+b2*fval)/fmax);
    result:=RGB(r,g,b);
  end;
var r1,g1,b1,r2,g2,b2,r,g,b: word;
begin
  result:=farbverlauf(col1,col2,val,max);
end;
*)

function InvertColor(color: TColor): TColor;
var r,g,b: byte;
begin
  //Color := ColorToRGB(color);
  b := (Color shr 16) and $FF;
  g := (Color shr 8) and $FF;
  r := (Color and $FF);
  b := 255 - b;
  g := 255 - g;
  r := 255 - r;
  result := (b shl 16) or (g shl 8) or r;
end;

{ Ermittelt Anzahl der Farben (fr palettenorientierte Bitmaps) }
function GetDInColors(BitCount: Word): Integer;
begin
  case BitCount of
    1, 4, 8: Result := 1 shl BitCount;
  else
    Result := 0;
  end;
end;

procedure TFormPlayer.ChangePalette(ABmp:TBitmap);
var Bfh       : PBitmapFileHeader;
    Bih       : PBitmapInfoHeader;
    Palette   : PbmiColors;
    PalCount  : LongInt;           { Anzahl Paletteneintrge }
    p         : PByte;
begin
    if PaletteStream=nil then exit;
    PaletteStream.Clear;
    ABmp.SaveToStream(PaletteStream);
    p:=PaletteStream.Memory;
    { FileHeader auslesen }
    Bfh:=PBitmapFileHeader(p);
    Inc(p,SizeOf(TBitmapFileHeader));
    { BitmapInfoHeader einlesen }
    Bih:=PBitmapInfoHeader(p);
    Inc(p,SizeOf(TBitmapInfoHeader));
    with Bih^ do begin
      { Palettengre und Position berechnen }
      Palette:=PbmiColors(p);
      PalCount:=GetDInColors(biBitCount);
    end;
    Move(APalette,Palette^,PalCount*SizeOf(TRGBQuad));
    PaletteStream.Seek(0,soFromBeginning);
    ABmp.LoadFromStream(PaletteStream);
end;

procedure TFormPlayer.MakePaletteGDI;
var r, g, b  : byte;
    YVal     : TColor;
    x        : integer;

    pixelpos,x1,x2,y1,y2,dx,dy:integer;
begin
   if bUpdating then exit;
   if VisBuff.width=0 then exit;

   MakePaletteGDI8Bit;
   ChangePalette(Image1.Picture.Bitmap);
   ChangePalette(VisBuff);
   ChangePalette(VisBlack);
   VolColIdx1:=Max(((ColorPosition1.Position+ColorPosition2.Position) div 2)-1,0);
   VolColIdx2:=Min(((ColorPosition4.Position+ColorPosition5.Position) div 2)+1,255);

   DrawPalette(Image1.Picture.Bitmap);
   if pOptions.Visible then
     image1.Refresh;

   (**-)
   PixelPos:=15;
   dx:=trunc(224/256*8);
   dy:=trunc(224/256*8);
   x1:=PixelPos-dx;
   y1:=PixelPos-dy;
   x2:=PixelPos+dx;
   y2:=PixelPos+dy;
   //SetArcDirection(Image1.canvas.Handle,1);
   Image1.canvas.pen.color:=sonopal[128];
   Image1.Canvas.Arc(x1,y1,x2,y2,
                     x2-dx,y1,
                     x1+dx,y2);
   Image1.Canvas.MoveTo(pixelpos,Pixelpos);
   Image1.Canvas.LineTo(x2-dx+1,y1);
   Image1.Canvas.Pen.Color:=sonopal[64];
   Image1.Canvas.MoveTo(pixelpos,Pixelpos);
   Image1.Canvas.LineTo(x1,y1+dy);

   x1:=5+PixelPos-dx;
   x2:=5+PixelPos+dx;
   y1:=PixelPos-dy;
   y2:=PixelPos+dy;
   //Image1.Canvas.Arc(x1   ,  y1,x2   ,y2,
   //                  x2-dx,  y2,x2-dx,y1  );

   //Image1.Canvas.Arc(   0,  0,  10,10,
   //                   5+1, 10,   5, 0);
   Image1.Refresh;
   (**)
end;

procedure TFormPlayer.MakePaletteGDI8Bit;
var r, g, b  : byte;
    YVal,
    c1,c2,c3,c4,c5,c6,c7: TColor;
    x1,x2,p1,p2,p3,p4,p5: integer;
begin
   if bUpdating then exit;
   bUpdating:=true;
   c1:=Color1.color;
   c2:=Color2.color;
   c3:=Color3.color;
   c4:=Color4.Color;
   c5:=Color5.color;
   c6:=Color6.color;
   c7:=Color7.color;
   p1:=ColorPosition1.Position;
   p2:=ColorPosition2.Position;
   p3:=ColorPosition3.Position;
   p4:=ColorPosition4.Position;
   p5:=ColorPosition5.Position;
   (**-) // fps change palette according to volume
   if LevelLF > (16384) then
     c2:=Lighter(Color2.Color, Trunc(LevelL / 32768 * 255), 255)
   else
     c2:=Darker (Color2.Color, Trunc(LevelL / 32768 * 255), 255);
   if LevelLF > (16384) then
     c3:=Lighter(Color3.Color, Trunc(LevelL / 32768 * 255), 255)
   else
     c3:=Darker (Color3.Color, Trunc(LevelL / 32768 * 255), 255);
   if LevelLF > (16384) then
     c4:=Lighter(Color4.Color, Trunc(LevelL / 32768 * 255), 255)
   else
     c4:=Darker (Color4.Color, Trunc(LevelL / 32768 * 255), 255);
   if LevelLF > (16384) then
     c5:=Lighter(Color5.Color, Trunc(LevelL / 32768 * 255), 255)
   else
     c5:=Darker (Color5.Color, Trunc(LevelL / 32768 * 255), 255);
   if LevelLF > (16384) then
     c6:=Lighter(Color6.Color, Trunc(LevelL / 32768 * 255), 255)
   else
     c6:=Darker (Color6.Color, Trunc(LevelL / 32768 * 255), 255);
   if LevelLF > (16384) then
     c7:=Lighter(Color7.Color, Trunc(LevelL / 32768 * 255), 255)
   else
     c7:=Darker (Color7.Color, Trunc(LevelL / 32768 * 255), 255);
   (**)

   for x1:=0 to p1-1 do
   begin
       farbverlauf(x1,c1,C2,x1,p1);
   end;
   x2:=0;
   for x1:=p1 to p2-1 do begin
       farbverlauf(x1,c2,c3,x2,p2-p1+1);
       Inc(x2);
   end;
   x2:=0;
   for x1:=p2 to p3-1 do begin
       farbverlauf(x1,c3,c4,x2,p3-p2+1);
       Inc(x2);
   end;
   x2:=0;
   for x1:=p3 to p4-1 do begin
       farbverlauf(x1,c4,c5,x2,p4-p3+1);
       Inc(x2);
   end;
   x2:=0;
   for x1:=p4 to p5-1 do begin
       farbverlauf(x1,c5,c6,x2,p5-p4+1);
       Inc(x2);
   end;
   x2:=0;
   for x1:=p5 to 255 do begin
       farbverlauf(x1,c6,c7,x2,255-p5+1);
       Inc(x2);
   end;
   bUpdating:=false;
end;

procedure TFormPlayer.DrawPalette(b:TBitmap);
var i, j, x  : Integer;
    val      : integer;
begin
  for i:=0 to b.Width do begin
    val := Round((i/b.Width) * 256);
    for j:=0 to b.Height-1 do begin
        //b.Canvas.Pixels[i,j] := SonoPal[val];
        b.Canvas.Pixels[i,j] := RGB(trunc(glSonoPal[val][0]),trunc(glSonoPal[val][1]),trunc(glSonoPal[val][2]));
    end;
  end;
  //image1.Canvas.pen.Mode:=pmXor;
  //image1.Canvas.pen.Mode:=pmCopy;
  //image1.Canvas.pen.Mode:=pmNotMerge;
  //image1.Canvas.Pen.Color:=invertcolor(sonopal[SplitLineColorIdx]);
  //image1.Canvas.MoveTo(SplitLineColorIdx,0);
  //image1.Canvas.LineTo(SplitLineColorIdx,image1.Height);
  PatBlt(image1.Canvas.Handle, SplitLineColorIdx, 0, 1, image1.Height, PATINVERT);
  image1.Canvas.pen.Mode:=pmCopy;
end;

procedure TFormPlayer.DrawPalette2(b:TBitmap);
var i, j, x  : Integer;
    val      : integer;
begin
  for i:=0 to b.Height do begin
    if i=b.Height then
      val := Round((i/b.Height) * 255);
    val := Round((i/b.Height) * 255);
    for j:=0 to 10 do begin
        //b.Canvas.Pixels[j,i] := SonoPal[val];
        b.Canvas.Pixels[i,j] := RGB(trunc(glSonoPal[val][0]),trunc(glSonoPal[val][1]),trunc(glSonoPal[val][2]));
    end;
  end;
end;

procedure TFormPlayer.opt2Click(Sender: TObject);
begin
  //setvars;  //includes setvars
end;

procedure TFormPlayer.DrawModeClick(Sender: TObject);
begin
if drawmode.ItemIndex=1 then vumeterwidth.Enabled:=true else vumeterwidth.Enabled:=false;
if drawmode.ItemIndex=1 then VolLevel.Enabled:=true else VolLevel.Enabled:=false;
setSettings;
end;

procedure TFormPlayer.FormResize(Sender: TObject);
begin setSettings; end;

procedure TFormPlayer.TrackOffChange(Sender: TObject);
begin setSettings; end;

procedure TFormPlayer.TrackResChange(Sender: TObject);
begin setSettings; end;

procedure TFormPlayer.SpinPeakFallChange(Sender: TObject);
begin setSettings; end;

procedure TFormPlayer.RadioDrawClick(Sender: TObject);
begin setSettings; end;

procedure TFormPlayer.TrackRadChange(Sender: TObject);
begin setSettings; end;

procedure TFormPlayer.SpecTrackWidthChange(Sender: TObject);
begin setSettings; end;

procedure TFormPlayer.SpinLineFallChange(Sender: TObject);
begin setSettings; end;

procedure TFormPlayer.SplitlineClick(Sender: TObject);
begin setVars; end;

procedure TFormPlayer.ScalingClick(Sender: TObject);
begin setVars; end;

procedure TFormPlayer.dblpxlClick(Sender: TObject);
begin setvars; end;

procedure TFormPlayer.fFFTSizeChange(Sender: TObject);
begin setvars; end;

procedure TFormPlayer.vumeterwidthChange(Sender: TObject);
begin setVars; end;

procedure TFormPlayer.MonoClick(Sender: TObject);
begin
  if mono.Checked then SwapChannels.Enabled:=false else SwapChannels.Enabled:=true;
  //if mono.Checked then VolLevel.Enabled:=false else VolLevel.Enabled:=true;
  //if mono.Checked then vumeterwidth.Enabled:=false else vumeterwidth.Enabled:=true;
  setVars;
end;

procedure TFormPlayer.FMaxChange(Sender: TObject);
begin
  if FMin.Position>FMax.Position-1 then FMin.Position:=FMax.Position-1;
  setvars;
end;

procedure TFormPlayer.FMinChange(Sender: TObject);
begin
  if FMax.Position<FMin.Position+1 then FMax.Position:=FMin.Position+1;
  lbTB1.Caption:=inttostr(TrackBar1.Position);
  lbTB2.Caption:=inttostr(effect1.Position);
  lbTB3.Caption:=inttostr(effect2.Position);
  setvars;
end;

procedure TFormPlayer.SpinEditChange(Sender: TObject);
begin
  if (StrToFloatDef(TSpinEdit(Sender).Text,-999.999))=-999.999 then exit;
  if TSpinEdit(Sender).Text = '' then exit;
  setVars;
end;

procedure TFormPlayer.FreqScaleLogChange(Sender: TObject);
begin
  if FreqScaleLog.Position>1 then
  Label9.Caption:=FloatToStrf(1+FreqScaleLog.Position/256,ffNumber,12,3)+'  -  logarithmic'
  else
  Label9.Caption:='1  -  linear';
  if FreqScaleLog.Tag<>FreqScaleLog.Position then
    setVars;
  FreqScaleLog.Tag:=FreqScaleLog.Position;
end;

procedure TFormPlayer.VolLevelClick(Sender: TObject);
begin
  setVars;
end;

procedure TFormPlayer.SnapshotTimerTimer(Sender: TObject);
begin
  SnapshotTimer.enabled:=false;
  SaveToFile(Sender);
end;

procedure TFormPlayer.Image1MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  SplitLineColorIdx:=x;
  DrawPalette(Image1.Picture.Bitmap);
end;

procedure TFormPlayer.Button1Click(Sender: TObject);
begin OpenAndPlayFile(sender,''); end;

procedure TFormPlayer.Button23Click(Sender: TObject);
begin FreqScaleLog.Position:=FreqScaleLog.min; end;
procedure TFormPlayer.Button35Click(Sender: TObject);
begin FreqScaleLog.Position:=FreqScaleLog.max div 8; end;
procedure TFormPlayer.Button32Click(Sender: TObject);
begin FreqScaleLog.Position:=FreqScaleLog.max div 4; end;
procedure TFormPlayer.Button36Click(Sender: TObject);
begin FreqScaleLog.Position:=FreqScaleLog.max div 4      + FreqScaleLog.max div 8; end;
procedure TFormPlayer.Button28Click(Sender: TObject);
begin FreqScaleLog.Position:=FreqScaleLog.max div 2; end;
procedure TFormPlayer.Button37Click(Sender: TObject);
begin FreqScaleLog.Position:=FreqScaleLog.max div 2      + FreqScaleLog.max div 8; end;
procedure TFormPlayer.Button33Click(Sender: TObject);
begin FreqScaleLog.Position:=(FreqScaleLog.max div 4)*3; end;
procedure TFormPlayer.Button38Click(Sender: TObject);
begin FreqScaleLog.Position:=(FreqScaleLog.max div 4)*3  + FreqScaleLog.max div 8; end;
procedure TFormPlayer.Button29Click(Sender: TObject);
begin FreqScaleLog.Position:=FreqScaleLog.max; end;

procedure TFormPlayer.btnsaveClick(Sender: TObject);
begin
  SaveToFile(Sender);
end;

////////////////////////////////////////////////////////////////////////////////
// colorstuff //////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

procedure TFormPlayer.PanelBkgClick(Sender: TObject);
begin
    ColorDialog.Color := PanelBkg.Color;
    if not ColorDialog.Execute then Exit;
    PanelBkg.Color := ColorDialog.Color;
    MakePaletteGDI;
end;

procedure TFormPlayer.PanelPenClick(Sender: TObject);
begin
    ColorDialog.Color := PanelPen.Color;
    if not ColorDialog.Execute then Exit;
    PanelPen.Color := ColorDialog.Color;
    MakePaletteGDI;
end;

procedure TFormPlayer.Color1MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if ssRight in Shift then
  begin
    if (Sender=Color1) then
    begin
      color2.Color:=FarbVerlauf2(43,color1.Color,color4.Color,43,128);
      color3.Color:=FarbVerlauf2(85,color1.Color,color4.Color,85,128);
      MakePaletteGDI;
    end;
    if (Sender=Color7) then
    begin
      color5.Color:=FarbVerlauf2(43,color4.Color,color7.Color,43,128);
      color6.Color:=FarbVerlauf2(85,color4.Color,color7.Color,85,128);
      MakePaletteGDI;
    end;
    if (Sender=Color4) then
    begin
      Color1MouseDown(color1,mbRight,[ssright],1,1);
      Color1MouseDown(color7,mbRight,[ssright],1,1);
      MakePaletteGDI;
    end;
  end;
end;

procedure TFormPlayer.ColorChooser(Sender: TObject);
begin
    CurrentPanel:=TPanel(Sender);
    ColorTimer.Enabled:=TRUE;
    ColorDialog.Color := TPanel(Sender).Color;
    if ColorDialog.Execute then begin
       TPanel(sender).Color := ColorDialog.Color;
    end;
    ColorTimer.Enabled:=FALSE;
    MakePaletteGDI;
end;

procedure TFormPlayer.ColorPosition1Change(Sender: TObject);
begin
    if bUpdating then exit;
    if ColorPosition2.Position<ColorPosition1.Position then
        ColorPosition2.Position:=ColorPosition1.Position+1;
    bUpdating:=true;
    tbBrightness.Position:=ColorPosition1.Position;
    bUpdating:=false;
    MakePaletteGDI;
end;

procedure TFormPlayer.ColorPosition2Change(Sender: TObject);
begin
    if bUpdating then exit;
    if ColorPosition1.Position>ColorPosition2.Position then
        ColorPosition1.Position:=ColorPosition2.Position+1;
    if ColorPosition3.Position<ColorPosition2.Position then
        ColorPosition3.Position:=ColorPosition2.Position+1;
    MakePaletteGDI;
end;

procedure TFormPlayer.ColorPosition3Change(Sender: TObject);
begin
    if bUpdating then exit;
    if ColorPosition2.Position>ColorPosition3.Position then
        ColorPosition2.Position:=ColorPosition3.Position+1;
    if ColorPosition4.Position<ColorPosition3.Position then
        ColorPosition4.Position:=ColorPosition3.Position+1;
    MakePaletteGDI;
end;

procedure TFormPlayer.ColorPosition4Change(Sender: TObject);
begin
    if bUpdating then exit;
    if ColorPosition3.Position>ColorPosition4.Position then
        ColorPosition3.Position:=ColorPosition4.Position+1;
    if ColorPosition5.Position<ColorPosition4.Position then
        ColorPosition5.Position:=ColorPosition4.Position+1;
    MakePaletteGDI;
end;

procedure TFormPlayer.ColorPosition5Change(Sender: TObject);
begin
    if bUpdating then exit;
    if ColorPosition4.Position>ColorPosition5.Position then
        ColorPosition4.Position:=ColorPosition5.Position+1;
    bUpdating:=true;
    tbContrast.Position:=ColorPosition5.Position;
    bUpdating:=false;
    MakePaletteGDI;
end;

procedure TFormPlayer.tbContrastChange(Sender: TObject);
begin // 2 contrast
if bUpdating then exit;
bUpdating:=true;
ColorPosition1.Position:=tbBrightness.Position;
ColorPosition2.Position:=tbBrightness.Position+((tbContrast.Position-tbBrightness.Position) div 4);
ColorPosition3.Position:=tbBrightness.Position+((tbContrast.Position-tbBrightness.Position) div 4)*2;
ColorPosition4.Position:=tbBrightness.Position+((tbContrast.Position-tbBrightness.Position) div 4)*3;
ColorPosition5.Position:=tbContrast.Position;
if tbBrightness.Position>tbContrast.Position then
  tbBrightness.Position:=tbContrast.Position
else
  tbBrightness.Position:=ColorPosition1.Position;
bUpdating:=false;
MakePaletteGDI;
end;

procedure TFormPlayer.tbBrightnessChange(Sender: TObject);
begin // 1 brightness
if bUpdating then exit;
bUpdating:=true;
ColorPosition1.Position:=tbBrightness.Position;
ColorPosition2.Position:=tbBrightness.Position+((tbContrast.Position-tbBrightness.Position) div 4);
ColorPosition3.Position:=tbBrightness.Position+((tbContrast.Position-tbBrightness.Position) div 4)*2;
ColorPosition4.Position:=tbBrightness.Position+((tbContrast.Position-tbBrightness.Position) div 4)*3;
ColorPosition5.Position:=tbContrast.Position;
if tbContrast.Position<tbBrightness.Position then
  tbContrast.Position:=tbBrightness.Position
else
  tbContrast.Position:=ColorPosition5.Position;
bUpdating:=false;
MakePaletteGDI;
end;

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////






































procedure TFormPlayer.Button31Click(Sender: TObject);
begin // color position preset 4
  if ColorPosition1.Visible then begin
    pOptions.Height:=GroupBox3.Top + button31.Top + button31.Height+20;
    GroupBox3.Height:=129;
  end else begin
    pOptions.Height:=GroupBox3.Top + button31.Top + button31.Height+89;
    GroupBox3.Height:=201;
  end;
  ColorPosition1.Visible:=not ColorPosition1.Visible;
  ColorPosition2.Visible:=not ColorPosition2.Visible;
  ColorPosition3.Visible:=not ColorPosition3.Visible;
  ColorPosition4.Visible:=not ColorPosition4.Visible;
  ColorPosition5.Visible:=not ColorPosition5.Visible;
end;

procedure TFormPlayer.Button10Click(Sender: TObject);
begin // color position preset 5
bUpdating:=true;
ColorPosition1.Position:=42;
ColorPosition2.Position:=84;
ColorPosition3.Position:=126;
ColorPosition4.Position:=168;
ColorPosition5.Position:=210;
tbBrightness.Position:=ColorPosition1.Position;
tbContrast.Position:=ColorPosition5.Position;
bUpdating:=false;
MakePaletteGDI;
end;

procedure TFormPlayer.Button39Click(Sender: TObject);
begin // color position preset 6
bUpdating:=true;
if not ColorPosition5.Visible then
  Button31Click(sender);
if ColorPosition2.Position>ColorPosition1.Position+1 then ColorPosition2.Position:=ColorPosition2.Position-max(1,abs(((ColorPosition2.Position-ColorPosition1.Position) div 4)));
if ColorPosition3.Position>ColorPosition2.Position+1 then ColorPosition3.Position:=ColorPosition3.Position-max(1,abs(((ColorPosition3.Position-ColorPosition2.Position) div 4)));
if ColorPosition4.Position>ColorPosition3.Position+1 then ColorPosition4.Position:=ColorPosition4.Position-max(1,abs(((ColorPosition4.Position-ColorPosition3.Position) div 4)));
bUpdating:=false;
//ColorPosition1.Position:=12;
//ColorPosition5.Position:=160;
MakePaletteGDI;
end;

procedure TFormPlayer.Button40Click(Sender: TObject);
begin // color position preset 7
bUpdating:=true;
if not ColorPosition5.Visible then
  Button31Click(sender);
if ColorPosition3.Position>ColorPosition2.Position then ColorPosition2.Position:=ColorPosition2.Position+max(1,abs(((ColorPosition3.Position-ColorPosition2.Position) div 4)));
if ColorPosition4.Position>ColorPosition3.Position then ColorPosition3.Position:=ColorPosition3.Position+max(1,abs(((ColorPosition4.Position-ColorPosition3.Position) div 4)));
if ColorPosition5.Position>ColorPosition4.Position then ColorPosition4.Position:=ColorPosition4.Position+max(1,abs(((ColorPosition5.Position-ColorPosition4.Position) div 4)));
bUpdating:=false;
//ColorPosition1.Position:=12;
//ColorPosition5.Position:=160;
MakePaletteGDI;
end;

procedure TFormPlayer.Button8Click(Sender: TObject);
begin // small
bUpdating:=true;
ColorPosition1.Position:=32;
ColorPosition2.Position:=64;
ColorPosition3.Position:=92;
ColorPosition4.Position:=128;
ColorPosition5.Position:=160;
tbBrightness.Position:=ColorPosition1.Position;
tbContrast.Position:=ColorPosition5.Position;
bUpdating:=false;
MakePaletteGDI;
end;

procedure TFormPlayer.Button11Click(Sender: TObject);
begin // smaller
bUpdating:=true;
ColorPosition1.Position:=16;
ColorPosition2.Position:=32;
ColorPosition3.Position:=48;
ColorPosition4.Position:=64;
ColorPosition5.Position:=80;
tbBrightness.Position:=ColorPosition1.Position;
tbContrast.Position:=ColorPosition5.Position;
bUpdating:=false;
MakePaletteGDI;
end;

procedure TFormPlayer.Button7Click(Sender: TObject);
begin // smallest
bUpdating:=true;
ColorPosition1.Position:=12;
ColorPosition2.Position:=24;
ColorPosition3.Position:=36;
ColorPosition4.Position:=48;
ColorPosition5.Position:=60;
tbBrightness.Position:=ColorPosition1.Position;
tbContrast.Position:=ColorPosition5.Position;
bUpdating:=false;
MakePaletteGDI;
end;

procedure TFormPlayer.Button12Click(Sender: TObject);
begin // tiny
bUpdating:=true;
ColorPosition1.Position:=8;
ColorPosition2.Position:=16;
ColorPosition3.Position:=24;
ColorPosition4.Position:=32;
ColorPosition5.Position:=40;
tbBrightness.Position:=ColorPosition1.Position;
tbContrast.Position:=ColorPosition5.Position;
bUpdating:=false;
MakePaletteGDI;
end;

procedure TFormPlayer.Button9Click(Sender: TObject);
var c1,c2,c3:tcolor;
begin // invert
c1:=color1.Color;
c2:=color2.Color;
c3:=color3.Color;
color1.Color:=color7.Color;
color2.Color:=color6.Color;
color3.Color:=color5.Color;
color5.Color:=c3;
color6.Color:=c2;
color7.Color:=c1;
MakePaletteGDI;
end;

procedure TFormPlayer.Button22Click(Sender: TObject);
var c1:tcolor;
begin // shift left
c1:=color1.Color;
color1.Color:=color2.Color;
color2.Color:=color3.Color;
color3.Color:=color4.Color;
color4.Color:=color5.Color;
color5.Color:=color6.Color;
color6.Color:=color7.Color;
color7.Color:=c1;
MakePaletteGDI;
end;

procedure TFormPlayer.Button30Click(Sender: TObject);
var c1:tcolor;
begin // shift right
c1:=color7.Color;
color7.Color:=color6.Color;
color6.Color:=color5.Color;
color5.Color:=color4.Color;
color4.Color:=color3.Color;
color3.Color:=color2.Color;
color2.Color:=color1.Color;
color1.Color:=c1;
MakePaletteGDI;
end;

procedure TFormPlayer.Button13Click(Sender: TObject);
var r,g,b:integer;
begin // random palette
//r:=random(255);
//g:=random(255);
//b:=random(255);
//color2.Color:=((random(r  ) shl 16) or (random(r  ) shl 8) or random(g  ));
//color3.Color:=((random(r  ) shl 16) or (random(g  ) shl 8) or random(g  ));
//color5.Color:=((random(g  ) shl 16) or (random(g  ) shl 8) or random(b  ));
//color6.Color:=((random(g  ) shl 16) or (random(b  ) shl 8) or random(b  ));

if random(255)<128 then r:=random(192) else r:=240+random(16);
if r<127 then g:=random(r*2) else g:=240+random(r);
if g<127 then b:=random(g*2) else b:=240+random(g);
color1.Color:=((random(r  ) shl 16) or (random(g  ) shl 8) or random(b  ));

if r+g+b> 3*128 then r:=random(192) else r:=240+random(16);
if r<127 then g:=random(r*2) else g:=240+random(r);
if g<127 then b:=random(g*2) else b:=240+random(g);
color2.Color:=((random(r  ) shl 16) or (random(g  ) shl 8) or random(b  ));

if r+g+b> 3*128 then r:=random(192) else r:=240+random(16);
if r<127 then g:=random(r*2) else g:=240+random(r);
if g<127 then b:=random(g*2) else b:=240+random(g);
color3.Color:=((random(r  ) shl 16) or (random(g  ) shl 8) or random(b  ));

if r+g+b> 3*128 then r:=random(192) else r:=240+random(16);
if r<127 then g:=random(r*2) else g:=240+random(r);
if g<127 then b:=random(g*2) else b:=240+random(g);
color4.Color:=((random(r  ) shl 16) or (random(g  ) shl 8) or random(b  ));

if r+g+b> 3*128 then r:=random(192) else r:=240+random(16);
if r<127 then g:=random(r*2) else g:=240+random(r);
if g<127 then b:=random(g*2) else b:=240+random(g);
color5.Color:=((random(r  ) shl 16) or (random(g  ) shl 8) or random(b  ));

if r+g+b> 3*128 then r:=random(192) else r:=240+random(16);
if r<127 then g:=random(r*2) else g:=240+random(r);
if g<127 then b:=random(g*2) else b:=240+random(g);
color6.Color:=((random(r  ) shl 16) or (random(g  ) shl 8) or random(b  ));

if r+g+b> 3*128 then r:=random(192) else r:=240+random(16);
if r<127 then g:=random(r*2) else g:=240+random(r);
if g<127 then b:=random(g*2) else b:=240+random(g);
color7.Color:=((random(r  ) shl 16) or (random(g  ) shl 8) or random(b  ));
//Color1MouseDown(color1,mbRight,[ssright],1,1);
//Color1MouseDown(color7,mbRight,[ssright],1,1);
MakePaletteGDI;
end;

procedure TFormPlayer.Button6Click(Sender: TObject);
begin color1.Color:=clBlack; // black/white
color2.Color:=$2a2a2a;
color3.Color:=$555555;
color4.Color:=$7f7f7f;
color5.Color:=$aaaaaa;
color6.Color:=$d4d4d4;
color7.Color:=$FFFFFF;
MakePaletteGDI; end;

procedure TFormPlayer.Button14Click(Sender: TObject);
begin color1.Color:=clBlack; // red
color2.Color:=$000056;
color3.Color:=$0000AA;
color4.Color:=clRed;
color5.Color:=$5656FF;
color6.Color:=$AAAAFF;
color7.Color:=$FFFFFF;
MakePaletteGDI; end;

procedure TFormPlayer.Button27Click(Sender: TObject);
begin color1.Color:=clBlack; // energy/orange/gold
color2.Color:=$000677;
color3.Color:=$002BBB;
color4.Color:=$0077FF;
color5.Color:=$55CCFF;
color6.Color:=$AAFFFF;
color7.Color:=$FFFFFF;
MakePaletteGDI;
end;

procedure TFormPlayer.Button17Click(Sender: TObject);
begin color1.Color:=clBlack; // Yellow
color2.Color:=$005555;
color3.Color:=$00aaaa;
color4.Color:=$00ffff;
color5.Color:=$55FFFF;
color6.Color:=$aaFFFF;
color7.Color:=$FFFFFF;
MakePaletteGDI; end;

procedure TFormPlayer.Button15Click(Sender: TObject);
begin color1.Color:=clBlack; // green
color2.Color:=$003300;
color3.Color:=$006600;
color4.Color:=clgreen;
color5.Color:=$66AA66;
color6.Color:=$aaDDAA;
color7.Color:=$FFFFFF;
MakePaletteGDI; end;

procedure TFormPlayer.Button16Click(Sender: TObject);
begin color1.Color:=clBlack; // blue
color2.Color:=$660000;
color3.Color:=$aa0000;
color4.Color:=clblue;
color5.Color:=$ff6666;
color6.Color:=$FFaaaa;
color7.Color:=$FFFFFF;
MakePaletteGDI; end;

procedure TFormPlayer.Button18Click(Sender: TObject);
begin color1.Color:=clBlack; // Violett
color2.Color:=$550055;
color3.Color:=$aa00aa;
color4.Color:=$FF00FF;
color5.Color:=$FF55FF;
color6.Color:=$FFaaFF;
color7.Color:=$FFFFFF;
MakePaletteGDI; end;

procedure TFormPlayer.Button5Click(Sender: TObject);
begin color1.Color:=$000000; // 1 - sun
color2.Color:=$401030;
color3.Color:=$800080;
color4.Color:=$0000FF;
color5.Color:=$0080FF;
color6.Color:=$00FFFF;
color7.Color:=$FFFFFF;
MakePaletteGDI; end;

procedure TFormPlayer.Button19Click(Sender: TObject);
begin color1.Color:=$220011; // 2 - light midtones / pastell
color2.Color:=$404000;
color3.Color:=$00CC10;
color4.Color:=$10FFE0;
color5.Color:=$0080FF;
color6.Color:=$000080;
color7.Color:=$000000;
MakePaletteGDI; end;

procedure TFormPlayer.Button20Click(Sender: TObject);
begin color1.Color:=$FF0080; // 3 - rainbow
color2.Color:=clBlue;
color3.Color:=clAqua;
color4.Color:=clLime;
color5.Color:=clYellow;
color6.Color:=$0080FF;
color7.Color:=clRed;
MakePaletteGDI; end;

procedure TFormPlayer.Button21Click(Sender: TObject);
begin color1.Color:=$83C8CD; // 4 - light jungle
color2.Color:=$1A281D;
color3.Color:=$006000;
color4.Color:=$0090FF;
color5.Color:=$0000FF;
color6.Color:=$000080;
color7.Color:=$000000;
MakePaletteGDI; end;

procedure TFormPlayer.Button25Click(Sender: TObject);
begin Color1.Color:=$FFFF80; // 5 - light background
Color2.Color:=$505027;
Color3.Color:=clBlack;
Color4.Color:=$000040;
Color5.Color:=clRed;
Color6.Color:=$4080FF;
Color7.Color:=clWhite;
MakePaletteGDI; end;

(*************************************************************************************)
(*************************************************************************************)
(*************************************************************************************)
(*************************************************************************************)
(*************************************************************************************)
(*************************************************************************************)
(*************************************************************************************)
(*************************************************************************************)
(*************************************************************************************)
(*************************************************************************************)
(*************************************************************************************)

procedure TFormPlayer.SaveToFile(Sender: TObject; filename: string='');
var fn:string;
    dtset:TFormatSettings;
begin
  if filename='' then begin
    GetLocaleFormatSettings(GetThreadLocale,dtset);
    dtset.LongDateFormat:='YYMMDD';
    dtset.ShortDateFormat:='YYMMDD';
    dtset.LongTimeFormat:='HHMMSS';
    dtset.ShortTimeFormat:='HHMMSS';
    fn:=progdir+'sonogram_'+DateToStr(now,dtset)+'_'+TimeToStr(now,dtset)+'.bmp';
  end;
  visbuff.SaveToFile(fn);
end;

procedure TFormPlayer.Edit1KeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if (Key = VK_RETURN) then T2.Enabled := not T2.Enabled;
  Led1.OnColor:=$0088ff;
  Led1.LedOn:=T2.Enabled;
  btRec.Enabled:=not T2.Enabled;
end;

procedure TFormPlayer.Edit1Change(Sender: TObject);
begin
  T2.Enabled := false;
  seconds := 0;
end;

procedure TFormPlayer.T2Timer(Sender: TObject);
var t_diff, minutes, sec: longint;
    ssec: string;
begin
    Inc(seconds);
    if (Edit1.Text = '') then exit;
    t_diff := StrToInt(Edit1.Text) * 60 - seconds;
    sec := t_diff mod 60;
    ssec := IntToStr(sec);
    if Length(ssec) < 2 then
        ssec := '0' + ssec;
    minutes := (t_diff - sec) div 60;
    Label21.Caption := 'timer: '+IntToStr(minutes) + ':' + ssec;
    if (seconds = StrToInt(Edit1.Text) * 60) then begin
        T2.Enabled := False;
        Led1.OnColor:=$ff0000;
        btRec.Enabled:=true;
        btRecClick(sender);
    end;
end;

////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////

// Draw The Blurred Image
procedure DrawBlur(const times : Integer; const inc : glFloat);
var spost, alpha, alphainc : glFloat;
    I : Integer;
begin
  alpha := 0.2;

  glEnable(GL_TEXTURE_2D);		   	// Enable 2D Texture Mapping
  glDisable(GL_DEPTH_TEST);		   	// Disable Depth Testing
  glBlendFunc(GL_SRC_ALPHA,GL_ONE);	   	// Set Blending Mode
  glEnable(GL_BLEND);			   	// Enable Blending
  glBindTexture(GL_TEXTURE_2D,BlurTexture);	// Bind To The Blur Texture
  //ViewOrtho();				   	// Switch To An Ortho View

  alphainc := alpha / times;		   	// alphainc=0.2f / Times To Render Blur

  glBegin(GL_QUADS);			   	// Begin Drawing Quads
    // Number Of Times To Render Blur
    For I :=0 to times-1 do
    begin
      glColor4f(1.0, 1.0, 1.0, alpha);	        // Set The Alpha Value (Starts At 0.2)
      glTexCoord2f(0+spost,1-spost);		// Texture Coordinate	( 0, 1 )
      glVertex2f(0,0);		              	// First Vertex		(   0,   0 )

      glTexCoord2f(0+spost,0+spost);		// Texture Coordinate	( 0, 0 )
      glVertex2f(0,480);			// Second Vertex	(   0, 480 )

      glTexCoord2f(1-spost,0+spost);		// Texture Coordinate	( 1, 0 )
      glVertex2f(640,480);			// Third Vertex		( 640, 480 )

      glTexCoord2f(1-spost,1-spost);		// Texture Coordinate	( 1, 1 )
      glVertex2f(640,0);			// Fourth Vertex	( 640,   0 )

      spost := spost + inc; 			// Gradually Increase spost (Zooming Closer To Texture Center)
      alpha := alpha - alphainc;		// Gradually Decrease alpha (Gradually Fading Image Out)
    end;
  glEnd();					// Done Drawing Quads

  //ViewPerspective();				// Switch To A Perspective View

  glEnable(GL_DEPTH_TEST);			// Enable Depth Testing
  glDisable(GL_TEXTURE_2D);			// Disable 2D Texture Mapping
  glDisable(GL_BLEND);				// Disable Blending
  glBindTexture(GL_TEXTURE_2D,0);		// Unbind The Blur Texture
end;

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

{}
procedure TFormPlayer.VUBox(X, Y, Z, Value: glFloat; lX, lY, lZ: glFloat; yval: byte);
var C, F: glFloat;
    R, G, B: glFloat;
    maxh:GLfloat;
begin
    C := (11.75 (*+ X*)) / 55; // amount of color to fade by as we go to the right
    F := (21.75 (*-Z *)) / 60; // amount of fade to black as we go back
    (**)
    R:=glSonoPal[yval][0]/100;
    G:=glSonoPal[yval][1]/100;
    B:=glSonoPal[yval][2]/100;
    (**)
    //R := C - F; // RED
    //G := C - F; // GREEN
    //B := 1 - F; // BLUE

    //GLQuadStrip
    glBegin(GL_QUADS);
    (**-)
    // front
    glColor3f(0, 0, 0);
      glVertex3f(X    , Y, Z);
      glVertex3f(X+1.0, Y, Z);
      glColor3f(Value/100+R, G, B-Value/100);   // VUBars = values 0 - 10
      glVertex3f(X+1.0, Y+Value, Z);
      glVertex3f(X    , Y+Value, Z);
    // left
    glColor3f(0, 0, 0);
      glVertex3f(X, Y, Z-1.0);
      glVertex3f(X, Y,     Z);
      glColor3f(Value/100+R, G, B-Value/100);
      glVertex3f(X, Y+Value, Z);
      glVertex3f(X, Y+Value, Z-1.0);
    // back
    glColor3f(0, 0, 0);
      glVertex3f(X+1.0, Y, Z-1.0);
      glVertex3f(X,   Y, Z-1.0);
      glColor3f(Value/100+R, G, B-Value/100);
      glVertex3f(X,   Y+Value, Z-1.0);
      glVertex3f(X+1.0, Y+Value, Z-1.0);
    // right
    glColor3f(0, 0, 0);
      glVertex3f(X+1.0, Y, Z);
      glVertex3f(X+1.0, Y, Z-1.0);
      glColor3f(Value/100+R, G, B-Value/100);
      glVertex3f(X+1.0, Y+Value, Z-1.0);
      glVertex3f(X+1.0, Y+Value, Z);
    (**)

    (**)
    // top
    // todo hier
    //R := Value; G := R / 256 * R; B := G / 256 * G;
    //glColor3f(R, G, B);

    //glColor3f(R, G, B);
    //glVertex3f(lX, lY, lZ);
    //glVertex3f(lX + 1, lY, lZ);
    //glColor3f(R, G, B);
    //glVertex3f(lX, lY + lastValue, lZ);
    //glVertex3f(lX + 1, lY + lastValue, lZ);

    (**)
    maxh:=256;
    glColor3f(glSonoPal[yval][0]/255, glSonoPal[yval][1]/255, glSonoPal[yval][2]/255);
    glVertex3f(X              , (Y + Value)/256*maxh, Z);
    glVertex3f(X + maxboxwidth, (Y + Value)/256*maxh, Z);
    glVertex3f(X + maxboxwidth, (Y + Value)/256*maxh, Z - maxboxwidth);
    glVertex3f(X              , (Y + Value)/256*maxh, Z - maxboxwidth);
    (**)
    glEnd;

    (**)

    (**-)
    glBegin(GL_POINTS);
    //glColor3f(R, G, B);
    glColor3f(glSonoPal[yval][0], glSonoPal[yval][1], glSonoPal[yval][2]);
    glVertex3d(x, (Y + Value)/256*maxh, z);
    glEnd;
    (**)

    (*
    glBegin(GL_LINES);
    R:=lastValue; G:=R/512*R; B:=G/512*G;
    glColor3f(R, G, B);
    glVertex3f(lx,ly+lastValue,lz);
    R:=Value; G:=R/512*R; B:=G/512*G;
    glColor3f(R, G, B);
    glVertex3f(x,y+Value,z);
    glEnd;
    *)

    gllastValue := Value;
end;

procedure TFormPlayer.VUBox2(X, Y, Z: glFloat; lX, lY, lZ: glFloat; Value: byte);
var C, F: glFloat;
    R, G, B: glFloat;
    maxh:GLfloat;
begin
    C := (11.75 (*+ X*)) / 55; // amount of color to fade by as we go to the right
    F := (21.75 (*-Z *)) / 60; // amount of fade to black as we go back
    R := C - F; // RED
    G := C - F; // GREEN
    B := 1 - F; // BLUE

    glBegin(GL_QUADS);
    //R := gllastValue; G := R / 256 * R; B := G / 256 * G;
    //glColor3f(R, G, B);
    //glColor3f(glSonoPal[value][0]/256,glSonoPal[value][1]/256,glSonoPal[value][2]/256);
    glColor3f(glSonoPal[value][0]/255, glSonoPal[value][1]/255, glSonoPal[value][2]/255);
    //glColor3f(glSonoPal[Trunc(value)][0],glSonoPal[Trunc(value)][1],glSonoPal[Trunc(value)][2]);

    maxh:=10;
    glVertex3f(X    , (Y - Value)/256*maxh, Z);
    glVertex3f(X + 1, (Y - Value)/256*maxh, Z);
    glVertex3f(X + 1, (Y - Value)/256*maxh, Z - 1);
    glVertex3f(X    , (Y - Value)/256*maxh, Z - 1);
    glEnd;
    gllastValue := Value;
end;
{}

procedure TFormPlayer.glDraw2;
var R, G, B: GLfloat;
    x,y,z  : GLfloat;
    i,j,k:integer;
    zwL,zwR:GLfloat;
    YValL, YValR: integer;
begin
    glClear(GL_DEPTH_BUFFER_BIT or GL_COLOR_BUFFER_BIT); // clears the Frame Buffer for a new Frame
    glLoadIdentity(); // Reset The View

    glTranslatef(xdist, yDist, zDist); //ydist
    //glTranslatef(0, -50.0,+(ElapsedTime/1000));

    //glRotatef(180, 0, 1, 0);
    glRotatef(angle, 1, 0, 0);
    glRotatef(180-anglerotate, 0, 1, 0);
    //glRotatef(35, 1, 0, 0);
    //glPushMatrix; // saves current Matrix

    k := 0;
    i := 0;
    // collect as much bytes as needed in forehand
    // fill new values into the first row of matrix
    //for i:=0 to FFTSize-1 do begin  // FFTSize
    while (i < FFTSize-1) do //FFTSize) do
    begin
        if (i mod 2 <> 0) then continue;
        zwL := Sqrt(FloatData[i    ]); // * SpinScale.Value;
        zwR := Sqrt(FloatData[i + 1]); // * SpinScale.Value;;
        j := i;
        while j < i+4 do begin
            // todo
            zwL := (zwL + Sqrt(FloatData[i+j  ]) * ScaleB.Position) / 2;
            zwR := (zwR + Sqrt(FloatData[i+j+1]) * ScaleB.Position) / 2;
            Inc(j, 2);
        end;
        FField3d[0,k  ] := zwL;
        FField3d[0,k+1] := zwR;
        Inc(k, 2);
        Inc(i, 4);
    end;
    (**)

    //GLQuadStrip
    glBegin(GL_QUADS);
    //i:=0;
    for i:=0 to MAXLINES-1 do
    begin
      for j:=0 to FFTSize-1 do
      begin
        if (j mod 2 <> 0) then continue;
        //YValL := Trunc(Sqrt(FFTFataS[j  ]) * ScaleB.Position); //FField3d[i  ,j]);
        //YValR := Trunc(Sqrt(FFTFataS[j+1]) * ScaleB.Position); //FField3d[i+1,j]);
        YValL := Trunc(FField3d[i,j  ] * ScaleB.Position);
        YValR := Trunc(FField3d[i,j+1] * ScaleB.Position); //FField3d[i+1,j]);
        if (YValL > 255) then YValL := 255;
        if (YValR > 255) then YValR := 255;
        if (YValL <   0) then YValL := 0;
        if (YValR <   0) then YValR := 0;

        R:=glSonoPal[YValL][0]/100;
        G:=glSonoPal[YValL][1]/100;
        B:=glSonoPal[YValL][2]/100;

        if false then //(show_texture == 1) then
        begin
           //glTexCoord2f(QuadTexturePtr[j+1],
           //             QuadTexturePtr[j]);
           //j = j + 2;
        end else begin
           glColor3f(R,G,B);
        end;

        x := j/10; //1.45; // abstand vertikal zw pnkten
        y := sqrt(FloatData[j])*256; //FField3d[i,j]/8;
        z := i/FFTSize*10; //(maxboxwidth/5);
        glVertex3f(x,y,z);
      end;
    end;
    glEnd;
    //glPopMatrix; // Get rid of current matrix and go

    SwapBuffers(openglDC); // Display the scene
end;

////////////////////////////////////////////////////////////////////////////////
//mandelbulb////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
procedure TFormPlayer.glDraw3;
var i, j, k: integer;
    YValL, YValR, LYValL, LYValR          : integer;
    iterations, bailout, divider, colormagic: integer;
    CtrlPoints2D: array[0..1] of array[0..2] of GlFloat;
    maxy: GLfloat;
    zwL, zwR: GLfloat;
    lx, lyR, lyL, lz: GLfloat;
    x,y,z,x2,y2,z2, r,theta,phi, n: GLfloat;
    x0,y0,z0,xe,ye,ze, diffx, diffy, diffz: double;
    noise                                 : double;
begin
    glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);    // Clear The Screen And The Depth Buffer
    glLoadIdentity();                                       // Reset The View

    //glClear(GL_DEPTH_BUFFER_BIT or GL_COLOR_BUFFER_BIT); // clears the Frame Buffer for a new Frame
    //glLoadIdentity(); // Reset The View
    glTranslatef(xdist, ydist, zDist); //ydist
    glRotatef(angle, 1, 0, 0);
    glRotatef(180-anglerotate, 0, 1, 0);

    iterations := 60;
    n          := 5;
    colormagic := 2;
    noise      := 1.5;
    bailout    := 4;

    x0:=-5;
    y0:=-5;
    z0:=-5;
    xe:=5;
    ye:=5;
    ze:=5;
    x :=x0;
    y :=y0;
    z :=z0;
    diffx := Abs((xe-x0) / Width)*10;
    diffy := Abs((ye-y0) / Height)*10;
    diffz := Abs((ze-z0) / ((Width+Height)/2))*10;

    //glPushMatrix; // saves current Matrix
    glBegin(GL_POINTS);
    while (x<=xe) do begin
      y:=y0;
      while (y<=ye) do begin
        z:=z0;
        while (z<=ze) do begin

          x2 := x0 + x*diffx;
          y2 := y0 + y*diffy;
          z2 := z0 + z*diffz;
          i:=0;

          //for j:=0 to iterations-1 do
          while ((x2*x2 + y2*y2 + z2*z2) < bailout) and (i<iterations) do
          begin
            (*
  double x=p.x,y=(p.y==0.0?1.0e-9:p.y),z=p.z; // avoids singularity when y=0
  double x2=sqr(x),
         y2=sqr(y),
         z2=sqr(z),
         r=sqrt(x2+y2+z2);
  double a=sqrt(y2+x2*(2.0+z2/(x2+y2))-2.0*x*r),
         b=sqr(y2)+x2*(y2-z2),
         c=a*(x*(r+x)+y2);
  t1=r-x;
  double yroot1=0.5*sqrt(t1-a)
  double yroot2=0.5*sqrt(t1+a);
  t1=x*y2;
  t2=x2+y2;
  t3=cube(x)*z2;
  t4=y*b;
  double xroot1=yroot1*((t1-c)*t2-t3)/t4;
  double xroot2=yroot2*((t1+c)*t2-t3)/t4;
  t1=c*(x2+y2)/b;
  double zroot1=-z/sqrt(2.0*(r-t1));
  double zroot2=-z/sqrt(2.0*(r+t1));
  plist[0]=pt3D(xroot1,yroot1,zroot1);
  plist[1]=pt3D(xroot2,yroot2,zroot2);
  plist[2]=pt3D(-xroot1,-yroot1,zroot1);
  plist[3]=pt3D(-xroot2,-yroot2,zroot2);


r^3*cos(T)^3 = z^3 !
tan(T) = sqrt(x^2+y^2)/z

newz = z^3 * ( 1 - 3*(x^2+y^2)/z^2 ) = z * ( z^2 - 3*x^2 - 3*y^2 )

This can be done for EVERY exponent; you can always factor out cos(T)^n from
newz and are left with z^n and a polynomial in tan(T),
which can be expressed in x,y,z using formula "2" above.
now, one "r", one "sin(T)", and one of the factors in the first
bracket always combine to an old coordinate,
and tan(T)^-2 = z^2/(x^2+y^2), so

newx = ( x^3 - 3*x*y^2 ) * ( 3*z^2 - x^2 - y^2 ) / ( x^2+y^2 )
newy = ( 3*x^2*y - y^3) * ( 3*z^2 - x^2 - y^2 ) / ( x^2+y^2 )
            *)

            r     := sqrt(x2*x2 + y2*y2 + z2*z2);
            theta := r*n*ArcTan(y2/x2); //sqrt(x*x + y*y),z);
            phi   := r*n*ArcSin(z2/r);
            // x ^n = r ^n
            //x2    := cos(theta)*cos(phi); //power(r,n) *
            //y2    := sin(theta) * cos(phi);
            //z2    := (-sin(phi));

            x2 := x2 + r*n*cos(theta) * cos(phi);
            y2 := y2 + r*n*cos(theta) * sin(phi);
            z2 := z2 + r*n*sin(theta)             ;

            inc(i);
            //newx  := x1 + x2;
            //newy  := y1 + y2;
            //newz  := z1 + z2;
            //YValL := Trunc(Sqrt(FField3d[i, j  ]) * ScaleB.Position);
            //YValR := Trunc(Sqrt(FField3d[i, j+1]) * ScaleB.Position);
            //YValL := Trunc(Sqrt(FFTFataS[j  ]) * ScaleB.Position);
            //YValR := Trunc(Sqrt(FFTFataS[j+1]) * ScaleB.Position);
          end;

          // default
          i := Trunc(i * noise * colormagic);
          i := i mod 256;
          if i < 0 then i:=0;
          if i>255 then i:= 255;

          if z < 0 then
            glColor3f(glSonoPal[i div 2][0]/255, glSonoPal[i div 2][1]/255, glSonoPal[i div 2][2]/255)
          else
            glColor3f(glSonoPal[i      ][0]/255, glSonoPal[i      ][1]/255, glSonoPal[i      ][2]/255);
          //glvertex3f( 0.05+ i/200, LYValL/1024, (j-1)/400);
          glvertex3f(x2/255,y2/255,z2/255);

          z:=z+diffz;
        end;
        y:=y+diffy;
      end;
      x:=x+diffx;
    end;

    glEnd;
    //glPopMatrix; // Get rid of current matrix and go
    SwapBuffers(openglDC); // Display the scene
end;

{ Draw OPENGL screen }
{}
procedure TFormPlayer.glDraw;
var i, j, k: integer;
    x, y, z: GLfloat;
    lx, lyR, lyL, lz: GLfloat;
    YValL, YValR, LYValL, LYValR: integer;
    zwL, zwR: GLfloat;
    CtrlPoints2D: array[0..1] of array[0..2] of GlFloat;
    maxy: GLfloat;
    divider:integer;
begin
    lx    := 0;
    lyR   := 0;
    lyL   := 0;
    lz    := 0;
    LYValL:= 0;
    LYValR:= 0;
    maxy  := 0;
    maxboxwidth:= 1;
    divider    := (FFTSize div MAXLINES);
    divider    := 2;
    i:=0;

    //glClear(GL_COLOR_BUFFER_BIT);    // Clear The Screen And The Depth Buffer
    glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);    // Clear The Screen And The Depth Buffer
    glLoadIdentity();                                       // Reset The View

    //glClear(GL_DEPTH_BUFFER_BIT or GL_COLOR_BUFFER_BIT); // clears the Frame Buffer for a new Frame
    //glLoadIdentity(); // Reset The View
    glTranslatef(xdist, ydist, zDist);
    glRotatef(angle, 1, 0, 0);
    glRotatef(180-anglerotate, 0, 1, 0);
    //glTranslatef(0, -1.0,-(ElapsedTime/1000));
    //glRotatef(180, 0, 1, 0);
    //glRotatef(35, 1, 0, 0);

    if not opt2.Checked then begin
        glBegin(GL_POINTS);
        //glBegin(GL_LINES);
        //glBegin(GL_LINE_STRIP);
        //glBegin(GL_LINE_LOOP);
        //glBegin(GL_QUADS);
        //glBegin(GL_QUAD_STRIP);
        for i:=0 to MAXLINES-1 do
          for j:=0 to FFTSize-1 do
          begin
            if (j mod 2 <> 0) then continue;

            YValL := trunc(AmplitudeArray[trunc(nteWurzel(FField3d[i, j  ],1+(bright/512)*2)*255)]);
            YValR := trunc(AmplitudeArray[trunc(nteWurzel(FField3d[i, j+1],1+(bright/512)*2)*255)]);

            //YValL := Trunc(Sqrt(FField3d[i, j  ]) * ScaleB.Position);
            //YValR := Trunc(Sqrt(FFTFataS[i, j+1]) * ScaleB.Position);
            //YValL := Trunc(Sqrt(FFTFataS[j  ]) * ScaleB.Position);
            //YValR := Trunc(Sqrt(FFTFataS[j+1]) * ScaleB.Position);

            // links
            glColor3f(glSonoPal[YValL][0]/255, glSonoPal[YValL][1]/255, glSonoPal[YValL][2]/255);
            glvertex3f( 0.05+ i/200,  YValL/4048,  j   /1024);
            //glvertex3f( 0.05+ i/400, LYValL/512, (j-2)/400);

            // rechts
            glColor3f(glSonoPal[YValR][0]/255, glSonoPal[YValR][1]/255, glSonoPal[YValR][2]/255);
            glvertex3f(-0.05- i/200,  YValR/4048,  j   /1024);
            //glvertex3f(-0.05- i/400, LYValR/512, (j-2)/400);

            LYValL:=YValL;
            lastaL[j  ]:=LYValL;

          end;
        glEnd;

        (**-)
        glBegin(GL_POINTS);
        glBegin(GL_LINES);
        //glBegin(GL_LINE_STRIP);
        //glBegin(GL_LINE_LOOP);
        //glBegin(GL_QUADS);
        //glBegin(GL_QUAD_STRIP);
        for i:=0 to MAXLINES-1 do
          for j:=0 to FFTSize-1 do
          begin
            if (j mod 2 = 0) then continue;

            YValR := Trunc(Sqrt(FField3d[i, j+1]) * ScaleB.Position);

            //YValL := Trunc(Sqrt(FFTFataS[j  ]) * ScaleB.Position);
            //YValR := Trunc(Sqrt(FFTFataS[j+1]) * ScaleB.Position);

            glColor3f(glSonoPal[YValR][0]/255, glSonoPal[YValR][1]/255, glSonoPal[YValR][2]/255);
            //glvertex3f(-0.05- i/400, lastR[j-2]/512, (j-2)/400);
            //glvertex3f(-0.05- i/400, lastR[j  ]/512, (j  )/400);
            glvertex3f(-0.05- i/400,      YValR/512,  j   /400);
            glvertex3f(-0.05- i/400,     LYValR/512, (j-2)/400);

            lastR[j  ]:=  YValR;
            lastR[j-2]:= LYValR;
            LYValR:=YValR;
          end;
        glEnd;
        (**)
    end else begin

        DL := glGenLists(1);
        glNewList(DL, GL_COMPILE);
        //glBegin(GL_QUADS);
        glBegin(GL_LINES);
        for i:=0 to MAXLINES-1 do
          for j:=0 to FFTSize-1 do
          begin
            if (j mod 2 <> 0) then continue;

            YValL := Trunc(Sqrt(FField3d[i, j  ]) * ScaleB.Position);
            YValR := Trunc(Sqrt(FField3d[i, j+1]) * ScaleB.Position);

            //YValL := Trunc(Sqrt(FFTFataS[j  ]) * ScaleB.Position);
            //YValR := Trunc(Sqrt(FFTFataS[j+1]) * ScaleB.Position);

            glColor3f(glSonoPal[YValL][0]/255, glSonoPal[YValL][1]/255, glSonoPal[YValL][2]/255);
            glvertex3f( 0.05+ i/400, LYValL/1512, (j-2)/800);
            glvertex3f( 0.05+ i/400,  YValL/1512,  j   /800);

            glColor3f(glSonoPal[YValR][0]/255, glSonoPal[YValR][1]/255, glSonoPal[YValR][2]/255);
            glvertex3f(-0.05- i/400, LYValR/1512, (j-2)/800);
            glvertex3f(-0.05- i/400,  YValR/1512,  j   /800);

            LYValL:=YValL;
            LYValR:=YValR;

          end;
          //glTexCoord2f((Vertex[i,0]-Size*Ratio/2)/(Size*Ratio), (-Vertex[i,2]-Size/2)/Size);
          //glVertex3fv(@Vertex[i]);
        glEnd;
        glEndList;
        glCallList(DL);

    end;

{ // zwei achsen zur orientierung
      glColor3f(1, 1, 1);
      glBegin(GL_LINES);
      glVertex3f( 0.025, 0, 0.0);
      glVertex3f( 0.025, 0, FFTSIze/400);

      glVertex3f(-0.025, 0, 0.0);
      glVertex3f(-0.025, 0, FFTSIze/400);

      glVertex3f( 0.0, 0, 0.0);
      glVertex3f( 0.0, 0.1, 0.0);
      glEnd;

    //VUBox(-1, 0, 10, 50, 0, 0, 10);
{}
    (**-)

    // shift old values in matrix up
    for i := MAXLINES-1 downto 0 do
        for j := FFTSize-1 downto 0 do
            FField3d[i, j] := FField3d[i, j - 1];

    // zero first row
    for i := FFTSize - 1 downto 0 do
        FField3d[0, i] := 0;

    k := 0;
    i := 0;
    // collect as much bytes as needed in forehand
    // fill new values into the first row of matrix
    //for i:=0 to FFTSize-1 do begin  // FFTSize
    while (i < MAXLINES-1) do //FFTSize) do
    begin
        if (i mod (divider * 2) <> 0) then continue;
        //zwR := ln(i);

        zwL := Sqrt(FFTFataS[i    ]); // * SpinScale.Value;
        zwR := Sqrt(FFTFataS[i + 1]); // * SpinScale.Value;;
        j := i;
        while j < i + (divider * 2) do begin
            // todo
            zwL := (zwL + Sqrt(FFTFataS[i+j  ]) * ScaleB.Position) / 2;
            zwR := (zwR + Sqrt(FFTFataS[i+j+1]) * ScaleB.Position) / 2;
            Inc(j, 2);
        end;
        FField3d[k  , 0] := zwL;
        FField3d[k+1, 0] := zwR;
        Inc(k, 2);
        Inc(i, divider*2);
    end;

    // draw the whole matrix
    for j:=0 to FFTSize-1 do
    begin
      if (i mod 2 <> 0) then continue;
      for i:=0 to MAXLINES-1 do
      begin
        YValL := Trunc(FField3d[i    , j]);
        YValR := Trunc(FField3d[i + 1, j]);
        if (YValL > 255) then YValL := 255;
        if (YValR > 255) then YValR := 255;
        if (YValL <   0) then YValL := 0;
        if (YValR <   0) then YValR := 0;

        x := j; //1.45; // abstand vertikal zw pnkten
        z := i/2; //(maxboxwidth/5);

        // linker kanal
        y := FField3d[i  , j]/8;
        lyL := y;
        VUBox( x, 0, z, y,   lx, 0, lz, YValL);
        //VUBox2(-x, 0, z, y, 0, lz, YValL);

        // rechter kanal
        y := FField3d[i+1, j]/8;
        lyR := y;
        VUBox(-x, 0, z, y,  -lx, 0, lz, YValR);
        //VUBox2(x, 0, z, y, 0, lz,  yvalR);

        lx := x+5;
        lz := z+5;
      end;
    end;

    (**)
    //glPopMatrix; // Get rid of current matrix and go
    SwapBuffers(openglDC); // Display the scene
end;
{}

////////////////////////////////////////////////////////////////////////////////
//processing addative blending /////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
procedure TFormPlayer.RenderScene;
var i, j, k: integer;
    YValL, YValR, LYValL, LYValR          : integer;
    iterations, bailout, divider, colormagic: integer;
    CtrlPoints2D: array[0..1] of array[0..2] of GlFloat;
    maxy: GLfloat;
    zwL, zwR: GLfloat;
    lx, lyR, lyL, lz: GLfloat;
    x,y,z,x2,y2,z2, r,theta,phi, n: GLfloat;
    x0,y0,z0,xe,ye,ze, diffx, diffy, diffz: double;
    noise                                 : double;
begin
(*
  glPushMatrix();
    glDisable(GL_DEPTH_TEST);           // disable Depth testing
    glEnable(GL_BLEND);                 // enable blending

    // set the previous scene to be 1-1/frames the brightness give frames amount of blur
    glColor4f(1.0, 1.0, 1.0, 1.0 - 1.0/frames );

    glMatrixMode(GL_PROJECTION);
    glPushMatrix();
      // go to orthogonal view
      glLoadIdentity();
      glOrtho( 0, 800, 600, 0, 0, 1);
      glMatrixMode(GL_MODELVIEW);
      glLoadIdentity();

      // Display the previous rendered scene
      glBindTexture(GL_TEXTURE_2D, BlurTexture);
      glBegin(GL_QUADS);
        glTexCoord2f(0.0, 1.0);  glVertex2f(0, 0);
        glTexCoord2f(0.0, 0.0);  glVertex2f(0, 600);
        glTexCoord2f(1.0, 0.0);  glVertex2f(800, 600);
        glTexCoord2f(1.0, 1.0);  glVertex2f(800, 0);
      glEnd();

      // go back to 3D view
      glMatrixMode(GL_PROJECTION);
    glPopMatrix();
    glMatrixMode(GL_MODELVIEW);

    glEnable(GL_DEPTH_TEST);
    glDisable(GL_BLEND);          // disable blending

  glPopMatrix();
*)
  glPushMatrix();

    glTranslatef(xdist, ydist, zDist); //ydist
    glRotatef(angle, 1, 0, 0);
    glRotatef(180-anglerotate, 0, 1, 0);
    //glpopMatrix; // saves current Matrix

      //glColor3f(1, 1, 1);
      glBegin(GL_POINTS);
      //glBegin(GL_LINES);
      //glBegin(GL_QUADS);

    //for i:=0 to MAXLINES-1 do //50 do //
      for j:=0 to FFTSize-1 do
      begin
        if (j mod 2 <> 0) then continue;

        YValL := Trunc(Sqrt(floatdata[j  ]) * ScaleB.Position);
        YValR := Trunc(Sqrt(floatdata[j+1]) * ScaleB.Position);

        //YValL := Trunc(Sqrt(FFTFataS[j  ]) * ScaleB.Position);
        //YValR := Trunc(Sqrt(FFTFataS[j+1]) * ScaleB.Position);

        glColor3f(glSonoPal[YValL][0]/255, glSonoPal[YValL][1]/255, glSonoPal[YValL][2]/255);
        glvertex3f( 0.05+ i/400, LYValL/512, (j-2)/400);
        glvertex3f( 0.05+ i/400,  YValL/512,  j   /400);

        glColor3f(glSonoPal[YValR][0]/255, glSonoPal[YValR][1]/255, glSonoPal[YValR][2]/255);
        glvertex3f(-0.05- i/400, LYValR/512, (j-2)/400);
        glvertex3f(-0.05- i/400,  YValR/512,  j   /400);

        LYValL:=YValL;
        LYValR:=YValR;

      end;
      glEnd;
{}

{} // zwei achsen zur orientierung
      glColor3f(1, 1, 1);
      glBegin(GL_LINES);
      glVertex3f( 0.025, 0, 0.0);
      glVertex3f( 0.025, 0, FFTSIze/400);

      glVertex3f(-0.025, 0, 0.0);
      glVertex3f(-0.025, 0, FFTSIze/400);

      glVertex3f( 0.0, 0, 0.0);
      glVertex3f( 0.0, 0.1, 0.0);
      glEnd;

  glPopMatrix();
end;

procedure TFormPlayer.glDraw4;
begin
(*// Displayliste generieren
DL := glGenLists(1);
glNewList(DL, GL_COMPILE);
 glBegin(GL_QUADS);
 for x := 0 to Resolution-2 do
  for z := 0 to Resolution-2 do
   begin
   for i := 0 to 3 do
    begin
    Vertex[i,0] := ((X + VertPos[I][0])/Resolution*Size-Size/2)*Ratio;
    Vertex[i,2] := (Z + VertPos[I][1])/Resolution*Size-Size/2;
    Vertex[i,1] := HeightData[X + VertPos[I][0],Z + VertPos[I][1]]*4*0.01;
    glTexCoord2f((Vertex[i,0]-Size*Ratio/2)/(Size*Ratio), (-Vertex[i,2]-Size/2)/Size);
    glVertex3fv(@Vertex[i]);
    end;
   end;
 glEnd;
glEndList;
*)
  glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);    // Clear The Screen And The Depth Buffer
  glLoadIdentity();                                       // Reset The View

  // move and rotate scene
  //glTranslatef(0.0, 0.0,-8);
  glTranslatef(xdist, ydist, zDist);
  glRotatef(ElapsedTime/8, 1, 0, 0);
  glRotatef(ElapsedTime/12, 0, 1, 0);

  // Render the scene in a 512x512 viewport
  glViewport(0, 0, 512, 512);
  RenderScene;
  SwapBuffers(openglDC); // Display the scene

  // Grab the scene as a texture
  glBindTexture(GL_TEXTURE_2D, BlurTexture);
  glCopyTexImage2D(GL_TEXTURE_2D, 0, GL_RGB, 0, 0, 512, 512, 0);

  // clear the screen and draw the new scene in viewport centered in the screen
  glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
  glViewport(144, 44, 512, 512);
  RenderScene;
  SwapBuffers(openglDC); // Display the scene
(**)
end;

procedure TFormPlayer.glDraw5;
var x,z:integer;
    YValL,YValR:integer;
    LYValL,LYValR:integer;
begin
  glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);                          // Smae obrazovku
  glLoadIdentity;                                                               // Reset matice
  gluLookAt(0.0,25.0,-45.0,0.0,0.0,0.0,0,1,0);                                  // Pozice kamery

    glTranslatef(xdist, ydist, zDist); //ydist
    glRotatef(angle, 1, 0, 0);
    glRotatef(180-anglerotate, 0, 1, 0);

  glPushMatrix();
  // Nastaven modelview matice v shaderu
  cgGLSetStateMatrixParameter(modelViewMatrix,CG_GL_MODELVIEW_PROJECTION_MATRIX,CG_GL_MATRIX_IDENTITY);
  if cg_enable then                                                             // Zapnout CG shader?
  begin
    cgGLEnableProfile(cgVertexProfile);                                         // Zapne profil
    cgGLBindProgram(cgPrg);                                                     // Zvol program
    cgGLSetParameter4f(colorCG,0.5,1.0,0.5,1.0);                                  // Nastav barvu (svtle zelen)
  end;

  for x := 0 to MAXLINES - 2 do                                                     // Vykreslen meshe
    begin
    //glBegin(GL_TRIANGLE_STRIP);                                                 // Kad prouek jednm triangle stripem
    glBegin(GL_LINES);                                                 // Kad prouek jednm triangle stripem
    for z := 0 to FFTSize - 2 do
      begin
          if z mod 2 = 0 then continue;
          cgGLSetParameter3f(waveCG,wave_movement,1.0,1.0);                           // Parametr vlny
          //glVertex3f(mesh[x  ,z,0],mesh[x  ,z,1],mesh[x  ,z,2]);                          // Vertex
          //glVertex3f(mesh[x+1,z,0],mesh[x+1,z,1],mesh[x+1,z,2]);                    // Vertex

          YValL := Trunc(Sqrt(FField3d[x, z  ]) * ScaleB.Position);
          YValR := Trunc(Sqrt(FField3d[x, z+1]) * ScaleB.Position);

          glVertex3f(mesh[x,YValL,z],mesh[x,LYValL,z+1],mesh[x,0,z+2]);                          // Vertex
          glVertex3f(mesh[x,YValR,z],mesh[x,LYValR,z+1],mesh[x,0,z+2]);                    // Vertex

          //YValL := Trunc(Sqrt(FFTFataS[j  ]) * ScaleB.Position);
          //YValR := Trunc(Sqrt(FFTFataS[j+1]) * ScaleB.Position);

          LYValL:=YValL;
          LYValR:=YValR;

          //wave_movement := wave_movement + 0.00001;                                 // Inkrementace parametru vlny
          //if wave_movement > TWO_PI then                                            // Vt ne dv p (6,28)?
          //  wave_movement := 0.0;                                                   // Vynulovat

      end;
    glEnd;                                                                      // Konec triangle stripu
    end;

  if cg_enable then                                                             // Zapnut CG shader?
    cgGLDisableProfile(cgVertexProfile);                                        // Vypne profil

  glPopMatrix();
  //glFlush;                                                                      // Vyprzdn OpenGL renderovac pipeline
  SwapBuffers(openglDC); // Display the scene
end;

procedure TFormPlayer.glInit();
var pfd: TPIXELFORMATDESCRIPTOR;
    pf, I, J, ll: Integer;
    x,z:integer;
    Error: CGerror;
  procedure CreateBlurTexture;
  var pData: Pointer;
  begin
    GetMem(pData, 512*512*3); // allocate memory for a 512x512 texture
    glGenTextures(1, BlurTexture);
    glBindTexture(GL_TEXTURE_2D, BlurTexture);
    glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);  {Texture blends with object background}

    glTexImage2D(GL_TEXTURE_2D, 0, 3, 512, 512, 0, GL_RGB, GL_UNSIGNED_BYTE, pData);  // Use when not wanting mipmaps to be built by openGL
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR); { only first two can be used }
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR); { all of the above can be used }
    FreeMem(pData);
  end;
begin (**) {  Initialise OpenGL }
    down := False;
    gllastValue := 0;
    Frames      := 60;
    angle       := 0;
    anglerotate := 0;
    openglDC := GetDC(FormPlayer.Handle);

    // PixelFormat
    pfd.nSize := sizeof(pfd);
    pfd.nVersion := 1;
    pfd.dwFlags := PFD_DRAW_TO_WINDOW or PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER or 0;
    pfd.iPixelType := PFD_TYPE_RGBA; // PFD_TYPE_RGBA or PFD_TYPEINDEX
    pfd.cColorBits := 32;

    pf := ChoosePixelFormat(opengldc, @pfd); // Returns format that most closely matches above pixel format
    SetPixelFormat(openglDC, pf, @pfd);

    openglRC := wglCreateContext(openglDC); // Rendering Context = window-glCreateContext
    wglMakeCurrent(openglDC, openglRC); // Make the DC (Form1) the rendering Context

  glClearColor(0.0, 0.0, 0.0, 0.0); 	   // Black Background
  glShadeModel(GL_SMOOTH);                 // Enables Smooth Color Shading
  glClearDepth(1.0);                       // Depth Buffer Setup
  glEnable(GL_DEPTH_TEST);                 // Enable Depth Buffer
  //glDepthFunc(GL_LESS);		           // The Type Of Depth Test To Do
  glDepthFunc(GL_LEQUAL);		           // The Type Of Depth Test To Do
  glBlendFunc(GL_SRC_ALPHA,GL_ONE);

  glEnable(GL_BLEND);
  glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);   //Realy Nice perspective calculations

  Frames :=10;
  CreateBlurTexture;

    glPointSize(2.2);
    glLineWidth(2.0);

    glClearColor(0.0, 0.0, 0.0, 0.0); 	   // Black Background
    glClearDepth(1.0);                       // Depth Buffer Setup

    //glShadeModel(GL_SMOOTH);                 // Enables Smooth Color Shading
    //glDisable(GL_DEPTH_TEST);
    //glEnable(GL_DEPTH_TEST);

    // dglOPENGL.PAS version
    //InitOpenGL; // Don't forget, or first gl-Call will result in an access violation!
    //openglRC := CreateRenderingContext(opengldc,[opDoubleBuffered],24,16,16,16,1,0);
    //ActivateRenderingContext(openglDC, openglRC); // Necessary, will also read some extension


    //glClearColor(0.0, 0.0, 0.0, 0.0); // Black Background
    //glShadeModel(GL_FLAT); // GL_SMOOTH); // Enables Smooth Color Shading
    //glClearDepth(0.2); // Depth Buffer Setup
    //glEnable(GL_DEPTH_TEST); // Enable Depth Buffer
    //glDepthFunc(GL_LESS); // The Type Of Depth Test To Do
    //glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST); //Realy Nice perspective calculations
    //glMatrixMode(GL_PROJECTION);

  //glBlendFunc(GL_ONE, GL_ONE);
  //glBlendFunc(GL_ONE_MINUS_DST_COLOR, GL_ONE);
  //glEnable(GL_BLEND);
  //glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);   //Realy Nice perspective calculations
  //glHint(GL_POINT_SMOOTH_HINT, GL_NICEST);

{
//glEnableClientState(GL_EXT_vertex_array); //GL_VERTEX_ARRAY
glEnableClientState(GL_VERTEX_ARRAY_EXT); //GL_EX COLOR_ARRAY);
glEnableClientState(GL_COLOR_ARRAY_EXT);
//glVertexPointer(3, GL_FLOAT, 0, @WAVEdata);
glVertexPointer(3, GL_FLOAT, 0, @FloatData);
glColorPointer(3, GL_FLOAT, 0, @ColorData);
glDrawArrays(GL_POINTS, 0, 3);
glDisableClientState(GL_VERTEX_ARRAY_EXT);
glDisableClientState(GL_COLOR_ARRAY_EXT);
{}

    //glEnable(GL_TEXTURE_2D); // Enable Texture Mapping
    //BlurTexture := EmptyTexture();								// Create Our Empty Texture
    (**-)
      glMateriali(GL_FRONT, GL_SHININESS, 128);
      glClearColor(0.0, 0.0, 0.0, 0.0);       // Black Background
      glShadeModel(GL_SMOOTH);                 // Enables Smooth Color Shading
      glClearDepth(1.0);                       // Depth Buffer Setup
      glEnable(GL_DEPTH_TEST);                 // Enable Depth Buffer
      glDepthFunc(GL_LESS);                 // The Type Of Depth Test To Do
      glBlendFunc(GL_SRC_ALPHA,GL_ONE);

      glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);   //Realy Nice perspective calculations

      glEnable(GL_TEXTURE_2D);                     // Enable Texture Mapping
      //LoadTexture('texture.bmp', MyTextureTex);    // Load the Texture
      CreateBlurTexture;
    (**)

(*

  glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);                                     // Drtn model
  for x := 0 to MAXLINES - 1 do                                                     // Inicializace meshe
    for z := 0 to MAXFFTSIZE - 1 do
      begin
      mesh[x,z,0] := (MAXLINES / 2) - x;                                            // Vycentrovn na ose x
      mesh[x,z,1] := 0.0;                                                       // Ploch rovina
      mesh[x,z,2] := (MAXLINES / 2) - z;                                            // Vycentrovn na ose z
      end;
  cgKontext := cgCreateContext;                                                 // Vytvoen CG kontextu
  if cgKontext = nil then                                                       // OK?
    begin
    MessageBox(0,'Failed To Create Cg Context','Error',MB_OK);
    //Result := false;
    exit;
    end;
  cgVertexProfile := cgGLGetLatestProfile(CG_GL_VERTEX);                        // Zskn minulho profilu vertex
  if cgVertexProfile = CG_PROFILE_UNKNOWN then                                  // OK?
    begin
    MessageBox(0,'Invalid profile type','Error',MB_OK);
    //Result := false;
    exit;
    end;
  cgGLSetOptimalOptions(cgVertexProfile);                                       // Nastaven profilu
  // Nahraje a zkompiluje vertex shader
  cgPrg := cgCreateProgramFromFile(cgKontext,CG_SOURCE,'CG/Wave.cg',cgVertexProfile,'main',nil);
  if cgPrg = nil then                                                           // OK?
    begin
    Error := cgGetError;                                                        // Typ chyby
    MessageBox(0,cgGetErrorString(Error),'Error',MB_OK);
    //Result := false;
    exit;
    end;
  cgGLLoadProgram(cgPrg);                                                       // Nahraje program do grafick karty

  // Handle na promnn
  positionCG := cgGetNamedParameter(cgPrg,'IN.position');
  colorCG := cgGetNamedParameter(cgPrg,'IN.color');
  waveCG := cgGetNamedParameter(cgPrg,'IN.wave');
  modelViewMatrix := cgGetNamedParameter(cgPrg,'ModelViewProj');
*)
end;
{}

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

procedure TFormPlayer.ColorTimerTimer(Sender: TObject);
begin
  if IsWindowVisible(ColorDialog.Handle) then begin
    CurrentPanel.Color:=ColorDialog.Color;
    MakePaletteGDI;
  end;
end;

const AC_SRC_OVER  = $0;
const AC_SRC_ALPHA = $1;

procedure BlendWinAPI(dst, src1, src2: TBitmap; src1Transparency:Byte);
var BlendFunc: TBlendFunction;
begin
  BlendFunc.BlendOp     := AC_SRC_OVER;
  BlendFunc.BlendFlags  := 0;
  BlendFunc.AlphaFormat := 0;
  BlendFunc.SourceConstantAlpha := src1Transparency;

  BitBlt    (dst.Canvas.Handle,0,0,dst.width,dst.Height,
             src2.Canvas.Handle,0,0,SRCCOPY);
  AlphaBlend(dst.Canvas.Handle,0,0,dst.width,dst.Height,
             src1.Canvas.Handle,0,0,dst.width,dst.height,BlendFunc);
end;

procedure TFormPlayer.TimerRenderTimer(Sender: TObject);
var tp                  : TPoint;
    extval,lastextval   : double;
    zwL, zwR            : integer;
    fidx,last           : integer;
    divisor,err,X,Y,i,j : integer;
    chstate             : cardinal;
    appnow              : cardinal;
    Channellocal        : cardinal;
    l1,r1               : integer;
    dataavail,res       : dword;
    s                   : string;
    logfile             : textfile;
    FField3dShifted     : PFField3d;
begin
    if doingsettings then exit;
    if bUpdating then exit;

    // select source
    if BASS_ChannelIsActive(FILEChannel) = BASS_ACTIVE_PLAYING then
      Channellocal := FILEChannel
    else
      Channellocal := RECORDCHAN;

    //chstate:=BASS_ChannelIsActive(Channellocal);
    //if (chstate<>BASS_ACTIVE_PLAYING) then
    if Channellocal=0 then
      exit;

    //if not flag then begin CurrData:=FFTData1; LastData:=FFTData2; end
    //            else begin CurrData:=FFTData2; LastData:=FFTData1; end;
    //flag:=not flag;

    // get whole data for this discreet moment
    //FillMemory(@WaveData,FFTSize,0);
    //FillMemory(@CurrData,FFTSize,0);
    //FillMemory(@lastFFTFata,FFTSize,0);
    //lastFFTFata:=
    //if BASS_ChannelGetData(Channel, @WaveData, FFTSize) = -1 then exit;

    (**-)
    dataavail:=BASS_ChannelGetData(Channellocal, nil, BASS_DATA_AVAILABLE);
    if dataavail=0 then begin
      label1.Caption:='-';
      exit;
    end else begin
      label1.Caption:=inttostr(dataavail);
    end;
    (**)

(**************************************************************)
//TimerStart2;
    //BASS_Update(TimerRender.Interval*2);
    //dataflag:=dataflag + BASS_DATA_FFT_NOWINDOW; //more noise

    if (rms.Checked) then begin
        //SpecBuf;
        //FillChar(Pointer(VisBuff), w*h, 0);
        //BASS_ChannelGetInfo(chan, ci); // get number of channels
        SetLength(Buf, w*2);
        //res:=BASS_ChannelGetData(Channellocal, @(FloatData[0]), dataflag + BASS_DATA_FFT_INDIVIDUAL + BASS_DATA_FFT_REMOVEDC)
        res:=BASS_ChannelGetData(Channellocal, buf, (2 * w * SizeOf(Single)) or BASS_DATA_FLOAT)
    end else begin
        res:=BASS_ChannelGetData(Channellocal, @(FloatData[0]), dataflag + BASS_DATA_FFT_INDIVIDUAL);
    end;

(**-)
label16.Caption:=IntToStr(res) + ' - '  + IntToStr(dataavail);
inc(imgcount);
image2.Canvas.Pixels[imgcount,trunc(dataavail/20000*256)]:=clgreen;
image2.Canvas.Pixels[imgcount,trunc(res/70000*256)]:=clred;
if imgcount>=256 then 
begin
image2.Canvas.pen.Color:=clWhite;
image2.Canvas.brush.Color:=clWhite;
image2.Canvas.Rectangle(0,0,256,256);
imgcount:=0;
end;
(**)
(**************************************************************)


//TimerStart3;
    // get level
    level  := BASS_ChannelGetLevel(Channellocal);
    levelL := LoWord(level);
    levelR := HiWord(level);

    (**)
    // get count of data that is above Sensitivity
    //GetNoiseLevel(CurrData, LevelLf, LevelRf);
    // count the average level per channel
    // start at higher frequencies to avoid dark noise freq

    // shift old values in matrix up
//TimerStart2;

    {
    if true then begin //if opt2.Checked then begin
        FField3dShifted:=(@FField3d);
        //FField3dShifted:=FField3dShifted+3;
        //Move(@FField3d,@(FField3d+),FFTSize-);
        Move(FField3dShifted^[0],FField3dShifted^[1],szoverall - szline);
        //Move(FField3dShifted^[0],
        //     FField3dShifted^[szline],
        //     szoverall - szline);
    end else begin
        (**)
        for i :=MAXLINES-1 downto 1 do //MAXLINES
          for j := FFTSize-1 downto 0 do
            FField3d[i, j] := FField3d[i-1, j];
        (**)
    end;
    }
    
    //AssignFile(logfile, 'float'+inttostr(dataavail)+'.log');
    //Rewrite(logfile);

    if RadioGroup1.ItemIndex=1 then
      // fill in 3D array
      for X := 0 to FFTSize - 1 do //for i:=0 to 512-1 do begin
        FField3d[0,x]:=FloatData[X];
    (**)
//TimerStop2;
//label16.Caption:=FloatToStrF(TimerAsSeconds2,ffNumber,12,6);

    //CloseFile(logfile);



    // fps info and second-marker


    
    // todo debug raus
    //FormPlayer.Label16.Caption:=GetUserFriendlyTime((GetTickCount()-AppStart)/1000.0);
    
    if fps mod 4 = 0 then begin
      //LevelL := (oldLevelL + LevelL) div 2;
      //LevelR := (oldLevelR + LevelR) div 2;
      //MakePaletteGDI;
    end;

    if RadioGroup1.ItemIndex=1 then
    begin
      //glViewport(0, 0, 128, 128);                      	// Set Our Viewport (Match Texture Size)
      //DrawBlur(2,0.5);

      if FormPlayer.Visible then
        glDraw;
      //glDraw2;
      //glDraw3;
      //glDraw4;
      //glDraw5;
      //Render;


      (**-)
      glBindTexture(GL_TEXTURE_2D,BlurTexture);		// Bind To The Blur Texture
      // Copy Our ViewPort To The Blur Texture (From 0,0 To 128,128... No Border)
      glCopyTexImage2D(GL_TEXTURE_2D, 0, GL_LUMINANCE, 0, 0, 128, 128, 0);
      glClearColor(0.0, 0.0, 0.5, 0.5);			// Set The Clear Color To Medium Blue
      glClear(GL_COLOR_BUFFER_BIT OR GL_DEPTH_BUFFER_BIT);	// Clear The Screen And Depth Buffer
      glViewport(0, 0, ClientWidth, ClientHeight);				// Set Viewport (0,0 to 640x480)
      (**)

    end else begin
      //TimerStart1;

      // also sums up LevelLf and LevelRf
      Draw;
      
      if FormPlayer.Visible then
      begin
      // paint level-meter
        if VolLevel.Checked and (DrawMode.ItemIndex=1) then
        begin
          if LevelLf > peakLf then peakLf:=LevelLf;
          if LevelRf > peakRf then peakRf:=LevelRf;
          if LevelL  > peakL  then peakL:=LevelL;
          if LevelR  > peakR  then peakR:=LevelR;
          Inc(PeakCounter);
          if PeakCounter*TimerRender.Interval>=500 then begin
            PeakCounter:=0;
            peakLClip:=false;peakRClip:=false;
            peakLClipf:=false;peakRClipf:=false;
            if peakLf>=(FFTSize div 2) then peakLClipf:=true;
            if peakRf>=(FFTSize div 2) then peakRClipf:=true;
            if peakL>=32767-(32767*0.05) then begin
              peakLClip:=true;
            end;
            if peakR>=32767-(32767*0.05) then begin
              peakRClip:=true;
            end;
            if (peakLClip or peakRClip) and autolevel.Checked then
              if tbVolume.Position>1 then
              begin
                tbVolume.Position:=tbVolume.Position-1;
              end;
          end;

          // clear old
          CanvasToDraw.pen.Style  :=psSolid;
          CanvasToDraw.pen.Color  :=sonopal[0];
          CanvasToDraw.brush.Style:=bsSolid;
          CanvasToDraw.brush.Color:=sonopal[0];
          CanvasToDraw.Rectangle(   0, 0, pl3, h);
          if (not mono.Checked) then
          CanvasToDraw.Rectangle(w-pl3, 0,  w, h);
          CanvasToDraw.pen.Width:=pixelwidth;

          if (mono.Checked) then begin
            LevelLf:=(LevelLf+LevelRf) div 2;
            LevelL :=(LevelL +LevelR ) div 2;
          end;

          // draw new fft-level aussen rum
          CanvasToDraw.pen.Color  :=sonopal[VolColIdx1];
          CanvasToDraw.brush.Color:=sonopal[0];
          CanvasToDraw.Rectangle(      ph, h - Trunc(LevelLf / (FFTSize div 2) * (h-1)), pl3-ph, h);
          if (not mono.Checked) then
          CanvasToDraw.Rectangle(w-pl3+ph, h - Trunc(LevelRf / (FFTSize div 2) * (h-1)),  w-ph, h);

          // draw new fft-level aussen rum peaks
          y:=h - Trunc(peakLf / (FFTSize div 2) * (h -1));
          CanvasToDraw.Rectangle(     ph, y,   pl3-ph, y+ph);
          if (not mono.Checked) then begin
          y:=h - Trunc(peakRf / (FFTSize div 2) * (h -1));
          CanvasToDraw.Rectangle(w-pl3+ph, y,    w-ph, y+ph);
          end;

          CanvasToDraw.pen.Width:=1;
          CanvasToDraw.Pen.Style:=psDot;
          // sensitivity for LevelLf
          CanvasToDraw.moveto(pl3+ph-2, ClientHeight-trunc(SensitivityF/100*ClientHeight));
          CanvasToDraw.LineTo(pl3+ph+pixelwidth*2-2, CanvasToDraw.PenPos.Y);
          // sensitivity for LevelRf
          CanvasToDraw.moveto(w-pl3-pixelwidth*2, ClientHeight-trunc(SensitivityF/100*ClientHeight));
          CanvasToDraw.LineTo(w-pl3, CanvasToDraw.PenPos.Y);

          CanvasToDraw.pen.Color  :=sonopal[VolColIdx2];
          // sensitivity for LevelL LevelR
          CanvasToDraw.moveto(pl3+ph-2, ClientHeight-trunc(Sensitivity/100*ClientHeight));
          CanvasToDraw.LineTo(pl3+ph+pixelwidth*2-2, CanvasToDraw.PenPos.Y);
          // sensitivity for LevelL LevelR
          CanvasToDraw.moveto(w-pl3-pixelwidth*2, ClientHeight-trunc(Sensitivity/100*ClientHeight));
          CanvasToDraw.LineTo(w-pl3, CanvasToDraw.PenPos.Y);


          CanvasToDraw.pen.Width:=pixelwidth;
          CanvasToDraw.brush.Style:=bsSolid;

          // draw new level innen drin
          CanvasToDraw.pen.Color  :=sonopal[VolColIdx2];
          CanvasToDraw.brush.Color:=sonopal[VolColIdx2];
          CanvasToDraw.Rectangle(  pl1+ph, h - Trunc(LevelL / 32768 * (h-1)),   pl2-ph, h);
          if (not mono.Checked) then
          CanvasToDraw.Rectangle(w-pl2+ph, h - Trunc(LevelR / 32768 * (h-1)), w-pl1-ph, h);

          // draw new level innen drin peaks
          y:=h - Trunc(peakL / 32768 * (h -1));
          CanvasToDraw.Rectangle(  pl1+ph, y,   pl2-ph, y+pl1);
          if (not mono.Checked) then begin
          y:=h - Trunc(peakR / 32768 * (h -1));
          CanvasToDraw.Rectangle(w-pl2+ph, y, w-pl1-ph, y+pl1);
          end;

          // clipping/oversteer
          CanvasToDraw.pen.Color  :=sonopal[255];
          CanvasToDraw.brush.Color:=sonopal[255];
          if peakLClip then
          CanvasToDraw.Rectangle(      ph, 0, pl3-ph, ph);
          if peakRClip and (not mono.Checked) then
          CanvasToDraw.Rectangle(w-pl3+ph, 0,   w-ph, ph);

          Dec(peakLf,max(1,FFTpromille div 16)); // 1% of FFTbins
          Dec(peakRf,max(1,FFTpromille div 16)); // 1% of FFTbins
          Dec(peakL,trunc(32767*0.0025));
          Dec(peakR,trunc(32767*0.0025));

          CanvasToDraw.pen.Width:=1;
          CanvasToDraw.pen.Color:=sonopal[0];
          CanvasToDraw.brush.Color:=sonopal[0];
          CanvasToDraw.brush.Style:=bsSolid;

        end; // paint level-meter ende ende ende ende ende ende ende ende

        FormPaint(sender);

        // freq-scala and mouse info
        if (HzInfo.Checked) then
        begin
          //SetBkMode(FormPlayer.Canvas.Handle, TRANSPARENT);
          //SetBkMode(Canvas.Handle,OPAQUE);
          //SetBkMode(Canvas.Handle,TRANSPARENT);
          //FormPlayer.canvas.Pen.Style:=psDot;
          canvas.Lock;
          canvas.Pen.Color:=SonoPal[SplitLineColorIdx];
          Canvas.Brush.Style:=bsClear;

          // freq-scala
          last:=PixelMaxX;
          lastextval:=0;
          if (DrawMode.ItemIndex=1) then
          for i:=PixelMaxX downto 10 do
          begin
            extval:=trunc((i)/(PixelMaxX)*PixelMax);
            if (trunc(extval) < PixelMaxX) and (trunc(extval) >=0) and (extval<MAXFFTSIZE) then
            begin
              extval:=RoundTo(Freqarray[trunc(extval-1)],2);
              //if (Freqarray[trunc(extval-1)]<100) then
              //  extval:=RoundTo(Freqarray[trunc(extval-1)],1);
              if ( (last=PixelMaxX) and (extval<> 0)) or
                 ( ( ( (extval>=10000) and (trunc(extval) mod 1000 = 0)) or
                     ( (extval>1000) and (extval<10000) and (trunc(extval) mod 1000 = 0)) or
                     ( (extval<=1000) and (trunc(extval) mod 100 = 0)) or
                     ( (extval<100)   and (trunc(extval) mod 10 = 0))   )
                   and
                  (extval<>0) and
                  (lastextval<>extval) and
                  (i<last-19)) then
              begin
                //canvas.MoveTo(w-5,h-i); canvas.LineTo(w,h-i);
                canvas.MoveTo(mL-2,h-i); canvas.LineTo(mL+2,h-i);
                lastextval:=RoundTo(extval,2);
                if last=PixelMaxX then begin
                  s:=FloatToStrF(Freqarray[PixelMaxX],ffnumber,12,0) +' Hz';
                  lastextval:=RoundTo(extval,3);
                end else if extval>=1000 then begin
                  if (trunc(extval) mod 1000 = 0) then
                  s:=FloatToStrF(RoundTo(extval,1)/1000,ffnumber,12,0)+' kHz'
                  else
                  s:=FloatToStrF(RoundTo(extval,1)/1000,ffnumber,12,1)+' kHz';
                end else
                s:=FloatToStrF(RoundTo(extval,1),ffnumber,12,0)+' Hz';
                //s:=s + ' ' + NoteStrings[trunc((i)/(PixelMaxX)*PixelMax)];
                //s:=s + ' ' + NoteStrings2[trunc((i)/(PixelMaxX)*PixelMax)];
                //Str((extval/1000):0:0,s);
                //ShadowTextOut(canvas,w-canvas.TextWidth(s)-2,h-i,s);
                ShadowTextOut(canvas,mL-canvas.TextWidth(s)-2,h-i,s);
                last:=i;
              end;
            end;
          end;
          if (PixelMaxX<PixelMax) and (DrawMode.ItemIndex=1) then begin
            extval:=RoundTo(Freqarray[PixelMaxx-1],2);
            canvas.MoveTo(w-5,h-PixelMaxX);
            canvas.LineTo(w,h-PixelMaxX);
            s:=FloatToStrF(Freqarray[trunc(extval)-1],ffnumber,12,2);
            ShadowTextOut(canvas,w-canvas.TextWidth(s+' kHz')-2,h-PixelMaxX,s+' kHz');
          end;
          (**)
          // mouse position/cursor
          tp:=ScreenToClient(Mouse.CursorPos);
          x:=tp.x;
          y:=tp.y;
          if (x>=ClientRect.Left) and (x<ClientRect.Right) and
             (y>=ClientRect.Top) and (y<ClientRect.Bottom)then
          begin
            fidx:=0;
            if not mono.Checked then begin
              case DrawMode.ItemIndex of
              0  :begin if (y < h div 2) then s:='L' else s:='R'; fidx:=x; end;
              1  :begin if (x < w div 2) then s:='L' else s:='R'; fidx:=h-y; end;
              2,3:begin if (y < h div 2) then s:='L' else s:='R'; fidx:=abs((h div 2) - y); end;
              4,5:begin if (x < w div 2) then s:='L' else s:='R'; fidx:=abs((w div 2) - x); end;
              end;
            end else begin
              case DrawMode.ItemIndex of
              0  :begin if (y < h div 2) then s:='L' else s:='R'; fidx:=x; end;
              1  :begin if (x < w div 2) then s:='L' else s:='R'; fidx:=h-y; end;
              2,3:begin if (y < h div 2) then s:='L' else s:='R'; fidx:=abs(h - y); end;
              4,5:begin if (x < w div 2) then s:='L' else s:='R'; fidx:=abs(w - x); end;
              end;
            end;
            if mono.Checked then s:='' else
              if SwapChannels.Checked then
                if s='L' then s:='R' else s:='L';
            if fidx<=PixelMaxX then
            begin
              extval:=FreqArray[trunc(fidx/(PixelMaxX-1)*PixelMax)];
              if (extval > SampleRate div 2) then
                extval:=SampleRate div 2;
              if extval>10000 then
                s:=s+' '+FloatToStrF(extval/1000,ffNumber,12,1)+' kHz'
              else
                s:=s+' '+FloatToStrF(extval,ffNumber,12,0)+' Hz';
              // notes only below 20500Hz
              if (extval>15) and (extval<20500) then
                s:=s+' '+NoteStrings[trunc(fidx/(PixelMaxX      )*PixelMax)];
              if x > VisBuff.width div 2 then
                x:=x-canvas.TextWidth(s)-3 else inc(x,3);
              if y > VisBuff.Height div 2 then
                y:=y-12 else inc(y,2);
              //FormPlayer.canvas.TextOut(x,y,FloatToStrF(extval,ffNumber,12,2)+'Hz')
              ShadowTextOut(canvas,x,y,s);
              Canvas.Brush.Style:=bsSolid;
              Canvas.Brush.Color:=SonoPal[SplitLineColorIdx];
            end;
          end;
          //CanvasToDraw.Pen.Color := sonopal[0];
          //CanvasToDraw.Brush.Color := sonopal[0];
          //CanvasToDraw.brush.style:=bssolid;
          FormPlayer.canvas.unLock;
        end; // if HZinfo.checked

        {}
        // silence detection
        l1:=trunc((LevelLf / (FFTSize div 2))*100);
        r1:=trunc((LevelRf / (FFTSize div 2))*100);
        if (cbRec.Checked) and
           (yet2sec OR ((l1 > SensitivityF  ) and (r1 > SensitivityF))) then
        begin
          if          (l1 < SpinSono.Value) and (r1 <  SpinSono.Value) then
          begin
              Inc(silence)
          end else if (l1 >= SpinSono.Value) and (r1 >= SpinSono.Value) then
          begin
              yet2sec := True;
              silence := 0;
              if not dorec then
                  btRecClick(sender);
          end;

          if silence mod 15 = 0 then
          label21.Caption:=floattostrF(silDuration-silence* TimerRender.Interval,ffNumber,8,0);

          if (silence     * TimerRender.Interval >= silDuration) then
          begin
              // lange genug wars stille, stop recording
              label21.Caption:='silence';
              yet2sec := false;
              silence := 0;
              minxL := FFTSize;
              minxR := FFTSize;
              maxxL := 0;
              maxxR := 0;
              btRecClick(sender);
          end;

        end else begin
          Inc(silence);
          if (silence * TimerRender.Interval >= silDuration) then
            silence := 0;
        end; // silence detection end
        {}
      end; // not minimized


      //TimerStop1;
      //TimerStart1;
      //label16.Caption:=TimerAsString1;
      //label26.Caption:=TimerAsString1;

    end;

    //if (fps mod 20 = 0) then
    //  BlendWinAPI(VisBuff,VisBlack,VisBuff,15);

    // fps info and second-marker
    Inc(fps);
    if dataavail=0 then
    Inc(missingcount);
    appnow:=GetTickCount()-AppLast;
    if appnow>=1000 then
    begin
      AppLast:=GetTickCount();
      lbfps.Caption:=inttostr(fps)+' fps';
      lbMissing.Caption:=inttostr(missingcount)+' frames missing';
      fps:=0;
      missingcount:=0;
      if HzInfo.Checked then 
      begin
        if (HzInfo.Checked or HzInfo.Checked) and (DrawMode.itemindex=1) then
        begin
          CanvasToDraw.Pen.Color:=SonoPal[SplitLineColorIdx];
          CanvasToDraw.Brush.Style:=bsClear;
          CanvasToDraw.MoveTo(mL-4,0);
          CanvasToDraw.LineTo(mL-4,5);
          if not mono.Checked then begin
            CanvasToDraw.MoveTo(mR+4,0);
            CanvasToDraw.LineTo(mR+4,5);
          end;
        end;
      end;
    end;

    // paint level-lines onto graphic
    if Hiddenpanel.Visible then
    begin
        lb15.Caption := floattostrf(maxLf,ffNumber,8,2); lb15.Refresh;
        lb16.Caption := floattostrf(minLf,ffNumber,8,2); lb15.Refresh;

        // print out level-values
        (**)
        if LevelLf > maxxL then begin
            maxxL := LevelLf;
            lb15.Caption := IntToStr(maxxL); lb15.Refresh;
        end;
        if LevelLf < minxL then begin
            minxL := LevelLf;
            lb16.Caption := IntToStr(minxL); lb16.Refresh;
        end;
        if LevelRf > maxxR then begin
            maxxR := LevelRf;
            lb17.Caption := IntToStr(maxxR); lb17.Refresh;
        end;
        if LevelRf < minxR then begin
            minxR := LevelRf;
            lb18.Caption := IntToStr(minxR); lb18.Refresh;
        end;
        (**)

        divisor := 1; // 8 mal timer-intervall
        TimerRender.Tag := TimerRender.Tag + 1;
        //if false then
        if TimerRender.Tag mod divisor = 0 then
        begin
            TimerRender.Tag := 0;
            (*
            // dim volume
            zw := ( (oldLevelL + LevelL) / 2 + (oldLevelR + LevelR) / 2) / 65536;
            //zw:=(((oldLevelLf+LevelLf)/2)+((oldLevelRf+LevelRf)/2))/4096;
            if cb_volumescale.Checked then
            begin
                if (zw * 100 > 100 - tbmaxlimit.Position)
                    //and (100-LeftScroll.Position>tbmaxlimit.Position)
                then begin
                    if LeftScroll.Position < tbminlimit.position then
                       LeftScroll.Position := LeftScroll.Position + Trunc(divisor);
                end else if (zw * 100 < 50) then begin
                    if LeftScroll.Position > tbmaxlimit.Position then
                       LeftScroll.Position := LeftScroll.Position - Trunc(divisor div 3);
                end;
            end;

            (**-) // average from Level and FFT
            if ShowLevel.Checked then
            begin
              CanvasToDraw.Pen.Color := sonopal[64];
              zwL:=h - Trunc(  (((LevelLf/(FFTSize div 2))+(LevelL/32768))/2)  *h   );
              //zwL:=h - Trunc((LevelLf/(FFTSize div 2)) * h);
              if dblpxl.Checked then tp.X := (FormPlayer.ClientWidth div 2) - divisor * 2
                                else tp.X := (FormPlayer.ClientWidth div 2) - divisor;
              tp.Y := oldzwL; //h - Trunc(oldzwL * h);
              CanvasToDraw.PenPos := tp;
              CanvasToDraw.LineTo((FormPlayer.ClientWidth div 2) - 1, zwL);

              zwR:=h - Trunc((((LevelRf/(FFTSize div 2))+(LevelR/32768))/2) * h);
              //zwR:=h - Trunc((LevelRf/(FFTSize div 2)) * h);
              if dblpxl.Checked then tp.X := (FormPlayer.ClientWidth div 2) + divisor * 2
                                else tp.X := (FormPlayer.ClientWidth div 2) + divisor;
              tp.Y := oldzwR; //h - Trunc(oldzwR * h);
              CanvasToDraw.PenPos := tp;
              CanvasToDraw.LineTo((FormPlayer.ClientWidth div 2) + 1, zwR);
            end;
            (**)
        end;

        (**)
        // levellines
        if ShowLevel.Checked then
        if (oldLevelLf=0) and (oldLevelRf=0) and (oldLevelR=0) and (oldLevelL=0) then begin
            // the first draw
            CanvasToDraw.Pixels[(FormPlayer.ClientWidth div 2)-1, FormPlayer.ClientHeight-Trunc(LevelLf/1024*FormPlayer.ClientHeight)]:=clLime;
            CanvasToDraw.Pixels[(FormPlayer.ClientWidth div 2)+1, FormPlayer.ClientHeight-Trunc(LevelRf/1024*FormPlayer.ClientHeight)]:=clLime;
            CanvasToDraw.Pixels[(FormPlayer.ClientWidth div 2)-1, FormPlayer.ClientHeight-Trunc(LevelL/32768*FormPlayer.ClientHeight*2)]:=sonopal[128];
            CanvasToDraw.Pixels[(FormPlayer.ClientWidth div 2)+1, FormPlayer.ClientHeight-Trunc(LevelR/32768*FormPlayer.ClientHeight*2)]:=sonopal[128];
        end else begin
            // sensitivity level line
            (**-)
            //SetBkMode(CanvasToDraw.Handle, TRANSPARENT);
            CanvasToDraw.Pen.Color:=sonopal[64];
            CanvasToDraw.Pen.Style:=psDot;
            CanvasToDraw.moveto(0,ClientHeight-trunc(Sensitivity/256*ClientHeight));
            CanvasToDraw.LineTo(W, CanvasToDraw.PenPos.Y);
            (**)
            CanvasToDraw.Pen.Style:=pssolid;

            (**) // LevelF
            CanvasToDraw.Pen.Color:=sonopal[VolColIdx1];
            // left
            if dblpxl.Checked then tp.X:=(w div 2)-4
                              else tp.X:=(w div 2)-2;
            tp.Y:=h-Trunc((oldLevelLf)/(FFTSize div 2)*h);
            CanvasToDraw.PenPos:=tp;
            CanvasToDraw.LineTo((FormPlayer.ClientWidth div 2)-1, h-Trunc(LevelLf/(FFTSize div 2)*h));

            // right
            if dblpxl.Checked then tp.X:=(w div 2)+4
                              else tp.X:=(w div 2)+2;
            tp.Y:=h-Trunc((oldLevelRf)/(FFTSize div 2)*h);
            CanvasToDraw.PenPos:=tp;
            CanvasToDraw.LineTo((w div 2)+1, h-Trunc(LevelRf/(FFTSize div 2)*h));
            (**)

            (**) // Level
            CanvasToDraw.Pen.Color:=sonopal[VolColIdx2];
            if dblpxl.Checked then tp.X:=(FormPlayer.ClientWidth div 2)-2
                              else tp.X:=(FormPlayer.ClientWidth div 2)-1;
            tp.Y:=h-Trunc((oldLevelL/(32768))*h);
            CanvasToDraw.PenPos:=tp;
            CanvasToDraw.LineTo((FormPlayer.ClientWidth div 2)-1, h-Trunc((LevelL/(32768))*h));

            if dblpxl.Checked then tp.X:=(FormPlayer.ClientWidth div 2)+2
                              else tp.X:=(FormPlayer.ClientWidth div 2)+1;
            tp.Y:=h-Trunc((oldLevelR/(32768))*h);
            CanvasToDraw.PenPos:=tp;
            CanvasToDraw.LineTo((FormPlayer.ClientWidth div 2)+1, h-Trunc((LevelR/(32768))*h));
            (**)

        end;
        (**)

        oldLevelL := LevelL;
        oldLevelR := LevelR;
        oldLevelLf:= LevelLf;
        oldLevelRf:= LevelRf;
        oldzwL := zwL;
        oldzwR := zwR;
    end;
    {}
    //else if maxxL<250  then SpinScale.Value:=120
    //else if maxxL<500  then SpinScale.Value:=60
    //else if maxxL<777 then SpinScale.Value:=30;
//TimerStart3;
//TimerStop3;
//label16.Caption:=FloatToStrF(TimerAsSeconds3,ffNumber,12,6);
end;

////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////

procedure TFormPlayer.Button4Click(Sender: TObject);
begin
    seconds := 0;
    minxL := FFTSize;
    minxR := FFTSize;
    maxxL := 0;
    maxxR := 0;
end;

procedure TFormPlayer.ScaleBChange(Sender: TObject);
begin
  contrast :=ScaleC.Position;
  bright   :=ScaleB.Position;
  fExponent:=256/power(bright,contrast);

  Label10.Caption:=inttostr(trunc(Scalec.Position/256*100))+'% contr';
  //Label10.Caption:=floattostrf(0.5+contrast/512,ffNumber,8,4);
  Label29.Caption:=inttostr(trunc(ScaleB.Position/256*100))+'% brigh';
  maxLf:=0;
  minLf:=0;
  setVars;
  //MakePaletteGDI; 
end;

procedure TFormPlayer.varinfo(y:integer; info:string);
var P : TPoint;
begin
  P:=CanvasToDraw.PenPos; // save
  CanvasToDraw.Font.Color:=clSilver;
  CanvasToDraw.Brush.Color:=clBlack;
  CanvasToDraw.pen.Color:=clBlack;
  CanvasToDraw.Rectangle(10,ClientHeight-50-y,50,ClientHeight-50-y+15);
  CanvasToDraw.TextOut(10, ClientHeight-50-y, info);
  CanvasToDraw.PenPos:=P; // setback
end;

// --- drawing function is quite simple but long ---
procedure TFormPlayer.Draw;

    // sub-function with amplitude-scaling is long
    procedure DrawPoint(PixelPos:integer;aL,aR:double);

        procedure specialline(x1,y1,x2,y2:integer);
        var x,y:integer;
            last,curr, dx:integer;
        begin
          last:=0;
          dx:=x2-x1;
          for x:=x1 to x2 do begin
            curr:=trunc((dx-(x2-x))/dx*offset);
            //if last<>curr then
            begin
              CanvasToDraw.Pixels[x,y1]:=sonopal[curr];
              //last:=curr;
            end;
          end;
        end;

    var bL,bR:double; // scale up to 256
        aL1,aR1,
        aL2,aR2: double;
        a,b:double;
        dv:double;
        x1,x2,y1,y2,
        dx2,dy2:integer;
        addenum:integer;
        minx,maxx:double;
    begin
        if AmplScale1.Checked then begin
            //aL:=LogPos2Freq2(aL,1,contrast)*bright/8;
            //aR:=LogPos2Freq2(aR,1,contrast)*bright/8;
            //aL:=AmplitudeArray[trunc(aL)]*bright;
            //aR:=AmplitudeArray[trunc(aR)]*bright;

            aL:=LogPos2Ampl(nteWurzel(aL,1+(contrast/256)),1,256)*bright/256;
            aR:=LogPos2Ampl(nteWurzel(aR,1+(contrast/256)),1,256)*bright/256;

            //trunc(nteWurzel(aL,1+(contrast/128)*2)*bright)            
            //trunc(nteWurzel(aR,1+(contrast/128)*2)*bright)            
            //aL:=nteWurzel(aL,1+(contrast/255))*bright*2;
            //aR:=nteWurzel(aR,1+(contrast/255))*bright*2;

            // 1 - low contrast
            // v3.1
            //aL:=nteWurzel(aL*contrast,512/((512-contrast*aL*255)))*bright; // /nteWurzel(1,AmplScaleValue.Position); //*AmplScaleValue.Position;
            //aR:=nteWurzel(aR*contrast,512/((512-contrast*aR*255)))*bright; // /nteWurzel(1,AmplScaleValue.Position); //*AmplScaleValue.Position;

            //aL:=aL + ((255- ((Abs(127-aL*256)*contrast) / 255) )*bright) / 255;
            //aL:=aL + ((255- ((Abs(127-aL*256)*contrast) / 255) )*bright) / 255;
            //aR:=aR + ((255- ((Abs(127-aR*256)*contrast) / 255) )*bright) / 255;
            //al:=aL+((255-aL)*bright)div 255;
            //    (Abs(127-aL)*contrast)div 255;

            // bright
            // r+((255-r)*bright)div 255;
            // contrast
            // (Abs(127-r)*contrast)div 255;

            // ok!!!!
            //aL:=ntewurzel(aL,0.5+contrast/256)*bright*8;
            //aR:=ntewurzel(aR,0.5+contrast/256)*bright*8;

            //aL:=LogN(1.0+contrast/256, 1.0+nteWurzel(aL,bright/256)    )*128;
            //aR:=LogN(1.0+contrast/256, 1.0+nteWurzel(aR,bright/256)    )*128;

            //aL:=LogValue(aL,1+contrast/256,2)*bright;
            //aR:=LogValue(aR,1+contrast/256,2)*bright;

            minx:=1;
            maxx:=2;
            //aL:=ln(1+aL)/ln(1+contrast/256)*bright;
            //aR:=ln(1+aR)/ln(1+contrast/256)*bright;
            //aL:=AmplitudeArray[trunc(nteWurzel(aL,1+(bright/512)*2)*255)];
            //aR:=AmplitudeArray[trunc(nteWurzel(aR,1+(bright/512)*2)*255)];
            //aL:=AmplitudeArray[trunc(nteWurzel(aL,1+(contrast/128)*2)*bright)];
            //aR:=AmplitudeArray[trunc(nteWurzel(aR,1+(contrast/128)*2)*bright)];
            //aL:=AmplitudeArray[trunc(sqrt(aL)*bright)];
            //aR:=AmplitudeArray[trunc(sqrt(aR)*bright)];

            //aL:=AmplitudeArray[trunc(nteWurzel(aL,2+(contrast/255))*bright)];
            //aR:=AmplitudeArray[trunc(nteWurzel(aR,2+(contrast/255))*bright)];
            //aL:=trunc(nteWurzel(aL,1+(bright/512)*2)*255);
            //aR:=trunc(nteWurzel(aR,1+(bright/512)*2)*255);

            //aL:=AmplitueArray[trunc(ntewurzel(aL,1+contrast/256)*255)];
            //aR:=AmplitueArray[trunc(ntewurzel(aR,1+contrast/256)*255)];

            //LogPos2Freq(
            
            //aL:=ln(1+nteWurzel(aL,contrast/256))*bright;
            //aR:=ln(1+nteWurzel(aR,contrast/256))*bright;

            // linear
            //aL:=(aL)*ScaleB.Position*8;
            //aR:=(aR)*ScaleB.Position*8;
            (**)
            //aL:=nteWurzel(aL,ScaleB.Position)*30/nteWurzel(1,ScaleB.Position); //*ScaleB.Position;
            //aR:=nteWurzel(aR,ScaleB.Position)*30/nteWurzel(1,ScaleB.Position); //*ScaleB.Position;

        end else if AmplScale2.Checked then begin
            // 2 - normal contrast
            // v3.1
            //aL:=sqrt(aL)*bright*5;
            //aR:=sqrt(aR)*bright*5;
            aL:=(sqrt(aL))*bright*5;
            aR:=(sqrt(aR))*bright*5;

            //aL:=nteWurzel(aL*contrast*255,1/bright*256); // /nteWurzel(1,ScaleB.Position); //*ScaleB.Position;
            //aR:=nteWurzel(aR*contrast*255,1/bright*256); // /nteWurzel(1,ScaleB.Position); //*ScaleB.Position;


            //aL:=sqrt(aL)*6*ScaleB.Position;
            //aR:=sqrt(aR)*6*ScaleB.Position;

        end else if AmplScale3.Checked then begin
            // 3 - high contrast
            // v3.1
            aL:=bright/256+(bright/256*aL)*contrast*32;
            aR:=bright/256+(bright/256*aR)*contrast*32;

            //dv:=92;
            //a:=ScaleB.Position/256; //+((256-ScaleB.Position)/256)*aL;
            //aL:=((1-EXP((1-aL*(ScaleB.Position/256))*dv)/EXP(dv)))*ScaleB.Position;
            //a:=ScaleB.Position/256; //+((256-ScaleB.Position)/256)*aR;
            //aR:=((1-EXP((1-aR*(ScaleB.Position/256))*dv)/EXP(dv)))*ScaleB.Position;

            //aL:=LogPos2Freq(aL,1,4)*ScaleB.Position;
            //aR:=LogPos2Freq(aR,1,4)*ScaleB.Position;
            //Freq2LogPos
            //aL:=power(sqrt(aL),(1/Scaleb.Position*64)*2)*ScaleB.Position;
            //aR:=power(sqrt(aR),(1/Scaleb.Position*64)*2)*ScaleB.Position;

            //aL:=nteWurzel(aL,ScaleC.Position/256*32)*255;
            //aR:=nteWurzel(aR,ScaleC.Position/256*32)*255;
            //aL := 220+(LN(aL*256*ScaleC.Position*0.05/240)*80)+(270-aL*256)/240*(270-aL*256*Scaleb.Position)/2;
            //aR := 220+(LN(aR*256*ScaleC.Position*0.05/240)*80)+(270-aR*256)/240*(270-aR*256*Scaleb.Position)/2;
                  //220 + (LN(x * SpinScale.Value * 0.05 / 240) * 80) + (270 - x) / 240 * (270 - x * SpinScale.Value * 0.05) / 2);

        end else if AmplScale4.Checked then begin
            //aL:=Power(aL, contrast / 256) / Power(1, contrast / 256) * bright;
            //aR:=Power(aR, contrast / 256) / Power(1, contrast / 256) * bright;
                        
            aL:=Power(aL,1-contrast/256)*bright/256;
            aR:=Power(aR,1-contrast/256)*bright/256;

            // 4 - highest contrast
            // v3.1
            //aL:=256-power((257-ScaleB.Position)/257,1+aL*16)/power((257-ScaleB.Position)/257,1.0625)*255;
            //aR:=256-power((257-ScaleB.Position)/257,1+aR*16)/power((257-ScaleB.Position)/257,1.0625)*255;

            (* test *)
            //aL:=LogN(1.+ScaleC.Position/556, 1+nteWurzel(aL,ScaleB.Position/128)    )*56;
            //aR:=LogN(1.+ScaleC.Position/556, 1+nteWurzel(aR,ScaleB.Position/128)    )*56;

            //aL:=LogN(1.0+ScaleC.Position/556, 1.0+nteWurzel(aL,ScaleB.Position/128)    )*128;
            //aR:=LogN(1.0+ScaleC.Position/556, 1.0+nteWurzel(aR,ScaleB.Position/128)    )*128;
            // v3.3!!!!!!!!!!!!!!!!!!!!!!
            //aL:=LogN(1.0+contrast/256, 1.0+nteWurzel(aL,bright/256)    )*128;
            //aR:=LogN(1.0+contrast/256, 1.0+nteWurzel(aR,bright/256)    )*128;
            //aL := 220+(LN(aL*256*ScaleC.Position*0.05/240)*80)+(270-aL*256)/240*(270-aL*256*Scaleb.Position)/2;
            //aR := 220+(LN(aR*256*ScaleC.Position*0.05/240)*80)+(270-aR*256)/240*(270-aR*256*Scaleb.Position)/2;

            //aL:=power(aL*ScaleB.Position/255,ScaleC.Position/6)*256;
            //aR:=power(aR*ScaleB.Position/255,ScaleC.Position/6)*256;
            //aL := power(aL,exponent)*f * 128;
            //aR := power(aR,exponent)*f * 128;

            //HSV:=RGBToHSV(rgb);
            //with HSV do begin v:=v*bright; if v>1 then v:=1;   end;
            //rgb:=HSVtoRGB(Hsv);


            //aL:=LogPos2Freq(aL*255,0,256);
            //aR:=LogPos2Freq(aR*255,0,256);

            //aL:=nteWurzel(1+aL*ScaleB.Position/255,ScaleC.Position/12);
            //aR:=nteWurzel(1+aR*ScaleB.Position/255,ScaleC.Position/12);

            (**-)
            dv:=ScaleC.Position/8;
            a:=ScaleB.Position/256+((256-ScaleB.Position)/256)*aL;
            aL:=((1-EXP((1-aL)*dv)/EXP(dv)))*ScaleB.Position;
            a:=ScaleB.Position/256+((256-ScaleB.Position)/256)*aR;
            aR:=((1-EXP((1-aR)*dv)/EXP(dv)))*ScaleB.Position;
            (**)

            //aL:=nteWurzel(aL*Scalec.Position*255,1/(Scaleb.Position)); // /nteWurzel(1,ScaleB.Position); //*ScaleB.Position;
            //aR:=nteWurzel(aR*Scalec.Position*255,1/(Scaleb.Position)); // /nteWurzel(1,ScaleB.Position); //*ScaleB.Position;

            (*
            LogPos2Freq(x, min, max: double):double;
            Freq2LogPos(x, min, max: double):double;
            result:= x*(max-min) + min
            result:=(max-min)*( min *   power(  FreqLogFakt, x * (ln(max) - ln(min)) / ln(FreqLogFaktDiv)   ) - min) /
                              ( min *   power(  FreqLogFakt,     (ln(max) - ln(min)) / ln(FreqLogFaktDiv)   ) - min)
                              + min;
            result:= (x - min)/(max-min)
            result:= ln(((x-min) * (min * power(FreqLogFakt, (ln(max) - ln(min))/
                     ln(FreqLogFaktDiv)) - min) / (max-min) + min) /
                     ln(FreqLogFakt)) * ln(FreqLogFaktDiv) / (ln(max) - ln(min));
            *)
            //dv:=64;
            //aL:=power(dv,dv-1+aL*255)/power(dv,dv)*ScaleB.Position/32;
            //aR:=power(dv,dv-1+aR*255)/power(dv,dv)*ScaleB.Position/32;

            aL:=Log2(1+sqrt(aL))/Log2(2)*bright;
            aR:=Log2(1+sqrt(aR))/Log2(2)*bright;

            //aL:=256-((Scalec.Position/256)+((1-EXP((1-aL)*ScaleB.Position)/EXP(ScaleB.Position))*((Scaleb.Position)/((Scalec.Position)*aL))));//*Scalec.Position/8;
            //aR:=256-((Scalec.Position/256)+((1-EXP((1-aR)*ScaleB.Position)/EXP(ScaleB.Position))*((Scaleb.Position)/((Scalec.Position)*aR))));//*Scalec.Position/16;
            //aL:=(Scaleb.Position/8*sqrt(aL))/(1/(Scaleb.Position/8));
            //aR:=(Scaleb.Position/8*sqrt(aR))/(1/(Scaleb.Position/8));
            
            
            //aL:=((ScaleB.Position/256)+((1-EXP((1-aL)*ScaleB.Position)/EXP(ScaleB.Position))*((256-ScaleB.Position)/ScaleB.Position)))*17;
            //aR:=((ScaleB.Position/256)+((1-EXP((1-aR)*ScaleB.Position)/EXP(ScaleB.Position))*((256-ScaleB.Position)/ScaleB.Position)))*17;
            //AmplBase.Position/256+((256-AmplBase.Position)/256)*aL
            
            //aL:=Exp(2+sqrt(aL)*(ScaleB.Position-1));
            //aR:=Exp(2+sqrt(aR)*(ScaleB.Position-1));
            //aL:=Exp(aL/ScaleB.Position);
            //aR:=Exp(aR/ScaleB.Position);

            //aL:=nteWurzel(aL/256,ScaleB.Position/64)*256; // /nteWurzel(1,ScaleB.Position); //*ScaleB.Position;
            //aR:=nteWurzel(aR/256,ScaleB.Position/64)*256; // /nteWurzel(1,ScaleB.Position); //*ScaleB.Position;
            //$C$1/256+(($C$2-$C$1)/256)*C8

            //aL:=((ScaleB.Position/256*aL/256)*(256-aL))*256 + sqrt(aL)*ScaleB.Position;
            //aR:=((ScaleB.Position/256*aR/256)*(256-aR))*256 + sqrt(aR)*ScaleB.Position;

            //YValLs:=nteWurzel(L1/LogN(AmplLogFakt,sc),AmplLogFakt)*AmplLogFakt*5;
            //YValRs:=nteWurzel(R1/LogN(AmplLogFakt,sc),AmplLogFakt)*AmplLogFakt*5;

            // excel: (value^ScaleFaktor/256))/(256^(ScaleFaktor/256))*256

            //aL:=trunc(( 0.42 - 0.5*cos(pi * aL * ScaleB.Position*10) + 0.08*cos(2*pi * aL * ScaleB.Position*10)) *28);
            //aR:=trunc(( 0.42 - 0.5*cos(pi * aR * ScaleB.Position*10) + 0.08*cos(2*pi * aR * ScaleB.Position*10)) *28);

            //aL:=(power(aL,ScaleB.Position/256))/(power(256,ScaleB.Position/256))*256;
            //aR:=(power(aR,ScaleB.Position/256))/(power(256,ScaleB.Position/256))*256;
            //aL:=(1+SIN(-PI/2+ScaleB.Position/256*PI+AL/256*PI))/2*256;
            //aR:=(1+SIN(-PI/2+ScaleB.Position/256*PI+AR/256*PI))/2*256;
            //if option1.Checked then begin
            //end else begin
            //end;
        end;

        if aL>255 then aL:=255; if aL<0 then aL:=0;
        if aR>255 then aR:=255; if aR<0 then aR:=0;
        if aL>maxLf then maxLf:=aL;
        if aL<minLf then minLf:=aL;
        if (aL<effect1.Position) and (aR<effect1.Position) then exit;
        avgL:=(aL+avgL)/2;
        avgR:=(aR+avgR)/2;

        aL1:=(aL+lastaL[PixelPos])/2;
        aR1:=(aR+lastaR[PixelPos])/2;
        //aL2:=(aL+)/2;
        //aR2:=(aR+lastR[PixelPos+1])/2;
        lastaL[PixelPos]:=aL; //aL;
        lastaR[PixelPos]:=aR; //aR;

        case DrawMode.ItemIndex of
           0: begin // horizontal u/d
                CanvasToDraw.Pixels[               (PixelPos)+1, mL-scrollL-1     ] := sonoPal[trunc(aL )];
                if not mono.Checked then
                CanvasToDraw.Pixels[               (PixelPos)+1, mR+scrollR+1     ] := sonoPal[trunc(aR )];
                if dblpxl.Checked then begin
                CanvasToDraw.Pixels[               (PixelPos)+1, mL-scrollL-2     ] := sonoPal[trunc(aL1 )];
                if not mono.Checked then
                CanvasToDraw.Pixels[               (PixelPos)+1, mR+scrollR+2     ] := sonoPal[trunc(aR1 )];
                end; end;
           1: begin // vertical r/l
                addenum:=0;
                if opt2.Checked then 
                begin
                    addenum:=effect2.Position+2;
                    //if (PixelPos mod TrackBar1.Position = 0) then
                    //if (PixelPos mod 2 = 0) then
                    begin
                        if (aL>0) then //>effect1.Position) then
                        begin
                            //if (PixelPos>30) and (PixelPos<32) then begin
                            //if (PixelPos=30) then begin
                            CanvasToDraw.Brush.Color:=sonoPal[trunc(aL )];
                            CanvasToDraw.Pen.Color  :=sonoPal[trunc(aL )];
                            CanvasToDraw.Pen.Width  :=trunc(aL/256*effect2.Position)+1;
                            CanvasToDraw.MoveTo(ml-1,h-PixelPos);
                            CanvasToDraw.LineTo(ml-1,h-PixelPos+1);
                            //CanvasToDraw.Brush.

                            (*
                            dx2:=effect2.Position-trunc(aL/256* effect2.Position       )+1;
                            dy2:=effect2.Position-trunc(aL/256*(effect2.Position div 2))+1;
                            x1:=mL-dx2*2;
                            x2:=mL;
                            y1:=H-PixelPos-dy2;
                            y2:=H-PixelPos+dy2;
                            //SetArcDirection(Image1.canvas.Handle,1);
                            CanvasToDraw.Arc(x1,y1,x2,y2,
                                             x2-dx2,y1,
                                             x1+dx2,y2);
                            //CanvasToDraw.Ellipse(x1   ,  y1,x2   ,y2);
                            {CanvasToDraw.Arc(x1,y1,x2,y2,
                                             x2-(dx2 div 2)-effect2.Position,y1,
                                             x2+(dx2 div 2)  ,y2);}
                            *)
                        end;
                        {}
                        if not mono.checked then //(aR>effect1.Position) then
                        if (aR>0) then //
                        begin
                            CanvasToDraw.Brush.Color:=sonoPal[trunc(aR )];
                            CanvasToDraw.Pen.Color  :=sonoPal[trunc(aR )];
                            CanvasToDraw.Pen.Width  :=trunc(aR/256*effect2.Position)+1;
                            CanvasToDraw.MoveTo(mr+1,h-PixelPos);
                            CanvasToDraw.LineTo(mr+1,h-PixelPos+1);
                            (*
                            dx2:=effect2.Position-trunc(aR/256* effect2.Position       )+1;
                            dy2:=effect2.Position-trunc(aR/256*(effect2.Position div 2))+1;
                            x1:=mR+10;
                            x2:=mR+10+dx2*2;
                            y1:=H-PixelPos-dy2;
                            y2:=H-PixelPos+dy2;
                            //CanvasToDraw.Ellipse(x1   ,  y1,x2   ,y2);
                            CanvasToDraw.Arc(x1,y1,x2,y2,
                                             x2-dx2,y2,
                                             x2-dx2,y1);
                            x1:=mR+20;
                            x2:=mR+20+dx2*2;
                            y1:=H-PixelPos-dy2+5;
                            y2:=H-PixelPos+dy2+5;
                            CanvasToDraw.Arc(x1,y1,x2,y2,
                                             x2-dx2,y2,
                                             x2-dx2,y1);
                            *)
                        end;
                        {}
                    end;
                    CanvasToDraw.Pen.width:=1;
                end else begin
                    addenum:=0;
                    CanvasToDraw.Pixels[      mL-scrollL-addenum-1, H-(PixelPos)+1        ] := sonoPal[trunc(aL )];
                    if not mono.Checked then
                    CanvasToDraw.Pixels[      mR+scrollR+addenum+1, H-(PixelPos)+1        ] := sonoPal[trunc(aR )];

                    if dblpxl.Checked then begin
                    CanvasToDraw.Pixels[      mL-scrollL-addenum-2, H-(PixelPos)+1        ] := sonoPal[trunc(aL1 )];
                    if not mono.Checked then
                    CanvasToDraw.Pixels[      mR+scrollR+addenum+2, H-(PixelPos)+1        ] := sonoPal[trunc(aR1 )];
                    end;
                end;
                if VolLevel.Checked and Mono.Checked then begin
                    //specialline(mR,                        H-(PixelPos)+1,
                    //            mR + trunc(aL/256*offset), H-(PixelPos)+1);
                    CanvasToDraw.Pen.Color:=sonoPal[trunc(aL )];
                    CanvasToDraw.MoveTo(mR, H-(PixelPos)+1);
                    CanvasToDraw.LineTo(mR + trunc(aL/256*offsetend)       , H-(PixelPos)+1);
                    if pixelpos mod 3 = 0 then begin
                    CanvasToDraw.MoveTo(mR + offsetstart + trunc(avgLl/256*offsetend)+1, H-(PixelPos-4));
                    CanvasToDraw.LineTo(mR + offsetstart + trunc(avgL /256*offsetend)+1, H-(PixelPos-1));
                    avgLl:=avgL;
                    avgRl:=avgR;
                    avgL:=0;
                    avgR:=0;
                    end;
                end;

              end;
           2: begin // right to left
                CanvasToDraw.Pixels[        W-scrollL-1, mL-(PixelPos)        ] := sonoPal[trunc(aL )];
                if not mono.Checked then
                CanvasToDraw.Pixels[        W-scrollR-1, mR+(PixelPos)        ] := sonoPal[trunc(aR )];
                if dblpxl.Checked then begin
                CanvasToDraw.Pixels[        W-scrollL-2, mL-(PixelPos)        ] := sonoPal[trunc(aL1 )];
                if not mono.Checked then   
                CanvasToDraw.Pixels[        W-scrollR-2, mR+(PixelPos)        ] := sonoPal[trunc(aR1 )];
                end; end;
           3: begin // left to right
                CanvasToDraw.Pixels[          scrollL+1, mL-(PixelPos)        ] := sonoPal[trunc(aL )];
                if not mono.Checked then
                CanvasToDraw.Pixels[          scrollR+1, mR+(PixelPos)        ] := sonoPal[trunc(aR )];
                if dblpxl.Checked then begin
                CanvasToDraw.Pixels[          scrollL+2, mL-(PixelPos)        ] := sonoPal[trunc(aL1 )];
                if not mono.Checked then
                CanvasToDraw.Pixels[          scrollR+2, mR+(PixelPos)        ] := sonoPal[trunc(aR1 )];
                end; end;
           4: begin // up
                CanvasToDraw.Pixels[    mL-1-(PixelPos),   scrollL-1          ] := sonoPal[trunc(aL )];
                if not mono.Checked then
                CanvasToDraw.Pixels[    mR+1+(PixelPos),   scrollR-1          ] := sonoPal[trunc(aR )];
                if dblpxl.Checked then begin
                CanvasToDraw.Pixels[    mL-1-(PixelPos),   scrollL-2          ] := sonoPal[trunc(aL1 )];
                if not mono.Checked then                               
                CanvasToDraw.Pixels[    mR+1+(PixelPos),   scrollR-2          ] := sonoPal[trunc(aR1 )];
                end; end;
           5: begin // down
                CanvasToDraw.Pixels[    mL-1-(PixelPos), H-scrollL            ] := sonoPal[trunc(aL )];
                if not mono.Checked then
                CanvasToDraw.Pixels[    mL+1+(PixelPos), H-scrollR            ] := sonoPal[trunc(aR )];
                if dblpxl.Checked then begin
                CanvasToDraw.Pixels[    mL-1-(PixelPos), H-scrollL-1          ] := sonoPal[trunc(aL1 )];
                if not mono.Checked then                   
                CanvasToDraw.Pixels[    mL+1+(PixelPos), H-scrollR-1          ] := sonoPal[trunc(aR1 )];
                end; end;
           
        end; // case
    end;

    procedure showendpoints(x1,y1,x2,y2:integer;col:TColor);
    begin
        CanvasToDraw.pen.Color:=col;
        CanvasToDraw.moveto(x2-2,y2-2);
        CanvasToDraw.LineTo(x2+2,y2+2);
    end;
    
var i,j,k,
    PixelPos, Pixelpos2,
    FFTPos              : Integer;
    FreqScreen, FreqFFT : double;
    maxmod:integer;
    tmp                 : double;
    dL1,dR1             : double;
    L1,R1,kL,kR         : double;
    LastL1,LastR1       : double;

    //PL,PR               : PByteArray;
    //PLl,PRl             : PByteArray;
    xcos,ysin           : extended;
    xsin,ycos           : extended;
    x1,x2,y1,y2         : integer;
    x1o,x2o,y1o,y2o     : integer;
    v,x,y,z:integer;
    sl:PByteArray;
begin
    if bUpdating then exit;
    bUpdating:=true;

    CanvasToDraw.Pen.Color:=sonopal[0];
    if not Scrolling.Checked then
    begin
      Dec(scrollL);
      Dec(scrollR);
      if dblpxl.Checked then begin 
        Dec(scrollL); 
        Dec(scrollR); 
      end;
      //Inc(Lsh);
      //dXL:=mL-scrollL+1;
      // todo stereo no scroll right ch 

      //Inc(dX);
      //if dblpxl.Checked then Inc(dX);
      //if (dX >= ml) then dX:=0;
    end else begin
      //dxL:=ml; // Rsh;
      //dxR:=ml;
      if DrawMode.ItemIndex<4 then begin
        scrollL:=0;
        scrollR:=0;
      end else begin
        scrollL:=H;
        scrollR:=H;
      end;
    end;

    if scrolling.Checked then
    begin
        case DrawMode.ItemIndex of
          0 : begin // horizontal split up/down scrolling
                 BitBlt(CanvasToDraw.Handle,          0,       0, w, mL-Lsh, // scroll up
                        CanvasToDraw.Handle,          0,     Lsh, SRCCOPY);
                 if not mono.Checked then
                 BitBlt(CanvasToDraw.Handle,          0,mR+Lsh+1, W, mR-Lsh+1, // scroll down
                        CanvasToDraw.Handle,          0,mR+1    , SRCCOPY);
                 CanvasToDraw.Rectangle(0, mL-Lsh+1, w, mR+Lsh-Rsh+1);
                 if (scrollL < 0) or (scrollL>=mL) or (scrollR < 0) or (scrollR>=mR) then begin
                     scrollL:=mL;
                     scrollR:=mR;
                 end;
              end;
          1   : begin // vertical split right/left scrolling
                 //BitBlt(CanvasToDraw.Handle,          1,        0, mL-Lsh-1, H, // scroll left
                 //       CanvasToDraw.Handle,      Lsh+1,        0, SRCCOPY);
                 BitBlt(CanvasToDraw.Handle,          0,          0, mL-Lsh, H, // scroll left
                        CanvasToDraw.Handle,        Lsh,          0, SRCCOPY);
                 if not mono.Checked then
                 BitBlt(CanvasToDraw.Handle, mR+Lsh-Rsh,          0, mR-Lsh+Rsh+2  , H, // scroll right
                        CanvasToDraw.Handle,     mR-Rsh,          0, SRCCOPY);
                 CanvasToDraw.Rectangle(mL-Lsh,0, mR+Lsh+1, h);
                 if (scrollL < 0) or (scrollL>=mL) or (scrollR < 0) or (scrollR>=mR) then begin
                     scrollL:=mL;
                     scrollR:=mR;
                 end;
              end;
          2 : begin // right to left
                 BitBlt(CanvasToDraw.Handle,          0,          0, W, H,      // scroll left
                        CanvasToDraw.Handle,        Lsh,          0, SRCCOPY);
                 if (mR+scrollR >= W) and not Scrolling.Checked then begin
                    //scroll  := true;
                    scrollR := 0; //mR;
                 end else if (mL > W) then scrollL:=1;
                 if Rsh=0 then CanvasToDraw.Rectangle(0, mL, w, mR);
                 CanvasToDraw.Rectangle(0, mL-Lsh+1, w, mR+Lsh-Rsh+1);
              end;
          3 : begin // left to right
                 BitBlt(CanvasToDraw.Handle,        Lsh,          0, W, H,      // scroll left
                        CanvasToDraw.Handle,          0,          0, SRCCOPY);
                 if (mL-scrollL <= 0) and not Scrolling.Checked then begin
                    //scroll  := true;
                    scrollL := 0;
                 end else if (mL-scrollL <= 0) then scrollL:=0;
                 if Rsh=0 then CanvasToDraw.Rectangle(0, mL, w, mR);
                 CanvasToDraw.Rectangle(0, mL-Lsh+1, w, mR+Lsh-Rsh+1);
              end;
          4 : begin // up
                 BitBlt(CanvasToDraw.Handle,          0,          0, W, H+1,    // scroll up
                        CanvasToDraw.Handle,          0,        Lsh, SRCCOPY);
                 CanvasToDraw.Rectangle(mL, 0, mL+1, h);
              end;
          5 : begin // down
                 BitBlt(CanvasToDraw.Handle,          0,        Lsh, W, H,    // scroll down
                        CanvasToDraw.Handle,          0,          0, SRCCOPY);
                 CanvasToDraw.Rectangle(mL, 0, mL+1, h);
              end;
        end; // case
    end else begin
        case DrawMode.ItemIndex of
          0,1 : begin // horizontal split up/down scrolling & vertical split right/left scrolling
                 if DrawMode.ItemIndex=0 then
                 CanvasToDraw.Rectangle(0, mL-Lsh, w, mR+Lsh-Rsh);
                 if (scrollL < 0) or (scrollL>=mL) or (scrollR < 0) or (scrollR>=mR) then begin
                     scrollL:=mL;
                     scrollR:=mR;
                 end;
              end;
          2,3 : begin // right to left & left to right
                 if (scrollL < 0) or (scrollL>=W) or (scrollR < 0) or (scrollR>=W) then begin
                     scrollL:=w;
                     scrollR:=w;
                 end;
                 if Rsh=0 then CanvasToDraw.Rectangle(0, mL, w, mR);
              end;
          4,5 : begin // up & down
                 if (scrollL < 0) or (scrollL>=h) or (scrollR < 0) or (scrollR>=h) then begin
                     scrollL:=h;
                     scrollR:=h;
                 end;
              end;
        end; // case
    end;


    if DrawMode.ItemIndex=7 then
         CanvasToDraw.Rectangle(0, 0, w, h);

    // clear left side for freq-peaks
    if VolLevel.Checked and Mono.Checked then begin
    CanvasToDraw.pen.Style  :=psSolid;
    CanvasToDraw.pen.Color  :=sonopal[0];
    CanvasToDraw.brush.Style:=bsSolid;
    CanvasToDraw.brush.Color:=sonopal[0];
    CanvasToDraw.Rectangle(w-offset, 0, w, h);
    end;

    x1o:=wHalf;
    x2o:=wHalf;
    y1o:=hHalf;
    y2o:=hHalf;
    avgLl:=0;
    avgRl:=0;
    avgL:=0;
    avgR:=0;
    L1:=0; R1:=0;
    LastL1:=0; LastR1:=0;
    LevelLf:=0;
    LevelRf:=0;
    PixelMaxX  := 0;
    PixelPos   := 0;
    FFTPos     := FFTStart; //freq2LogPos(); //0; // 1 'cause 0 is the DC component (sample mean at this very moment)
    maxmod:=2;
    maxmod:=TrackBar1.Position;
    //maxmod:=ScaleMin.Value;
    //if (FreqLogFakt>1) then maxmod:=2;

    if drawmode.ItemIndex=6 then
    begin
        // circle mode
        //winkelmass:=0.1;
        winkel:=winkel+winkelmass;
        if winkel>=360 then begin
          winkel:=0;
        end;
        SinCos(DegToRad(winkel),ysin,xcos);
        ysin:=abs(ysin);
        xcos:=abs(xcos);
        //varinfo(40,'w: ' +inttostr(trunc(winkel)));
        //varinfo(20,'x : ' +FloatToStr(xcos));
        //varinfo( 0,'y : ' +FloatToStr(ysin));
        // delete marker
        CanvasToDraw.pen.Color:=sonopal[0];
        CanvasToDraw.MoveTo(lx1,ly1);
        CanvasToDraw.LineTo(lx2,ly2);
        //CanvasToDraw.pixels[lx2,ly2]:=sonopal[0];
        if          (winkel>=  0) and (winkel< 90) then begin
            x1:=trunc(wHalf+xcos*(PixelMax+7));
            y1:=trunc(hHalf-Ysin*(PixelMax+7));
            x2:=trunc(wHalf+xcos*(PixelMax+3));
            y2:=trunc(hHalf-Ysin*(PixelMax+3));
        end else if (winkel>= 90) and (winkel<180) then begin
            x1:=trunc(wHalf-xcos*(PixelMax+7));
            y1:=trunc(hHalf-Ysin*(PixelMax+7));
            x2:=trunc(wHalf-xcos*(PixelMax+3));
            y2:=trunc(hHalf-Ysin*(PixelMax+3));
        end else if (winkel>=180) and (winkel<270) then begin
            x1:=trunc(wHalf-xcos*(PixelMax+7));
            y1:=trunc(hHalf+Ysin*(PixelMax+7));
            x2:=trunc(wHalf-xcos*(PixelMax+3));
            y2:=trunc(hHalf+Ysin*(PixelMax+3));
        end else begin //if (winkel>=270) and (winkel<360) then begin
            x1:=trunc(wHalf+xcos*(PixelMax+7));
            y1:=trunc(hHalf+Ysin*(PixelMax+7));
            x2:=trunc(wHalf+xcos*(PixelMax+3));
            y2:=trunc(hHalf+Ysin*(PixelMax+3));
        end;
        // draw marker
        CanvasToDraw.Pen.Color:=sonopal[SplitLineColorIdx];
        CanvasToDraw.MoveTo(x1,y1);
        CanvasToDraw.LineTo(x2,y2);
        //CanvasToDraw.pixels[x2,y2]:=sonopal[255];
        lx1:=x1;
        ly1:=y1;
        lx2:=x2;
        ly2:=y2;
    end else if drawmode.ItemIndex=7 then begin
        x1:=wHalf-2;
        x2:=wHalf+2;
        y1:=hHalf-hQuart;
        y2:=hHalf-hQuart;
    end;
    sl:=VisBuff.ScanLine[0];
    y:=0;
    
    while (PixelPos<PixelMax+maxmod) and (FFTPos<=FFTSize) do // *2 for stereo FFT
    begin
        // get current frequency at current PixelPos
        FreqScreen:=FreqArray[PixelPos];

        // add up data until next frequency or end of fftdata
        repeat
            if Trunc(Sqrt(FloatData[FFTPos  ]) * 255) > Sensitivity/10 then
              Inc(LevelLf);
            if Trunc(Sqrt(FloatData[FFTPos+1]) * 255) > Sensitivity/10 then
              Inc(LevelRf);

            if (mono.Checked) or (drawmode.ItemIndex=6) then begin
              // mono or circle mode
              L1:=(FloatData[FFTPos  ]+FloatData[FFTPos+1])/2;
              R1:=L1;
            end else begin
              L1:=FloatData[FFTPos  ];
              R1:=FloatData[FFTPos+1];
              if rms.Checked then begin
              dL1:=abs(L1-R1);
              dR1:=abs(R1-L1);
              L1:=dL1;
              R1:=dR1;
              end;
            
            end;

            if rms.Checked and (pixelpos>0) then 
            begin
              //y = y + a(k) * Cos(k * t)
              //y = y + b(k) * Sin(k * t)

              //CurrL:=IntData[(FFTPos div 2)  ];
              //CurrR:=IntData[(FFTPos div 2)+1]; //IntData[(FFTPos div 2)+1]/256;

              //CurrL:=abs((WaveData[(FFTPos)    ] - WaveData[(FFTPos) +1])/256);
              //CurrR:=abs((WaveData[(FFTPos) + 1] - WaveData[(FFTPos)   ])/256);
              //CurrL:=CurrL+trunc(cot(pi/2*(WaveData[FFTPos  ])));
              //CurrR:=CurrR+trunc(sin(pi/2*(WaveData[FFTPos+1])));
              //phi := arctan( Pi/2 * (WaveData[FFTPos  ]*WaveData[FFTPos+1]) );
              //CurrL:=CurrL+( cos(phi) );
              //CurrR:=CurrR+( sin(phi) );
            end else begin
              //CurrL:=abs((CurrData[(FFTPos)    ] - CurrData[(FFTPos) +1]));
              //CurrR:=abs((CurrData[(FFTPos) + 1] - CurrData[(FFTPos)   ]));
            end;

            //L1:=(L1+CurrL)/2;
            //R1:=(R1+CurrR)/2;

            //FloatDataLast[FFTPos  ]:=FloatData[FFTPos  ];
            //FloatDataLast[FFTPos+1]:=FloatData[FFTPos+1];

            Inc(FFTPos,2);
            FreqFFT:=FFTPos*FreqRes;

        until (   FFTpos>=FFTSize ) or
              ( ((FFTPos) mod maxmod = 0) and (FreqFFT>=FreqScreen));

        if (SwapChannels.checked) and (not mono.Checked) then begin
            tmp:=L1;
            L1:=R1;
            R1:=tmp;
        end;

        if blur.Value<=0 then
        begin // until FreqFFT reaches FreqScreen
            while (PixelPos  < PixelMax+maxmod-2) and (FreqFFT>=FreqScreen) do
            begin
                // zeichne im kreis
                if drawmode.ItemIndex=6 then
                begin
                    // circle mode
                    if opt2.Checked then 
                    xfact:=PixelPos
                    else
                    xfact:=PixelMax-PixelPos;
                    if          (winkel>=  0) and (winkel< 90) then begin //q1
                      x2:=trunc(wHalf+xcos*xfact); 
                      y2:=trunc(hHalf-Ysin*xfact);
                    end else if (winkel>= 90) and (winkel<180) then begin //q4
                      x2:=trunc(wHalf-xcos*xfact);
                      y2:=trunc(hHalf-Ysin*xfact);
                    end else if (winkel>=180) and (winkel<270) then begin //q3
                      x2:=trunc(wHalf-xcos*xfact);
                      y2:=trunc(hHalf+Ysin*xfact);
                    end else begin //q2
                      x2:=trunc(wHalf+xcos*xfact);
                      y2:=trunc(hHalf+Ysin*xfact);
                    end;
                    //CanvasToDraw.pixels[x2,y2]:=clred;
                    CanvasToDraw.Pixels[x2,y2]:=sonopal[trunc(
                          //nteWurzel(L1,1+(contrast/255))*bright*2)];
                          LogPos2Ampl(nteWurzel(L1,1+(contrast/256)),1,256)*bright/256)];
                                 
                end else if drawmode.ItemIndex=7 then
                begin
                    // phase
                    //winkelmass:=0.1;
                    winkel:=(PixelPos/PixelMax*180)*PI/180;
                    SinCos(winkel,xsin,ycos);
                   
                    if opt2.Checked then 
                    xfact:=trunc((PixelMax-PixelPos)/PixelMax*(wHalf+wQuart))
                    else
                    xfact:=trunc((PixelPos         )/PixelMax*(wHalf+wQuart));

                    if opt2.Checked then begin
                    CanvasToDraw.Pen.Color:=sonopal[trunc(LogPos2Ampl(nteWurzel(L1,1+(contrast/256)),1,256)*bright/256)];
                    CanvasToDraw.MoveTo(x1,y1);
                    end;

                    yfact:=trunc(LogPos2Ampl(nteWurzel(L1,1+(contrast/h)),1,h)*bright/h);
                    x1:=trunc(wHalf-xsin*xfact)-2; 
                    y1:=trunc(h-ycos*yfact-hHalf-ycos*hQuart);

                    if opt2.Checked then begin
                    CanvasToDraw.LineTo(x1,y1);
                    CanvasToDraw.Pen.Color:=sonopal[trunc( LogPos2Ampl(nteWurzel(R1,1+(contrast/256)),1,256)*bright/256)];
                    CanvasToDraw.MoveTo(x2,y2);
                    end else begin
                    CanvasToDraw.Pixels[x1,y1]:=sonopal[trunc(LogPos2Ampl(nteWurzel(L1,1+(contrast/256)),1,256)*bright/256)];
                    end;

                    yfact:=trunc(LogPos2Ampl(nteWurzel(R1,1+(contrast/h)),1,h)*bright/h);
                    x2:=trunc(wHalf+xsin*xfact)+2;
                    y2:=trunc(h-ycos*yfact-hHalf-ycos*hQuart);

                    if opt2.Checked then begin
                    CanvasToDraw.LineTo(x2,y2);
                    end else begin
                    CanvasToDraw.Pixels[x2,y2]:=sonopal[trunc(LogPos2Ampl(nteWurzel(R1,1+(contrast/256)),1,256)*bright/256)];
                    end;

                        
                end else begin
                    // zeichne normal
                    DrawPoint(PixelPos,L1,R1);

                end;
                Inc(PixelPos);
                LastL1:=L1;
                LastR1:=R1;
                FreqScreen:=FreqArray[PixelPos];
            end;

        end else begin // end blur

            PixelPos2:=PixelPos; // count pixels to be interpolated
            while (PixelPos2 < PixelMax+maxmod-2) and (FreqFFT>=FreqScreen) do
            begin
                Inc(PixelPos2,1);
                FreqScreen:=FreqArray[PixelPos2];
            end;

            k:=PixelPos2-PixelPos+1;
            kL:=(L1-LastL1)/k; // may be negative
            kR:=(R1-LastR1)/k; // may be negative
            L1:=LastL1+kL;
            R1:=LastR1+kR;

            PixelPos2:=PixelPos2-(blur.Value-1); // accidentially found this to be good
            //PixelPos2:=PixelPos2-(blur.Value); // accidentially found this to be good
            if (PixelPos2>0) and (PixelPos2<PixelMax+maxmod-2) then
            begin // interpolate pixels
                for i:=PixelPos to PixelPos2-1 do
                begin
                    if DrawMode.ItemIndex=6 then
                    begin
                        // circle mode
                        if opt2.Checked then 
                        xfact:=PixelPos
                        else
                        xfact:=PixelMax-PixelPos;
                        if          (winkel>=  0) and (winkel< 90) then begin
                          x2:=trunc(wHalf+xcos*xfact);
                          y2:=trunc(hHalf-Ysin*xfact);
                        end else if (winkel>= 90) and (winkel<180) then begin
                          x2:=trunc(wHalf-xcos*xfact);
                          y2:=trunc(hHalf-Ysin*xfact);
                        end else if (winkel>=180) and (winkel<270) then begin
                          x2:=trunc(wHalf-xcos*xfact);
                          y2:=trunc(hHalf+Ysin*xfact);
                        end else begin //if (winkel>=270) and (winkel<360) then begin
                          x2:=trunc(wHalf+xcos*xfact);
                          y2:=trunc(hHalf+Ysin*xfact);
                        end;
                        //CanvasToDraw.pixels[x2,y2]:=clred;
                        CanvasToDraw.Pixels[x2,y2]:=sonopal[trunc(
                              //nteWurzel(L1,1+(contrast/255))*bright*2)];
                              LogPos2Ampl(nteWurzel(L1,1+(contrast/256)),1,256)*bright/256)];

                    end else if Drawmode.ItemIndex=7 then begin
                        // phase

                    end else begin
                        DrawPoint(PixelPos,L1,R1);

                    end;
                    
                    Inc(PixelPos);
                    L1:=L1+kL;
                    R1:=R1+kR;
                end;
            end;
            LastL1:=L1;
            LastR1:=R1;
            PixelPos:=PixelPos2;
            //if option1.Checked then begin
            //L1:=L1+kL;
            //R1:=R1+kR;
            //end;

        end; // not blur

    end; // while (PixelPos<PixelMax) do
    {}

    (**-)
    if (drawmode.ItemIndex=6) and (blur.Value>0) then
    begin
       // circle mode and blur
       //for i := 0 to FFTSize-1 do
         //FloatDataLast[i] := Data[i] * ln(i + 1) * (h)*2;

       CanvasToDraw.Pen.Width:=1;
       for i := 0 to FFTSize-1 do
       begin
         CanvasToDraw.pen.color := sonopal[IntData[i]]; //sonopal[trunc(FloatData[i] * ln(i + 1) *h*2)];
         CanvasToDraw.MoveTo(i, h-5                  );
         CanvasToDraw.LineTo(i, h-5-IntData[i]);
       end;
    end;
    (**)
    
    // if not reached the end of the FFT, do it now
    while (FFTPos<=FFTSize) do // *2 for stereo FFT
    begin
      //
      if Trunc(Sqrt(FloatData[FFTPos  ]) * 255) > Sensitivity/10 then Inc(LevelLf);
      if Trunc(Sqrt(FloatData[FFTPos+1]) * 255) > Sensitivity/10 then Inc(LevelRf);
      // fill in 3d array
      FField3d[0,FFTPos  ]:=FloatData[FFTPos  ];
      FField3d[0,FFTPos+1]:=FloatData[FFTPos+1];
      Inc(FFTPos,2);
    end; // while (FFTPos<FFTS) do

    PixelMaxX:=PixelPos-1;
    if PixelMaxX<PixelMax then PixelMaxX:=PixelMax;
    //showendpoints(x2,x2,x1,y1,clblue);
    //varinfo(40,'fft: ' +inttostr(FFTPos));
    //varinfo(20,'xX: ' +inttostr(PixelMaxX));
    //varinfo( 0,'x : ' +inttostr(PixelMax));

    if Splitline.Checked and ((not mono.Checked) OR VolLevel.Checked) then
    begin
      case DrawMode.ItemIndex of
      0   : // horizontal
          for i:=0 to w do if i mod 10 = 0 then CanvasToDraw.Pixels[i, mL]:=SonoPal[SplitLineColorIdx];
      1   : // vertical
          for i:=0 to h do if i mod 10 = 0 then CanvasToDraw.Pixels[mL, h-i]:=SonoPal[SplitLineColorIdx];
      2,3 : // rechts <-> links
          for i:=0 to w do if i mod 10 = 0 then CanvasToDraw.Pixels[w-i, mL]:=SonoPal[SplitLineColorIdx];
      4   : // up
          for i:=0 to h do if i mod 10 = 0 then CanvasToDraw.Pixels[mL, i]:=SonoPal[SplitLineColorIdx];
      5   : // down
          for i:=0 to h do if i mod 10 = 0 then CanvasToDraw.Pixels[mL, i]:=SonoPal[SplitLineColorIdx];
      end;//case
    end else if Splitline.Checked then begin
      case DrawMode.ItemIndex of
      1   : // horizontal
          for i:=0 to h do if i mod 10 = 0 then CanvasToDraw.Pixels[mL, h-i]:=SonoPal[SplitLineColorIdx];
      end;
    end;
    bUpdating:=false;
end; // procedure DRAW

////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////

procedure TFormPlayer.Button24Click(Sender: TObject);
begin
  // auto scale
  if formplayer.BorderStyle=bsNone then
  begin

  end else begin
    if screen.Height > fftsize div 4 then     //border
    begin
      SetBounds(left,top,width,fftsize div 4 + (Height-ClientHeight));
      if top>screen.Height-Height then top:=screen.Height-Height;
    end;
  end;
  FMax.Position := trunc( (((PixelMax)* 4) * FreqRes) / FreqRate * 100 );
  FMin.Position := trunc( FreqRes / FreqRate * 100 );
  setVars;
end;

procedure TFormPlayer.AmplitueScaleLogChange(Sender: TObject);
begin
  setVars;  
end;

procedure TFormPlayer.btnSelectDirClick(Sender: TObject);
begin
  SelectDirectory('Output Directory', '', savePath);
  if RightStr(savepath,1)<>'\' then
    savepath:=savepath+'\';
  tbSavePath.Text:=savepath;
end;

procedure TFormPlayer.btnSelectLameClick(Sender: TObject);
begin
  OpenDialog.Title := 'Browse for LAME.EXE';
  OpenDialog.Filter := '*.exe';
  OpenDialog.FileName := 'lame.exe';
  OpenDialog.InitialDir := ExtractFileDir(LamePath);
  if OpenDialog.Execute then begin
      LamePath := OpenDialog.FileName;
      tbLamePath.Text:=LamePath;
  end;
end;

procedure TFormPlayer.SetS(nW, nH: integer; doresize:boolean=true);
var i      : integer;
    oW, oH : integer;
begin
    //if bUpdating then exit;
    VisBuff.PixelFormat:=pf8bit;
    VisBlack.PixelFormat:=pf8bit;
    Image1.Picture.Bitmap.PixelFormat:=pf8bit;
    image1.Picture.Bitmap.Width:=Image1.Width;
    image1.Picture.Bitmap.Height:=Image1.Height;

    CanvasToDraw.Pen.Color   :=sonopal[0];
    CanvasToDraw.Brush.Color :=sonopal[0];
    CanvasToDraw.brush.style :=bssolid;

    oW:=Visbuff.Width;
    oH:=Visbuff.Height;
    W:=nW;
    H:=nH;
    Visbuff.Width  := W;
    Visbuff.Height := H;
    VisBlack.Width  := W;
    VisBlack.Height := H;
    wHalf:=Width  div 2;
    hHalf:=Height div 2;
    wQuart:=Width  div 4;
    hQuart:=Height  div 4;

    if (nH=oH) then begin
      //CanvasToDraw.Rectangle((w div 2)-2, 0, (w div 2)+3, H);
      if (W<oW) and scrolling.Checked then begin
        //BitBlt(CanvasToDraw.Handle, 0, 0, W, H,     // scroll to left
        //       CanvasToDraw.Handle, oW-1, 0, SRCCOPY);
        scrollL:=mL-1;
        //dXL:=W-1;
        //if dXL<=-1 then dXL:=0;
        //scrolling.Checked:=true;
      end else if (W>=oW) and Scrolling.Checked then begin
        //BitBlt(CanvasToDraw.Handle, 0, 0, W, H,     // scroll to left
        //       CanvasToDraw.Handle, W, 0, SRCCOPY);
        scrollL:=mL-1;
        //dXL:=dXL+W-Visbuff.Width-1;
        //scroll:=false;
      end;
      if (W<oW) and not scrolling.Checked then begin
        //dXL:=W-1;
        scrollL:=mL-1;
      end else if (W>=oW) and not scrolling.Checked then begin
        //BitBlt(CanvasToDraw.Handle, 0, 0, W, H,     // scroll to left
        //       CanvasToDraw.Handle, W, 0, SRCCOPY);
        nW:=W div 2;
        nH:=H div 2;
        //BitBlt(Canvas.Handle, 0, 0, W, H, CanvasToDraw.Handle, 0, 0, SRCCOPY);

        //BitBlt(CanvasToDraw.Handle,  W-oW-trunc(oW/2.5),H-oH,    nW,        nH,           //Dest 65
        //       CanvasToDraw.Handle,  0,0,    SRCCOPY); //Src //dX, H-(H-oH),
        //BitBlt(Canvas.Handle, 0, 0, W, H, CanvasToDraw.Handle, 0, 0, SRCCOPY);
        scrollL:=mL-1;
        //dXL:=W-1;
      end;
    end else begin
      // clear all
      CanvasToDraw.Rectangle(0,0,w,h);
      {
      if H<oH then begin
        // scale down
        i:=dXL-W;
        if i<0 then i:=dXL-1;
        if doresize then
        //StretchBlt(CanvasToDraw.Handle,     0,   0,    dX,  H,           //Dest
        //           CanvasToDraw.Handle,     i,   0,    dX, H+(oH-H), SRCCOPY); //Src
        if dXL>W then dXL:=W-2;                 //X   Y      Wid    Hei
        if (oW>0) and (dXL>=W-2) then begin dXL:=W-1; end;
      end else begin
        // scale up
        if doresize then begin
        //StretchBlt(CanvasToDraw.Handle,     0,0,    dX,        H,           //Dest 65
        //           CanvasToDraw.Handle,     0,0,    dX, H-(H-oH), SRCCOPY); //Src
        //for i:=0 to dX do CanvasToDraw.Pixels[i, Trunc(H/2)+1]:= CanvasToDraw.Pixels[i, Trunc(H/2)+2];
        //for i:=0 to dX do CanvasToDraw.Pixels[i, Trunc(H/2)-1]:= CanvasToDraw.Pixels[i, Trunc(H/2)-2];
        end else begin
        nW:=W div 2;
        nH:=H div 2;
        //BitBlt(CanvasToDraw.Handle,  (W)-(W div 2),(H)-(H-oH),    nW,        nH, //Dest 65
        //       CanvasToDraw.Handle,  0,0,    SRCCOPY); //Src //dX, H-(H-oH),
        (*
        BitBlt(CanvasToDraw.Handle,     0,0,    dX,        H,           //Dest 65
               CanvasToDraw.Handle,     0,0,    SRCCOPY); //Src //dX, H-(H-oH),
        BitBlt(CanvasToDraw.Handle,     0,0,    dX,        H,           //Dest 65
               CanvasToDraw.Handle,     0,0,    SRCCOPY); //Src //dX, H-(H-oH),
        *)
        end;
      end;
      }
    end;
    SetBkMode(CanvasToDraw.Handle, TRANSPARENT);
    SetBkMode(canvas.Handle, TRANSPARENT);
    canvas.Font.Color:=SonoPal[SplitLineColorIdx];
    Canvas.Font.Name:='Small Fonts';
    Canvas.Font.Style:=[fsBold];
    Canvas.Font.Size:=7;
    CanvasToDraw.Pen.Color := sonopal[0];
    CanvasToDraw.Brush.Color := sonopal[0];
    CanvasToDraw.brush.style:=bssolid;
    VisBlack.Canvas.Pen.Color := sonopal[0];
    VisBlack.Canvas.Brush.Color := sonopal[0];
    VisBlack.Canvas.Rectangle(0,0,w,h);
end;

procedure TFormPlayer.setSettings;
begin
    if not FormPlayer.Visible then exit;
    if bUpdating then exit;
    if doingsettings then exit;
    doingsettings:=true;

    (**)
    if RadioGroup1.ItemIndex=1 then begin
      //glViewport(0, 0, FormPlayer.ClientWidth, FormPlayer.ClientHeight); // Set the viewport for the OpenGL window
      //glMatrixMode(GL_PROJECTION); // Change Matrix Mode to Projection
      //glLoadIdentity(); // Reset View
      //gluPerspective(45.0, FormPlayer.ClientWidth / FormPlayer.ClientHeight, 1.0, 500.0); // Do the perspective calculations. Last value = max clipping depth
      //glMatrixMode(GL_MODELVIEW); // Return to the modelview matrix

      glViewport(0, 0, ClientWidth, ClientHeight);
      glMatrixMode(GL_PROJECTION);
      glLoadIdentity();
      (*
      if (Width <= Height) then
          glOrtho(-5.0, 5.0, -5.0*Height/Width,5.0*Height/Width, -5.0, 5.0)
      else
          glOrtho(-5.0*Width/Height, 5.0*Width/Height, -5.0, 5.0, -5.0, 5.0);
      *)
      glMatrixMode(GL_MODELVIEW);
      glLoadIdentity();

    end else begin
      SetS(ClientWidth, ClientHeight,true);
    end;
    (**)
    SetVars;
    MakePaletteGDI;
    doingsettings:=false;
end;

procedure TFormPlayer.setVars;
var i:integer;
    s:string;
begin
    if bUpdating then exit;
    if fFFTSize.Text='' then exit;

    //Visbuff.Width  := ClientWidth;
    //Visbuff.Height := ClientHeight;
    pixelwidth:=vumeterwidth.Value+1;
    pl1:=pixelwidth;//   + (pixelwidth div 2);
    pl2:=pixelwidth*2;// - ((pixelwidth div 2)-1);
    pl3:=pixelwidth*3;// - ((pixelwidth div 2)-1);
    ph:=(pixelwidth div 2);

    if      fFFTSize.ItemIndex=0 then
      dataflag:=BASS_DATA_FFT256
    else if fFFTSize.ItemIndex=1 then
      dataflag:=BASS_DATA_FFT512
    else if fFFTSize.ItemIndex=2 then
      dataflag:=BASS_DATA_FFT1024
    else if fFFTSize.ItemIndex=3 then
      dataflag:=BASS_DATA_FFT2048
    else if fFFTSize.ItemIndex=4 then
      dataflag:=BASS_DATA_FFT4096
    else
      dataflag:=BASS_DATA_FFT8192;

    if not VolLevel.Checked then begin
      offset     :=0;
      offsetstart:=0;
      offsetend  :=0;
    end else begin
      offset:=vumeterwidth.Value*10;
      offsetstart:=trunc(offset*0.1); //(offset div 4);
      offsetend  :=trunc((offset-offsetstart)*1.3); //((offset div 4)*3);
    end;

    case DrawMode.ItemIndex of
      0 : begin // horizontal split up/down scrolling
             mL := H;
             if not mono.Checked then
             mL := H div 2;
             PixelMax:=w;
             //scrollL := mL;
          end;
      1 : begin // vertical split right/left scrolling
             mL := W - offset;
             if not mono.Checked then
             mL := W div 2;
             PixelMax:=h;
             //scrollL := mL;
          end;
      2,3:begin // right to left + left to right
             mL := H;
             if not mono.Checked then
             mL := H div 2;
             PixelMax:=mL;
             //scrollL := w;
          end;
      4,5:begin // up + down
             mL := W;
             if not mono.Checked then
             mL := W div 2;
             PixelMax:=mL;
             //scrollL := H;
          end;
      6:  begin
             PixelMax:=min((height div 2) - 25,(width div 2) - 25);
          end;
      7:  begin
             PixelMax:=height;
          end;
    end; // case

    //scrollL         := mL-offset;
    //scrollR         := scrollL+1;
    scrollR := scrollL;

    Lsh:=1;
    Rsh:=0;
    if dblpxl.Checked then Lsh:=2;
    mR := mL;
    if (not (Splitline.Checked)) then begin
      mR:=mR-1;
      Rsh:=1;
    end;

    //if dXL<=-1 then dXL:=0;
    //if dXL>Visbuff.Width then dXL:=-1;
    //if Scrolling.Checked then dXL:=w-offsetstart;

    if Splitline.Checked then
    scrollR         := scrollL+2;
    if Scrolling.Checked then scrollL:=ml;

    silDuration     := silenceDuration.Value*1000;
    Sensitivity     := SpinSens.Value;
    SensitivityF    := SpinSono.Value;

    FFTsize         := StrToIntDef(fFFTSize.Text,4096);
    FFTbins         := FFTSize div 4;
    FFTpromille     := trunc(Max(1,FFTbins*0.1));
    FreqRate        := SampleRate div 2;
    FreqRes         := FreqRate / FFTSize; // / 2; // width of Freq band per bin
    FreqMax         := ((FMax.Position)/100*FreqRate);
    FreqMin         := ((FMin.Position)/100*FreqRate);
    if FreqMin=0 then FreqMin:=FreqRes;
    //FillTime        := FFTSize / SampleRate;     // 1/FreqRes = TimeScroll
    //FreqSpan        := FreqRes * h;
    //Frequency range / Bins numbers
    if ScaleC.Position=1 then
    AmplLogFakt          := 1
    else
    AmplLogFakt          := 1+ScaleC.Position/256;
    AmplLogFaktDiv       := sqrt(6); //2.44948;

    AmplLogFakt          := 0.25+((256-ScaleC.Position)/256);
    AmplLogFaktDiv       := 1.25; //sqrt(2); //2.44948;

    if FreqScaleLog.Position=1 then
    FreqLogFakt          := 1
    else
    FreqLogFakt          := 1+FreqScaleLog.Position/256;
    FreqLogFaktDiv       := sqrt(6); //2.44948;
    //FreqLogFaktDiv       := sqrt(5); //2.23606;
    //FreqLogFaktDiv       := sqrt(4); //2.00000;

    szline    := sizeof(GLfloat)*FFTSize;
    szoverall := szline * MAXLINES;

    minxL := FFTSize;
    minxR := FFTSize;

    bright   :=ScaleB.Position;
    contrast :=ScaleC.Position;
    fExponent:=256/power(bright,contrast);

    FillChar(FreqArray     ,MAXFFTSIZE,0);
    FillChar(AmplitudeArray,256,0);
    FillChar(NoteStrings   ,MAXFFTSIZE,0);
    FillChar(NoteStrings2  ,MAXFFTSIZE,0);
    FillChar(FField3d,sizeof(GLfloat)*MAXFFTSIZE*MAXLINES,0);

    // fill arrays with log-scaled values
    for i:=0 to PixelMax*2-1 do FreqArray     [i]:=LogPos2Freq(i/PixelMax, FreqMin, FreqMax);
    //for i:=0 to 256          do AmplitudeArray[i]:=LogPos2Ampl(i/255, 1, 256);
    for i:=0 to PixelMax  -1 do NoteStrings   [i]:=freq_to_note(FreqArray[i]);
    for i:=0 to PixelMax  -1 do NoteStrings2  [i]:=freq_to_note2(FreqArray[i]);

    FFTStart := 0;
    while FreqMin>FreqArray[FFTStart] do
      Inc(FFTStart,2);

    label14.Caption:=inttostr(trunc(FreqMin-FreqRes))+' Hz';
    label17.Caption:=inttostr(trunc(FreqMax))+' Hz';
    lbScaling.Caption:='zoom: '+ FloatToStrF(
        ((FreqRate)/(FreqMax-(FreqMin)))* // -FreqRes
        (PixelMax/(FFTSize div 4))*100,
        ffNumber,12,1)+'%';

    (**) // log-curves
    Image2.Canvas.Brush.Color:=clBtnFace;
    Image2.Canvas.Rectangle(0,0,Image2.Width,Image2.Height);
    for i:=0 to PixelMax*2-1 do Image2.Canvas.Pixels[
      trunc(i/PixelMax*(Image2.Width-2))+1,
      trunc(FreqArray[i]/FreqMax*Image2.Height)+1]:=clGreen;
    for i:=0 to 256 do Image2.Canvas.Pixels[
      trunc(i/256*(Image2.width-1))+1,
      Image2.Height-
      trunc(LogPos2Ampl(nteWurzel(i/256,1+((contrast/256*(Image2.Height))/255)),1,256)*(bright/256*(Image2.Height))/256)]:=clMaroon;
    Image2.Refresh;
    (**)
end;

function LogValue(x, minx, maxx: double):double;
begin
  result:=( minx * power( FreqLogFakt, x * (ln(maxx) - ln(minx)) / ln(FreqLogFaktDiv)   ) - minx) /
          ( minx * power( FreqLogFakt,     (ln(maxx) - ln(minx)) / ln(FreqLogFaktDiv)   ) - minx)   ;
end;

function LogValue2(x, minx, maxx: double):double;
begin
  result:=( minx * power( FreqLogFakt, x * (ln(maxx) - ln(minx)) / ln(FreqLogFaktDiv)   ) - minx) /
          ( minx * power( FreqLogFakt,     (ln(maxx) - ln(minx)) / ln(FreqLogFaktDiv)   ) - minx)   ;
end;

function LogPos2Ampl(x, minx, maxx: double):double;
begin // logarithmic position (band number/band count) to a frequency
if (AmplLogFakt=1) then
  result:= x*(maxx-minx) + minx
else
  result:=(maxx-minx)*
          ( minx * power( AmplLogFakt, x * (ln(maxx) - ln(minx)) / ln(AmplLogFaktDiv)   ) - minx) /
          ( minx * power( AmplLogFakt,     (ln(maxx) - ln(minx)) / ln(AmplLogFaktDiv)   ) - minx)   + minx;
end;

function LogPos2Freq(x, minx, maxx: double):double;
begin // logarithmic position (band number/band count) to a frequency
if (FreqLogFakt=1) then
  result:= x*(maxx-minx) + minx
else
  result:=(maxx-minx)*
          ( minx * power( FreqLogFakt, x * (ln(maxx) - ln(minx)) / ln(FreqLogFaktDiv)   ) - minx) /
          ( minx * power( FreqLogFakt,     (ln(maxx) - ln(minx)) / ln(FreqLogFaktDiv)   ) - minx)   + minx;
end;

function Freq2LogPos(x, minx, maxx: double):double;
begin // frequency to logarithmic position (band number/band count)
if (FreqLogFakt=1) then
  result:= (x - minx)/(maxx-minx)
else
  result:= ln(((x-minx) * (minx * power(FreqLogFakt, (ln(maxx) - ln(minx))/
           ln(FreqLogFaktDiv)) - minx) / (maxx-minx) + minx) /
           ln(FreqLogFakt)) * ln(FreqLogFaktDiv) / (ln(maxx) - ln(minx));
end;

Function nteWurzel(x: Double; n: Double): double;
begin
   If x < 0 Then begin
      result:=0
   end Else begin
      If n = 0 Then
         result:=0
      Else
         result:=power(x, 1 / n);
   end;
End;

procedure TFormPlayer.cbMuteClick(Sender: TObject);
begin
  if bUpdating then exit;
  Application.ProcessMessages;
  if cbMute.Checked then 
    BASS_RecordSetInput(-1, BASS_INPUT_OFF, -1)
  else
    BASS_RecordSetInput(-1, BASS_INPUT_ON, -1);
end;

end.

